;		     FINAL FANTASY X 4
;			   for the TI-86
;
; By Alex Highsmith
; TI-86 Version By Andreas Finne
;

#include "ti86asm.inc"
#include "ffx4lib.inc"	;Symbol table

#DEFINE CALL_Z(ADDR)    call z,ADDR
#DEFINE CALL_(ADDR)     call ADDR
#DEFINE CALL_NZ(ADDR)   call nz,ADDR
#DEFINE CALL_C(ADDR)    call c,ADDR
#DEFINE CALL_NC(ADDR)   call nc,ADDR
#DEFINE JUMP_Z(ADDR)    jp z,ADDR
#DEFINE JUMP_(ADDR)     jp ADDR
#DEFINE JUMP_NZ(ADDR)   jp nz,ADDR
#DEFINE JUMP_C(ADDR)    jp c,ADDR
#DEFINE JUMP_NC(ADDR)   jp nc,ADDR



TEXT_MEM = _plotSScreen
TEXT_MEM2 = _plotSScreen+200


Save = TEXT_MEM2 	
LEFT = TEXT_MEM2+2 	;\
RIGHT = TEXT_MEM2+3	;| Checks walls to see if spaces
UP1 = TEXT_MEM2+4	;| exist or not
DOWN = TEXT_MEM2+5	;/
COUNTER =TEXT_MEM2+6
WHOATTACK = TEXT_MEM2+7
COUNTER2 = TEXT_MEM2+8

BKX = TEXT_MEM+5	;\   Coordinates for (drawit),
BKY = TEXT_MEM+6	;/   a simple sprite displayer
BKX1 = TEXT_MEM+7
BKY1 = TEXT_MEM+8
OKAY1 = TEXT_MEM+10
OKAY2 = TEXT_MEM+11
NUMBEROFENEMIES = TEXT_MEM+19
ENEMYKILLED = TEXT_MEM+20
ECOUNTER = TEXT_MEM+22
ENEMYCOUNTER = TEXT_MEM+24
ENEMYSPEED = TEXT_MEM+26
ENEMY1STR = TEXT_MEM+27
ENEMY2STR = TEXT_MEM+28
ENEMY1 = TEXT_MEM+29
ENEMY2 = TEXT_MEM+31
WHICHENEMY = TEXT_MEM+32
DISPENEMY = TEXT_MEM+33
STRENGTHPOINTER = TEXT_MEM+35
ENEMYKILLED2 = TEXT_MEM+37
HITBYWHO = TEXT_MEM+39
HIT = TEXT_MEM+41
ENEMY32 = TEXT_MEM+48
MAGIPAGE = TEXT_MEM+56
MAGICHK = TEXT_MEM+58 
DEFENDONI = TEXT_MEM+60
DEFENDOND = TEXT_MEM+61
ENEMYHP = TEXT_MEM+62
ENEMYHP2 = TEXT_MEM+64
LIFEPOINTER = TEXT_MEM+66
LEADERORNO = TEXT_MEM+68

XPCHECK = TEXT_MEM2+45
XPPOINTER = TEXT_MEM2+47
ENEMY1XP = TEXT_MEM2+49
ENEMY2XP = TEXT_MEM2+51
CHKDFD = TEXT_MEM2+53
WHOTOATTACK = TEXT_MEM2+55

ROOM = TEXT_MEM2+61	;<-- Tells what room you are in
DOTY = TEXT_MEM2+63	  
DOTX = TEXT_MEM2+64	  
HPDMAX = TEXT_MEM2+66
GOLD = TEXT_MEM2+68
MEDKITS = TEXT_MEM2+70
MAGIKITS = TEXT_MEM2+72
MPIMAX = TEXT_MEM2+74
MPDMAX = TEXT_MEM2+76
DEFENDD = TEXT_MEM2+78
DEFENDI = TEXT_MEM2+80
SCENARIO = TEXT_MEM2+82
DUNGEON = TEXT_MEM2+84
CHEST1 = TEXT_MEM2+85
CHEST2 = TEXT_MEM2+86
CHEST3 = TEXT_MEM2+87
CHEST4 = TEXT_MEM2+88
ISISLVL = TEXT_MEM2+89
DARQLVL = TEXT_MEM2+91
DARQMP = TEXT_MEM2+93
STRENGTHI = TEXT_MEM2+95
STRENGTHD = TEXT_MEM2+97
HPI = TEXT_MEM2+99
HPD = TEXT_MEM2+101
DARQXP = TEXT_MEM2+103
ISISXP = TEXT_MEM2+105
HPIMAX = TEXT_MEM2+107
ISISMP = TEXT_MEM2+109
;; in general, D=Darq and I=Isis

.org _asm_exec_ram

 nop
 jp      prog_start
 .dw     $0000
 .dw     Description

prog_start:
	call _flushallmenus
	call _runindicoff
	set graphdraw,(iy+graphflags)
	ld hl,DataName-1
	rst 20h
	rst 10h
	jp c,_jforcecmdnochar
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_src_addr
	ld a,1
	ld hl,$0100
	call _set_abs_dest_addr
	xor a
	ld hl,$2E40
	call _set_mm_num_bytes
	call _mm_ldir
	call _ram_page_1


	CALL ERASESCREEN
	ld bc,$0724
	ld hl,TITLE1
	CALL drawit2
	ld bc,$072C
	ld hl,TITLE2
	CALL drawit2
	ld bc,$0734
	ld hl,TITLE3
	CALL drawit2
    ld hl,14*256+36
	ld (_penCol),hl
	ld hl,credits
   	CALL _vputs
	ld bc,20*256+19
	ld (_penCol),bc
	call _vputs
	ld hl,0
	ld (ISISXP),hl
	ld (DARQXP),hl
	ld (GOLD),hl
	ld (ENEMY1XP),hl
	ld (ENEMY2XP),hl
	jr STARTUP	
LOOPLOAD:
	call _getky
	cp K_UP
	jr z,STARTUP
 	cp K_DOWN
	jr z,STARTDOWN
	cp K_SECOND
	jr z,STARTGAME1
	jr LOOPLOAD
STARTUP:
	ld hl,$0804
	ld (_curRow),hl
	ld hl,new
	set textInverse,(iy+textflags)	;3,(IY+05)
	call _puts
	ld hl,$0805
	ld (_curRow),hl
	ld hl,sload
	res textInverse,(iy+textflags)	;res 3,(IY+05)
	call _puts
	xor a
	ld (DOTX),a
	jr LOOPLOAD
STARTDOWN:
	ld hl,$0804
 	ld (_curRow),hl
	ld hl,new
	res textInverse,(iy+textflags)	;3,(IY+05)
	call _puts
	ld hl,$0805
	ld (_curRow),hl
	ld hl,sload
	set textInverse,(iy+textflags)	;3,(IY+05)
	call _puts

	ld a,1
	ld (DOTX),a
	jr LOOPLOAD
STARTGAME1:
	ld a,(DOTX)
	cp 1
	jp z,LOADGAME
;---------------
; start of game
;---------------
			
STARTGAME:
	ld a,4
	ld (DOTY),a
	ld (DOTX),a
	ld a,3	
	ld (MEDKITS),a
	ld (MAGIKITS),a
	ld (DEFENDD),a
	ld (DEFENDI),a
	ld a,8
	ld (STRENGTHI),a	
	ld a,12
	ld (STRENGTHD),a
	ld a,30
	ld (HPIMAX),a
	ld (HPI),a
	ld a,40
	ld (HPDMAX),a
	ld (HPD),a
	ld a,1
	ld (ROOM),a
	ld (DARQLVL),a
	ld (ISISLVL),a
	ld a,25
	ld (DARQMP),a
	ld (ISISMP),a
	ld (MPIMAX),a
	ld (MPDMAX),a

	xor a
	ld (SCENARIO),a
	ld (DUNGEON),a
	ld (COUNTER),a
	ld (CHEST1),a	
	ld (CHEST2),a	
	ld (CHEST3),a	
	ld (CHEST4),a	
	
	CALL_(DRAWWALLS)
	CALL_(BORDERUP)
	CALL_(BORDERDOWN)
	CALL_(BORDERRIGHT)
	CALL_(BORDERLEFT)
	CALL_(BUILDINGDRAWS)
	ld hl,RT
	ld (Save),hl
	CALL_(moveit)
	JUMP_(GAMELOOP)	
SWITCHROOM:
	CALL_(DRAWWALLS)
	xor a
	ld (UP1),a
	ld (RIGHT),a
	ld (DOWN),a
	ld (LEFT),a
	ld a,(DUNGEON)
	or a
	JUMP_NZ(DUNGEONSWITCH)
	ld a,(ROOM)
	cp 1
	JUMP_Z(LOOM1)
	cp 2
	JUMP_Z(LOOM2)
	cp 3
	JUMP_Z(LOOMto1)
	cp 4
	JUMP_Z(LOOMto1)
	cp 5
	JUMP_Z(LOOMto1)
	cp 6
	JUMP_Z(LOOM6)
	cp 7
	JUMP_Z(LOOM7)
	cp 8
	JUMP_Z(LOOM8)
	cp 9
	JUMP_Z(LOOM9)
	cp 10
	JUMP_Z(LOOM10)
	cp 11
	JUMP_Z(LOOM11)
	cp 12
	JUMP_Z(LOOM12)
	cp 13
	JUMP_Z(LOOM13)
	cp 14
	JUMP_Z(LOOMto11)
	cp 15
	JUMP_Z(LOOMto11)
	cp 25
	JUMP_Z(LOOM25)
	cp 26
	JUMP_Z(LOOMto25)
	cp 27
	JUMP_Z(LOOMto25)
	cp 28
	JUMP_Z(LOOM28)
	cp 29
	JUMP_Z(LOOM29)
	cp 30
	JUMP_Z(LOOM30)
	cp 31
	JUMP_Z(LOOM31)
	cp 32
	JUMP_Z(LOOMto25)
	cp 33
	JUMP_Z(loom30rt)
	cp 40
	JUMP_Z(LOOM40)
	cp 41
	JUMP_Z(LOOM41)
	cp 42
	JUMP_Z(LOOM42)
	cp 43
	JUMP_Z(LOOM43)
	cp 44
	JUMP_Z(loom42lt)
DUNGEONSWITCH:
	ld a,(ROOM)	
	cp 100
	JUMP_Z(LOOM100)
	cp 101
	JUMP_Z(LOOM101)
	cp 102
	JUMP_Z(LOOM102)
	cp 103
	JUMP_Z(LOOM103)
	cp 104
	JUMP_Z(loom102rt)
	cp 105
	JUMP_Z(LOOM105)
	cp 106
	JUMP_Z(LOOM106)
	cp 107
	JUMP_Z(LOOM107)
	cp 108
	JUMP_Z(loom106dn)
	cp 109
	JUMP_Z(LOOM109)
	cp 110
	JUMP_Z(loom106rt)
	cp 111
	JUMP_Z(LOOM111)
	cp 112
	JUMP_Z(loom106up)
	cp 113
	JUMP_Z(LOOM113)
	cp 114
	JUMP_Z(loom106lt)
	cp 115
	JUMP_Z(LOOM115)
	cp 116
	JUMP_Z(LOOM116)
	cp 117
	JUMP_Z(LOOM117)
	cp 118
	JUMP_Z(LOOM118)
	cp 119
	JUMP_Z(LOOM119)
	cp 120
	JUMP_Z(loom118lt)	
	cp 121
	JUMP_Z(loom125lt)
	cp 122
	JUMP_Z(LOOM122)
	cp 123
	JUMP_Z(loom125lt)
	cp 124
	JUMP_Z(LOOM124)
	cp 125
	JUMP_Z(LOOM125)
	cp 126
	JUMP_Z(loom124up)
	cp 128
	JUMP_Z(LOOMto129)
	cp 129
	JUMP_Z(LOOM129)
	cp 130
	JUMP_Z(LOOMto129)
	cp 131
	JUMP_Z(LOOM131)
	cp 132
	JUMP_Z(LOOMto131)
	cp 133
	JUMP_Z(LOOMto131)
	cp 136
	JUMP_Z(LOOMto138)
	cp 137
	JUMP_Z(LOOMto138)
	cp 138
	JUMP_Z(LOOM138)
	cp 139
	JUMP_Z(LOOMto138)
	cp 140
	JUMP_Z(LOOMto144)
	cp 141
	JUMP_Z(LOOMto144)
	cp 142
	JUMP_Z(LOOMto144)
	cp 143
	JUMP_Z(LOOMto144)
	cp 144
	JUMP_Z(LOOM144)
	cp 145
	JUMP_Z(LOOMto149)
	cp 146
	JUMP_Z(LOOMto149)
	cp 147
	JUMP_Z(LOOMto149)
	cp 148
	JUMP_Z(LOOMto149)
	cp 149
	JUMP_Z(LOOM149)
	cp 150
	JUMP_Z(LOOMto154)
	cp 151
	JUMP_Z(LOOMto154)
	cp 152
	JUMP_Z(LOOMto154)
	cp 153
	JUMP_Z(LOOMto154)
	cp 154
	JUMP_Z(LOOM154)
	cp 155
	JUMP_Z(LOOM155)
	cp 156
	JUMP_Z(LOOM156)
	cp 160
	JUMP_Z(LOOM160)
	cp 161
	JUMP_Z(LOOM161)
	cp 162
	JUMP_Z(LOOM162)
	cp 163
	JUMP_Z(LOOM163)
	cp 164
	JUMP_Z(LOOM164)
	cp 165
	JUMP_Z(LOOM165)
RELOADROOM:
	CALL_(BUILDINGDRAWS)
	ld a,(DUNGEON)
	or a
	JUMP_NZ(RELOADDUNGEON)
	ld a,(ROOM)
	cp 1	
	JUMP_Z(ROOM1)
	cp 2	
	JUMP_Z(ROOM2)
	cp 3	
	JUMP_Z(ROOM3)
	cp 4	
	JUMP_Z(ROOM4)
	cp 5	
	JUMP_Z(ROOM5)
	cp 6	
	JUMP_Z(ROOM6)
	cp 7	
	JUMP_Z(ROOM7)
	cp 8	
	JUMP_Z(ROOM8)
	cp 9	
	JUMP_Z(ROOM9)
	cp 10	
	JUMP_Z(ROOM4)
	cp 11	
	JUMP_Z(ROOM1)
	cp 12	
	JUMP_Z(ROOM12)
	cp 13	
	JUMP_Z(ROOM7)
	cp 14	
	JUMP_Z(ROOM7)
	cp 15	
	JUMP_Z(ROOM5)
	cp 25	
	JUMP_Z(ROOM1)
	cp 26	
	JUMP_Z(ROOM7)
	cp 27
	JUMP_Z(ROOM5)
	cp 28	
	JUMP_Z(ROOM119)
	cp 29	
	JUMP_Z(ROOM103)
	cp 30	
	JUMP_Z(ROOM119)
	cp 31	
	JUMP_Z(ROOM103)
	cp 32	
	JUMP_Z(ROOM3)
	cp 33	
	JUMP_Z(ROOM4)
	cp 40	
	JUMP_Z(ROOM4)
	cp 41	
	JUMP_Z(ROOM103)
	cp 42	
	JUMP_Z(ROOM8)
	cp 43	
	JUMP_Z(ROOM8)
	cp 44	
	JUMP_Z(ROOM5)
RELOADDUNGEON:
	ld a,(ROOM)
	cp 100	
	JUMP_Z(ROOM2)
	cp 101	
	JUMP_Z(ROOM2)
	cp 102	
	JUMP_Z(ROOM102)
	cp 103	
	JUMP_Z(ROOM103)
	cp 104	
	JUMP_Z(ROOM4)
	cp 105	
	JUMP_Z(ROOM5)
	cp 106	
	JUMP_Z(ROOM1)
	cp 107	
	JUMP_Z(ROOM2)
	cp 108	
	JUMP_Z(ROOM4)
	cp 109	
	JUMP_Z(ROOM8)
	cp 110	
	JUMP_Z(ROOM3)
	cp 111	
	JUMP_Z(ROOM2)
	cp 112	
	JUMP_Z(ROOM7)
	cp 113	
	JUMP_Z(ROOM8)
	cp 114	
	JUMP_Z(ROOM5)
	cp 115	
	JUMP_Z(ROOM3)
	cp 116	
	JUMP_Z(ROOM119)
	cp 117	
	JUMP_Z(ROOM2)
	cp 118	
	JUMP_Z(ROOM103)
	cp 119	
	JUMP_Z(ROOM119)
	cp 120	
	JUMP_Z(ROOM7)
	cp 121	
	JUMP_Z(ROOM4)
	cp 122	
	JUMP_Z(ROOM102)
	cp 123	
	JUMP_Z(ROOM5)
	cp 124	
	JUMP_Z(ROOM2)
	cp 125	
	JUMP_Z(ROOM102)
	cp 126	
	JUMP_Z(ROOM3)
	cp 128	
	JUMP_Z(ROOM3)
	cp 129	
	JUMP_Z(ROOM129)
	cp 130	
	JUMP_Z(ROOM4)
	cp 131	
	JUMP_Z(ROOM129)
	cp 132	
	JUMP_Z(ROOM4)
	cp 133	
	JUMP_Z(ROOM3)
	cp 136	
	JUMP_Z(ROOM7)
	cp 137	
	JUMP_Z(ROOM5)
	cp 138	
	JUMP_Z(ROOM1)
	cp 139	
	JUMP_Z(ROOM3)
	cp 140	
	JUMP_Z(ROOM7)
	cp 141	
	JUMP_Z(ROOM3)
	cp 142	
	JUMP_Z(ROOM4)
	cp 143	
	JUMP_Z(ROOM5)
	cp 144	
	JUMP_Z(ROOM1)
	cp 145	
	JUMP_Z(ROOM7)
	cp 146	
	JUMP_Z(ROOM3)
	cp 147	
	JUMP_Z(ROOM4)
	cp 148	
	JUMP_Z(ROOM5)
	cp 149	
	JUMP_Z(ROOM1)
	cp 150	
	JUMP_Z(ROOM7)
	cp 151	
	JUMP_Z(ROOM3)
	cp 152	
	JUMP_Z(ROOM4)
	cp 153	
	JUMP_Z(ROOM5)
	cp 154	
	JUMP_Z(ROOM1)
	cp 155	
	JUMP_Z(ROOM5)
	cp 156	
	JUMP_Z(ROOM3)
	cp 160	
	JUMP_Z(ROOM2)
	cp 161	
	JUMP_Z(ROOM2)
	cp 162	
	JUMP_Z(ROOM2)
	cp 163	
	JUMP_Z(ROOM2)
	cp 164	
	JUMP_Z(ROOM2)
	cp 165	
	JUMP_Z(ROOM129)
GAMELOOP2:
	ld a,(COUNTER)
	inc a
	cp 20
	JUMP_Z(STARTBATTLE)
	ld (COUNTER),a
GAMELOOP:	
	call _getky
	cp K_EXIT
	JUMP_Z(EXIT)
	cp K_ALPHA
	JUMP_Z(BUILDINGCHK)
	cp K_SECOND
	JUMP_Z(STATUSSCREEN)
	cp K_UP
	jr z,MOVEUP
 	cp K_DOWN
	JUMP_Z(MOVEDOWN)
        	cp K_LEFT
	JUMP_Z(MOVELEFT)
        	cp K_RIGHT
	JUMP_Z(MOVERIGHT)
	jr GAMELOOP
MOVEUP:
	ld a,(DOTY)		
	cp 4
	jr z,CHKVT
	ld HL,(Save)
	CALL_(moveit)
	LD HL,UP
	ld a,(DOTY)		
	sub 8
	ld (DOTY),a
	CALL_(moveit)
	jr GAMELOOP2
CHKVT:
	ld a,(UP1)
	or a
	jr z,GAMELOOP
	ld a,(DOTX)
	cp 44
	JUMP_Z(SWITCHROOM)
	jr GAMELOOP	
CHKVT2:
	ld a,(DOWN)
	or a
	JUMP_Z(GAMELOOP)
	ld a,(DOTX)
	cp 44
	JUMP_Z(SWITCHROOM)
	jr GAMELOOP	
CHKHZ:
	ld a,(RIGHT)
	or a
	JUMP_Z(GAMELOOP)
	ld a,(DOTY)
	cp 28
	JUMP_Z(SWITCHROOM)
	JUMP_(GAMELOOP)	
CHKHZ2:
	ld a,(LEFT)
	or a
	JUMP_Z(GAMELOOP)
	ld a,(DOTY)
	cp 28
	JUMP_Z(SWITCHROOM)
	JUMP_(GAMELOOP)
MOVEDOWN:
	ld a,(DOTY)		
	cp 52
	jr z,CHKVT2
	ld HL,(Save)
	CALL_(moveit)
	LD HL,DN
	ld a,(DOTY)		
	add a,8
	ld (DOTY),a
	CALL_(moveit)
	JUMP_(GAMELOOP2)
MOVELEFT:
	ld a,(DOTX)		
	cp 4
	jr z,CHKHZ2
	ld HL,(Save)
	CALL_(moveit)
	LD HL,LT
	ld a,(DOTX)		
	sub 8
	ld (DOTX),a
	CALL_(moveit)
	JUMP_(GAMELOOP2)
MOVERIGHT:
	ld a,(DOTX)		
	cp 84
	JUMP_Z(CHKHZ)
	ld HL,(Save)
	CALL_(moveit)
	LD HL,RT
	ld a,(DOTX)		
	add a,8
	ld (DOTX),a
	CALL_(moveit)
	JUMP_(GAMELOOP2)
ERASESCREEN:
	push hl
	ld hl,$FC00
	ld de,$FC00+1
	ld bc,1023
	ld (hl),l	
	ldir                     ; Simple - fill the GRAPH_MEM with one value
       	call CR_GRBCopy	
	pop hl
	RET




SAVERAM:
	.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0



DataName:
	.db 7,"ffx4lib"





CR_GRBCopy:
_GRBUFCPY_V:
DISP_GRAPH:
  ei
  halt
  halt
  ret



;-----------------------------------
;BATTLE!!!!!!!
;-----------------------------------

STARTBATTLE:
	xor a	
	res textInverse,(iy+textflags)	;3,(IY+05)
	ld b,3
SCRAMBLE:
	push bc
	CALL_(ERASESCREEN)
	CALL_(DELAY3)
	ld hl,$0000			;load battle screen
	CALL_(BG)
	CALL_(DELAY3)
	pop bc
	djnz SCRAMBLE

BATTLE:

RANDOMENEMY:

;	call _op2set2
;	call _random
;	call _fpmult
;	call _convop1
;	inc a

;	ld a,2
;	call _setXXop1
;	call _op1toop2
;	ld a,1
;	call _setXXop1
;	call _randint
;	call _convop1
	
  ld a,r
  srl a
  and 1          ; between 0-1
	inc a
;  jr z,RANDOMENEMY
;  cp 3
;  jr z,RANDOMENEMY
  ld (NUMBEROFENEMIES),a

	ld hl,0	
	ld (ENEMYHP),hl
	ld (ENEMYHP2),hl
	xor a
	ld (LEADERORNO),a
	ld (DEFENDONI),a
	ld (DEFENDOND),a
	ld (ENEMY2XP),a
	ld (MAGICHK),a
	ld (WHOATTACK),a
	ld (WHOTOATTACK),a
	ld (OKAY1),a
	ld (OKAY2),a
	ld (ENEMYCOUNTER),a
	ld (ENEMY32),a	
	ld a,1
	ld (HITBYWHO),a
	ld a,21
	ld (COUNTER),a
	ld a,41
	ld (COUNTER2),a
	ld a,13
	ld (ECOUNTER),a
	ld hl,BATTLEPIC			;load battle screen
	ld de,$FC00
	ld b,e
	call DeComp

	ld a,(HPI)
	or a
	jr z,ISISDEADSTART
	ld a,(HPD)
	or a
	CALL_Z(ERASEDARQ)
	jr NOBODYDEAD
ISISDEADSTART:
	CALL_(ERASEISIS)
	ld bc,$1C55	
	ld hl,CURSOR	
	CALL_(drawit2)
	ld a,1
	ld (WHOATTACK),a
	jr SOMEBDYWASDED
NOBODYDEAD:
	ld bc,$0655	
	ld hl,CURSOR	
	CALL_(drawit2)
SOMEBDYWASDED:
	ld a,(CHKDFD)
	cp 99
	JUMP_Z(LEADERS)
	CALL_(PUTENEMY)	
RETFROMLEADER:
	LD DE,$381A		;\
	ld a,(HPI)		; \
	CALL_(DISPHL)		;/
	LD DE,$382E		;\
	ld a,(HPD)		; \
	CALL_(DISPHL)		;/
	ld bc,$2E01	
	ld hl,ICONRING	
	CALL_(drawit2)
SPEEDLOOP:
 	ld a,$1E
 	out (1),a
 	in a,(1)
	bit 5,a
 	JUMP_Z(IPRESS)
 	bit 7,a
 	JUMP_Z(SWITCH)
	bit 3,a
 	JUMP_Z(IUP)
 	bit 0,a
 	JUMP_Z(IDOWN)
        	bit 1,a
        	JUMP_Z(ILEFT)
        	bit 2,a
        	JUMP_Z(IRIGHT)
	ld a,(OKAY1)
	cp 1
	jr nz,ISISCOUNTER
	ld a,(OKAY2)
	cp 1
	jr nz,DARQCOUNTER
	jr SPEEDLOOP
ISISCOUNTER:
	ld a,(COUNTER)
	ld b,a
	ld c,10
	CALL_(PutPixel)
	ld a,(COUNTER)
	ld b,a
	ld c,9
	CALL_(PutPixel)	
	ld a,(ENEMYSPEED)
	ld c,a
	ld a,(ENEMYCOUNTER)
	inc a
	ld (ENEMYCOUNTER),a
	cp c
	JUMP_Z(ENEMYATTACK)
RETURNATTK:	
	ld a,(COUNTER)
	inc a
	ld (COUNTER),a
	cp 35
	jr z,OK1	
	ld a,(OKAY2)	
	cp 1
	jr z,SPEEDLOOP
DARQCOUNTER:
	ld a,(ENEMYSPEED)
	ld c,a
	ld a,(ENEMYCOUNTER)
	inc a
	ld (ENEMYCOUNTER),a
	cp c
	JUMP_Z(ENEMYATTACK)
	ld a,(COUNTER2)
	ld b,a
	ld c,10
	CALL_(PutPixel)
	ld a,(COUNTER2)
	ld b,a
	ld c,9
	CALL_(PutPixel)
	ld a,(COUNTER2)
	inc a
	ld (COUNTER2),a	
	cp 56
	jr z,OK2 
	JUMP_(SPEEDLOOP)
OK1:	
	ld a,1
	ld (OKAY1),a
	JUMP_(SPEEDLOOP)
OK2:
	ld a,1
	ld (OKAY2),a
	JUMP_(SPEEDLOOP)
IDOWN:
	ld hl,ICONRING
	CALL_(drawit)
	ld a,55
	ld (BKY),a
	ld hl,ICONRING
	CALL_(drawit)
	JUMP_(SPEEDLOOP)
ILEFT:
	ld hl,ICONRING
	CALL_(drawit)
	ld a,1		
	ld (BKX),a
	ld hl,ICONRING
	CALL_(drawit)
	JUMP_(SPEEDLOOP)
IRIGHT:
	ld hl,ICONRING
	CALL_(drawit)
	ld a,10	
	ld (BKX),a
	ld hl,ICONRING
	CALL_(drawit)
	JUMP_(SPEEDLOOP)
IUP:
	ld hl,ICONRING
	CALL_(drawit)
	ld a,46	
	ld (BKY),a
	ld hl,ICONRING
	CALL_(drawit)
	JUMP_(SPEEDLOOP)
IPRESS:
	ld a,(WHOATTACK)	
	cp 1
	jr z,DARQ
ISIS:
	ld a,(OKAY1)
	or a
	jr z,NOTOK
	jr REUPORDOWN
DARQ:
	ld a,(OKAY2)
	or a
	JUMP_Z(NOTOK)
	jr REUPORDOWN
NOTOK:
	ld de, $0103                    
             ld hl,NOTTURN
             call DISPSTRING     
	CALL_(DELAY)
	CALL_(ERASETEXT)
	JUMP_(SPEEDLOOP)
REUPORDOWN:
	ld a,(BKX)
	cp 1
	jr z,UPORDOWN
	cp 10
	jr z,UPORDOWNRT
UPORDOWN:
	ld a,(BKY)
	cp 46
	JUMP_Z(FIGHT)
	cp 55
	JUMP_Z(ITEM)
UPORDOWNRT:
	ld a,(BKY)
	cp 46
	JUMP_Z(MAGIC)
	cp 55
	JUMP_Z(DEFEND)
SWITCH:
	ld a,(HPD)	
	or a
	JUMP_Z(SPEEDLOOP)
	ld a,(HPI)	
	or a
	JUMP_Z(SPEEDLOOP)
	CALL_(REVERSAL)
	ld a,(WHOATTACK)
	or a
	jr z,DARQSWITCH
	ld bc,$1C55	
	ld hl,CURSOR	
	CALL_(drawit2)
	ld bc,$0655	
	xor a
	ld (WHOATTACK),a
	jr SWITCHEND
DARQSWITCH:
	ld bc,$0655	
	ld hl,CURSOR	
	CALL_(drawit2)
	ld bc,$1C55	
	ld a,1
	ld (WHOATTACK),a
SWITCHEND:
	ld hl,CURSOR	
	CALL_(drawit2) 
	CALL_(ENDREVERSAL)
	CALL_(DELAY)
	JUMP_(SPEEDLOOP)
FIGHT:
	ld a,(NUMBEROFENEMIES)
	cp 1
	JUMP_Z(WHOISDEAD)
	jr NOONEIS	
WHOISDEAD:
	ld hl,(ENEMYHP2)
	ld de, 0
	and a
	sbc hl,de
	jr z,ENEMY2DEAD
ENEMY1DEAD:	
	ld a,2
	ld (WHOTOATTACK),a
	JUMP_(ACTUALATTACK)	
ENEMY2DEAD:
	ld a,1
	ld (WHOTOATTACK),a
	JUMP_(ACTUALATTACK)
NOONEIS:
	CALL_(REVERSAL)	
	ld bc,$0D04	
	ld hl,CURSOR2	
	CALL_(drawit2)
	ld a,1
	ld (WHOTOATTACK),a
	CALL_(DELAY)
CURSLOOP:	
	ld a,$3E
 	out (1),a
 	in a,(1)
 	bit 5,a
 	JUMP_Z(CURSPRESS)
	bit 3,a
 	JUMP_Z(CURSUP)
 	bit 0,a
 	JUMP_Z(CURSDOWN)
	bit 1,a
        	JUMP_Z(CURSUP)
	bit 2,a
        	JUMP_Z(CURSDOWN)
	jr CURSLOOP
CURSUP:
	ld hl,CURSOR2	
	CALL_(drawit)
	ld bc,$0D04	
	ld hl,CURSOR2	
	CALL_(drawit2)
	CALL_(DELAY)
	ld a,1
	ld (WHOTOATTACK),a
	jr CURSLOOP
CURSDOWN:
	ld hl,CURSOR2	
	CALL_(drawit)
	ld bc,$1A0D	
	ld hl,CURSOR2	
	CALL_(drawit2)
	CALL_(DELAY)
	ld a,2
	ld (WHOTOATTACK),a
	jr CURSLOOP
CURSPRESS:
	ld hl,CURSOR2	
	CALL_(drawit)
	CALL_(ENDREVERSAL)
ACTUALATTACK:
	ld a,(WHOATTACK)
	or a
	JUMP_Z(ISISATTACKS)
DARQATTACKS:
	;; here are Darq's attacks
	CALL_(DRAWDATTACK)	
	CALL_(REVERSAL)
DARQRLOOP:
	ld a,r
  	srl a
  	and 3          ; between 1-2
	jr z,DARQRLOOP
  	sub 1
  	jr z,DARQRLOOP
	cp 1  	
	JUMP_Z(ATTACK1FORDARQ)
ATTACK2FORDARQ:
	ld a,54	
	ld (CHKDFD),a
REPEATDATTACK2:
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,32
	ld (BKY),a
	ld hl,ATTACKDNUMBER3	
	CALL_(drawit)
	ld a,(CHKDFD)
	add a,3
	ld (BKX),a
	ld a,27
	ld (BKY),a
	ld hl,ATTACKDNUMBER3	
	CALL_(drawit)
	ld a,(CHKDFD)
	sub 5
	ld (BKX),a
	ld a,28
	ld (BKY),a
	ld hl,ATTACKDNUMBER3	
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,32
	ld (BKY),a
	ld hl,ATTACKDNUMBER3	
	CALL_(drawit)
	ld a,(CHKDFD)
	add a,3
	ld (BKX),a
	ld a,27
	ld (BKY),a
	ld hl,ATTACKDNUMBER3	
	CALL_(drawit)
	ld a,(CHKDFD)
	sub 5
	ld (BKX),a
	ld a,28
	ld (BKY),a
	ld hl,ATTACKDNUMBER3	
	CALL_(drawit)
	ld a,(CHKDFD)
	sub 4
	ld (CHKDFD),a
	cp 30
	JUMP_NZ(REPEATDATTACK2)
	CALL_(ENDREVERSAL)
	CALL_(DRAWDATTACK)
	ld a,(STRENGTHD)
	ld c,a
	JUMP_(DARQGOHERE)
ATTACK1FORDARQ:
	ld a,57
	ld (CHKDFD),a
REPEATDARQATTACK:
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,27
	ld (BKY),a
	ld hl,ATTACKDNUMBER1	
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,27
	ld (BKY),a
	ld hl,ATTACKDNUMBER1	
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,27
	ld (BKY),a
	ld hl,ATTACKDNUMBER2	
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,27
	ld (BKY),a
	ld hl,ATTACKDNUMBER2	
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)
	dec a
	dec a
	dec a
	ld (CHKDFD),a
	cp 42
	jr nz, REPEATDARQATTACK
	CALL_(ENDREVERSAL)
	CALL_(DRAWDATTACK)
	ld a,(STRENGTHD)
	ld c,a
	JUMP_(DARQGOHERE)
ISISATTACKS:
	ld a,r
  	srl a
  	and 3          ; between 1-2
	jr z,ISISATTACKS
  	sub 1
  	jr z,ISISATTACKS
	cp 1  	
	JUMP_Z(ATTACK1FORISIS)
ATTACK2FORISIS:
	CALL_(REVERSAL)
	CALL_(DRAWIATTACK2)
REPEATATTACK2:
	ld (CHKDFD),a
	ld bc,$053B	
	ld hl,ATTACKINUMBER3	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$053B	
	ld hl,ATTACKINUMBER3	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$053B	
	ld hl,ATTACKINUMBER4	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$053B	
	ld hl,ATTACKINUMBER4	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$053B	
	ld hl,ATTACKINUMBER5	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$053B	
	ld hl,ATTACKINUMBER5	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$053B	
	ld hl,ATTACKINUMBER6	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$053B	
	ld hl,ATTACKINUMBER6	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld a,(CHKDFD)
	inc a
	cp 2
	JUMP_NZ(REPEATATTACK2)
	CALL_(ENDREVERSAL)
	CALL_(DRAWIATTACK2)
	JUMP_(ISISDONE)
ATTACK1FORISIS:
	CALL_(DRAWIATTACK)
	CALL_(REVERSAL)
	ld b,4
REPEATISISATTACK:
	push bc
	ld bc,$132D	
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$0A28
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)	
	ld bc,$0420	
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$0117	
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$040E
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$0A06
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$1301
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$1C06
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$230E
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$2617
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$2320
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	ld bc,$1C28
	ld hl,ATTACKINUMBER1
	CALL_(drawit2)
	pop bc	
	djnz REPEATISISATTK2
	CALL_(ENDREVERSAL)
	CALL_(DRAWIATTACK)
	jr ISISDONE
REPEATISISATTK2:
	JUMP_(REPEATISISATTACK)
ISISDONE:
	ld a,(STRENGTHI)
	ld c,a
DARQGOHERE:	
	CALL_(RAND2)	
	CALL_(DISPDAMAGE)
	ld a,(WHOTOATTACK)
	cp 1
	jr z,ATTACKENEMY1
ATTACKENEMY2:
	ld a,(CHKDFD)
	ld c,a
	ld b,0
	ld hl,(ENEMYHP2)
	and a
	sbc hl,bc
	ld (ENEMYHP2),hl
	JUMP_Z(ENEMYDEAD2)
	JUMP_C(ENEMYDEAD2)
	JUMP_(ACTIONEND)
ATTACKENEMY1:	
	ld a,(CHKDFD)
	ld c,a
	ld b,0
	ld hl,(ENEMYHP)
	and a
	sbc hl,bc	
	ld (ENEMYHP),hl
	JUMP_Z(ENEMYDEAD1)
	JUMP_C(ENEMYDEAD1)
	JUMP_(ACTIONEND)
ENEMYDEAD2:
	ld hl,0
	ld (ENEMYHP2),hl
	jr ENEMYDEAD
ENEMYDEAD1:
	ld a,(LEADERORNO)
	or a
	JUMP_NZ(ERASELEADER)
	ld hl,0
	ld (ENEMYHP),hl
ENEMYDEAD:
	ld a,(ENEMY32)	
	or a
	JUMP_NZ(BIGERASE)
	CALL_(ERASEENEMY)		
BIGERASEDONE:
	ld a,(NUMBEROFENEMIES)
	dec a	
	ld (NUMBEROFENEMIES),a
	or a
	jr z,ALLENEMYDEAD
	JUMP_(ACTIONEND)
ALLENEMYDEAD:
	CALL_(ERASEOF)
	ld de,$0103
   	ld hl,YOUWIN
        	call DISPSTRING
	;; Display XP earned and add it up
	ld de,(ENEMY1XP)
	ld hl,(ENEMY2XP)
	add hl,de
	ld (CHKDFD),hl
RANDGOLD:
	ld a,r
  	srl a
  	and 7          ; between 1-9
	ld c,a
	ld b,0
	ld hl,(CHKDFD)
	and a
	sbc hl,bc
	ld (WHOTOATTACK),hl

	ld hl,(GOLD)
	ld de,(WHOTOATTACK)
	add hl,de
	ld (GOLD),hl
	
	ld a,(HPI)
	or a
	jr z,DARQXPADD
	
	ld de,(CHKDFD)
	ld hl,(ISISXP)
	add hl,de
	ld (ISISXP),hl
DARQXPADD:
	ld a,(HPD)
	or a
	jr z,ENDOFADD
	ld de,(CHKDFD)
	ld hl,(DARQXP)
	add hl,de
	ld (DARQXP),hl
ENDOFADD:
	ld bc,$0A1E
	ld hl,BLANK	
	CALL_(drawit2)
	ld bc,$0A26
	ld hl,BLANK	
	CALL_(drawit2)
	ld bc,$0A2E
	ld hl,BLANK	
	CALL_(drawit2)
	ld bc,$0A36
	ld hl,BLANK	
	CALL_(drawit2)
	ld bc,$0C18
	ld hl,BLANK2	
	CALL_(drawit2)
	ld bc,$1418
	ld hl,BLANK2	
	CALL_(drawit2)
	ld bc,$1C18
	ld hl,BLANK2
	CALL_(drawit2)
	ld bc,$0C36
	ld hl,BLANK2	
	CALL_(drawit2)
	ld bc,$1436
	ld hl,BLANK2	
	CALL_(drawit2)
	ld bc,$1C36
	ld hl,BLANK2
	CALL_(drawit2)
	ld bc,$241E
	ld hl,BLANK	
	CALL_(drawit2)
	ld bc,$2426
	ld hl,BLANK	
	CALL_(drawit2)
	ld bc,$242E
	ld hl,BLANK	
	CALL_(drawit2)
	ld bc,$2436
	ld hl,BLANK	
	CALL_(drawit2)
	ld de,$0C27                   
            	ld hl,GAIN
            	call DISPSTRING
	ld de,$1523                   
            	ld hl,EXP
            	call DISPSTRING
	ld de,$1C25                   
            	ld hl,GOLDSTR
            	call DISPSTRING
	LD DE,$152E	
	ld a,(CHKDFD)	
	CALL_(DISPHL)	
	LD DE,$1C2E	
	ld a,(WHOTOATTACK)
	CALL_(DISPHL)	
	call WaitKey
	CALL_(LEVELUPORNOT)
ENDBATTLE:
	ld a,(LEADERORNO)
	or a
	JUMP_NZ(AFTERLEADER)
RETFROMLDR2:
	xor a
	ld (COUNTER),a
	CALL_(ERASESCREEN)		;return to map, battle over
	CALL_(DRAWWALLS)
	ld a,(DOTY)
	ld (BKY),a
	ld a,(DOTX)
	ld (BKX),a
	ld hl,(Save)
	CALL_(drawit)	
	JUMP_(RELOADROOM)

;-----------------
; -----Magic-----
;-----------------
MAGIC:
	CALL_(REVERSAL)
	CALL_(ERASEOF)
	ld a,(WHOATTACK)
	or a
	jr z,ISISCHKDFD
DARQCHKDFD:
	ld a,(DARQLVL)
	ld (CHKDFD),a
	jr CHKINGDONE
ISISCHKDFD:
	ld a,(ISISLVL)
	ld (CHKDFD),a
CHKINGDONE:
	ld a,(CHKDFD)
	cp 3
	JUMP_C(MAGIPAGE1)
	ld bc,$3656	
	ld hl,CURSORDN	
	CALL_(drawit2)
MAGIPAGE1:
	xor a
	ld (MAGIPAGE),a
	ld a,(WHOATTACK)
	or a
	jr z,ISISSPELL
DARQSPELL:
	ld de,$2D48		
             ld hl,Flee
             call DISPSTRING     
	ld a,(CHKDFD)
	cp 2
	jr c,MAGICSTART	
	ld de,$3448		
             ld hl,Drain
             call DISPSTRING     
	jr MAGICSTART
ISISSPELL:
	ld de,$2D48		
             ld hl,Cure
             call DISPSTRING     
	ld a,(CHKDFD)
	cp 2
	jr c,MAGICSTART
	ld de,$3448		
             ld hl,Fire
             call DISPSTRING     
	
MAGICSTART:
	ld bc,$2D3F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	CALL_(DELAY)
MAGICLOOP:
	ld a,$3E
 	out (1),a
 	in a,(1)
 	bit 6,a
 	JUMP_Z(CANCELSPELL)
 	bit 5,a
 	JUMP_Z(MAGIPRESS)
 	bit 0,a
 	jr z,MAGIDOWN
	bit 3,a
	jr nz,MAGICLOOP
MAGIUP:
	ld a,(BKY)
	cp 45
	jr z,MAGICLOOP	
	ld bc,$343F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	ld bc,$2D3F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	CALL_(DELAY)
	JUMP_(MAGICLOOP)
MAGIDOWN:
	ld a,(CHKDFD)
	cp 3
	jr WHICHSPELL
RESUME:	
	ld a,(BKY)
	cp 52
	jr z,MAGICLOOP	
	ld bc,$2D3F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	ld bc,$343F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	CALL_(DELAY)
	JUMP_(MAGICLOOP)
WHICHSPELL:
	ld a,(BKY)
	cp 45
	jr z,RESUME
	ld a,(CHKDFD)
	cp 3
	jr c,RESUME	
	ld de,$2D48		
	ld hl,BLANKTEXT2
             	call DISPSTRING     
	ld de,$3448		
       	ld hl,BLANKTEXT2
        	call DISPSTRING     
	ld a,(MAGIPAGE)
	cp 1
	JUMP_Z(RETURNTOPAGE1)
	cp 2
	JUMP_Z(RETURNTOPAGE2)
	cp 3
	JUMP_Z(JUSTRETURN)
	ld a,(WHOATTACK)
	or a
	JUMP_Z(SPELLSOFISIS)
SPELLSOFDARQ:
	ld a,1
	ld (MAGIPAGE),a
	ld de,$2D48		
             ld hl,Siphon
             call DISPSTRING     
	ld a,(CHKDFD)
	cp 9
	JUMP_C(MAGIUP)
	ld de,$3448		
             ld hl,Nuke
             call DISPSTRING     
	JUMP_(MAGIUP)
SPELLSOFISIS:
	ld a,1
	ld (MAGIPAGE),a
	ld de,$2D48		
             ld hl,Wrath
             call DISPSTRING     
	ld a,(CHKDFD)
	cp 5
	JUMP_C(MAGIUP)
	ld de,$3448		
             ld hl,Cure2
             call DISPSTRING     
	JUMP_(MAGIUP)
SPELLSOFISIS2:
	ld a,2
	ld (MAGIPAGE),a
	ld de,$2D48		
        	ld hl,Life
           	call DISPSTRING     
	ld a,(CHKDFD) 
	cp 10
	JUMP_C(MAGIUP)
	ld de,$3448		
            	ld hl,Cure3
            	call DISPSTRING     
	JUMP_(MAGIUP)
SPELLSOFISIS3:
	ld a,3
	ld (MAGIPAGE),a
	ld de,$2D48		
        	ld hl,Death
           	call DISPSTRING     
	ld a,(CHKDFD)
	JUMP_(MAGIUP)
SPELLS3:
	ld a,(WHOATTACK)
	or a
	JUMP_Z(SPELLSOFISIS3)
	JUMP_(SPELLSOFDARQ)
SPELLS2:
	ld a,(WHOATTACK)
	or a
	JUMP_Z(SPELLSOFISIS2)
	JUMP_(SPELLSOFDARQ)
RETURNTOPAGE2:
	ld a,(CHKDFD)
	cp 10
	JUMP_NC(SPELLS3)
	jr JUSTRETURN
RETURNTOPAGE1:
	ld a,(CHKDFD)
	cp 7
	JUMP_NC(SPELLS2)
JUSTRETURN:
	ld bc,$343F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	JUMP_(MAGIPAGE1)
MAGIPRESS:
	ld a,(WHOATTACK)
	or a
	JUMP_Z(ISISSELECT)
DARQSELECT:
	ld a,(MAGIPAGE)
	or a
	jr z,DARQCMP0
	cp 1
	jr z,DARQCMP1
DARQCMP0:
	ld a,(BKY)
	cp 45
	JUMP_Z(FLEESPELL)
	ld a,(DARQLVL)
	cp 2
	JUMP_C(MAGICLOOP)
	JUMP_(DRAINSPELL)
DARQCMP1:
	ld a,(BKY)
	cp 45
	JUMP_Z(SUCKSPELL)
	ld a,(DARQLVL)
	cp 9
	JUMP_C(MAGICLOOP)
	JUMP_(NUKESPELL)
ISISSELECT:
	ld a,(MAGIPAGE)
	or a
	jr z,ISISCMP0
	cp 1
	jr z,ISISCMP1
	cp 2
	jr z,ISISCMP2
	JUMP_(DEATHSPELL)
ISISCMP0:
	ld a,(BKY)
	cp 45
	JUMP_Z(CURESPELL)
	ld a,(ISISLVL)
	cp 2
	JUMP_C(MAGICLOOP)
	JUMP_(FIRESPELL)
ISISCMP1:
	ld a,(BKY)
	cp 45
	JUMP_Z(HATESPELL)
	ld a,(ISISLVL)
	cp 5
	JUMP_C(MAGICLOOP)
	JUMP_(CURESPELL2)
ISISCMP2:
	ld a,(BKY)
	cp 45
	JUMP_Z(LIFESPELL)
	ld a,(ISISLVL)
	cp 10
	JUMP_C(MAGICLOOP)
	JUMP_(CURESPELL3)
SPELLEND:	
	xor a
	ld (MAGICHK),a
	ld bc,$2E0A	
	ld (BKX),bc
	CALL_(ERASEOF)
	CALL_(PUTNAME)
	JUMP_(ACTIONEND)
PUTNAME:
	ld hl,(ENEMYHP)
	ld de,0
	and a
	sbc hl,de
	jr z,NEXT2
	ld de,$2C40
   	ld hl,(ENEMY1)
             call DISPSTRING
NEXT2:
	ld hl,(ENEMYHP2)
	ld de,0
	and a
	sbc hl,de
	RET Z
	ld de, $3340
   	ld hl,(ENEMY2)
             call DISPSTRING
	RET

ERASEOF:	
	ld de,$2D3F		
             ld hl,BLANKTEXT
             call DISPSTRING     
	ld de,$333F		
             ld hl,BLANKTEXT
             call DISPSTRING     
	ld de,$3942		
             ld hl,BLANKTEXT
             call DISPSTRING     
	RET

FLEESPELL:
	ld a,(DARQMP)   ;; have enough MP?
	cp 1
	JUMP_C(NEEDMOREMP)		
	ld a,(LEADERORNO)
	or a
	JUMP_NZ(MAGICLOOP)
	ld de,$0103                    
            	ld hl,Fleetext
            	call DISPSTRING     
	CALL_(DRAWDATTACK)
	ld a,4
	ld (CHKDFD),a
FLEEOVER: ;; spell graphics -- "the winds of change..."
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,8
	ld (BKY),a
	ld hl,FLEE	
	CALL_(drawit)
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,17
	ld (BKY),a
	ld hl,FLEE	
	CALL_(drawit)
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,26
	ld (BKY),a
	ld hl,FLEE	
	CALL_(drawit)
	ld a,(CHKDFD)	 
	ld (BKX),a
	ld a,35
	ld (BKY),a
	ld hl,FLEE	
	CALL_(drawit)
	ld a,(CHKDFD)	
	add a,8
	ld (CHKDFD),a
	cp 85
	JUMP_C(FLEEOVER)
	ld a,(DARQMP)  ;; subtract that used MP
	dec a
	ld (DARQMP),a
	JUMP_(ENDBATTLE)	;;spell effect -- exits battle (like a charm, baby)

SUCKSPELL:
	ld a,(DARQMP)
	cp 24
	JUMP_C(NEEDMOREMP)		
	ld a,66	
	ld (WHOTOATTACK),a
	jr RETSPELLD
DRAINSPELL:
	ld a,(DARQMP)
	cp 7
	JUMP_C(NEEDMOREMP)		
RETSPELLD:
	CALL_(DRAWDATTACK)
	ld a,63
	ld (CHKDFD),a
DRAINLOOP:
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,20
	ld (BKY),a
	ld hl,SPELLDRAIN
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,20
	ld (BKY),a
	ld hl,SPELLDRAIN
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,20
	ld (BKY),a
	ld hl,SPELLDRAIN2
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,20
	ld (BKY),a
	ld hl,SPELLDRAIN2
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)
	sub 8
	ld (CHKDFD),a
	cp 23
	jr nz,DRAINLOOP
DRAINLOOP2:
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,20
	ld (BKY),a
	ld hl,SPELLDRAIN3
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,20
	ld (BKY),a
	ld hl,SPELLDRAIN3
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,20
	ld (BKY),a
	ld hl,SPELLDRAIN4
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)	
	ld (BKX),a
	ld a,20
	ld (BKY),a
	ld hl,SPELLDRAIN4
	CALL_(drawit) 
	CALL_(DELAY2)
	ld a,(CHKDFD)
	add a,8
	ld (CHKDFD),a
	cp 63
	jr nz,DRAINLOOP2
	CALL_(DRAWDATTACK)
	ld a,(WHOTOATTACK)
	cp 66
	jr z,SUCKSPELLEND	
	ld a,(DARQMP)  ;; subtract that used MP
	sub 7
	ld (DARQMP),a
	ld a,(HPD)
	add a,20
	ld (HPD),a
	CALL_(HPOVERMAXD)
	CALL_(DISPALLHP)
	ld c,20		;; damage = 15 +/- RAND	
	JUMP_(MAGICERASE)	
SUCKSPELLEND:
	ld a,(DARQMP)  ;; subtract that used MP
	sub 24
	ld (DARQMP),a
	ld a,(HPD)
	add a,60
	ld (HPD),a
	CALL_(HPOVERMAXD)
	CALL_(DISPALLHP)
	ld c,60		;; damage = 60 +/- RAND	
	JUMP_(MAGICERASE)	
NUKESPELL:
	ld a,(DARQMP)
	cp 36
	JUMP_C(NEEDMOREMP)		
	CALL_(DRAWDATTACK)
	ld a,51
	ld (CHKDFD),a
	ld b,2
NUKELOOP:	
	push bc
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,15
	ld (BKY),a
	ld hl,SPELLNUKE	
	ld c,16
	CALL_(drawbig)
	ld a,15
	ld (BKY),a
	ld a,(CHKDFD)
	add a,8
	ld (BKX),a
	ld hl,SPELLNUKE2	
	ld c,16
	CALL_(drawbig)
	ld a,15
	ld (BKY),a
	ld a,(CHKDFD)
	add a,16
	ld (BKX),a
	ld hl,SPELLNUKE3	
	ld c,16
	CALL_(drawbig)

	pop bc
	djnz NUKELOOP	
	ld b,2
	ld a,(CHKDFD)	
	sub 3
	ld (CHKDFD),a
	cp 15
	jr nz,NUKELOOP
	ld b,6
NUKELOOP2:
	push bc
	ld bc,$1A1A	
	ld hl,SPELLFIRE	
	CALL_(drawit2)
	ld bc,$0D0D	
	ld hl,SPELLFIRE
	CALL_(drawit2)
	CALL_(DELAY2)
	pop bc
	djnz NUKELOOP2
	ld a,(DARQMP)  ;; subtract that used MP
	sub 23
	ld (DARQMP),a
	CALL_(DRAWDATTACK)
	ld c,230		;; damage = 230 +/- RAND	
	JUMP_(MAGICERASE)	
	
;;Begin Isis' Spells
CURESPELL:
	ld a,3
	ld (MAGIPAGE),a
	ld a,30
	ld (MAGICHK),a
	jr CURECURE
CURESPELL2:
	ld a,9
	ld (MAGIPAGE),a
	ld a,110
	ld (MAGICHK),a
	jr CURECURE
CURESPELL3:
	ld a,20
	ld (MAGIPAGE),a
	ld a,255
	ld (MAGICHK),a
	jr CURECURE
CURECURE:
	
	ld de,$0109                    
             ld hl,Curetext
             call DISPSTRING     
	ld a,(MAGIPAGE)
	ld b,a	
	ld a,(ISISMP)   ;; have enough MP?
	cp b
	JUMP_C(NEEDMOREMP)		
	CALL_(DRAWIATTACK)
	ld b,4
	CALL_(CURELOOP)
	ld a,(MAGIPAGE)
	ld b,a
	ld a,(ISISMP)  ;; subtract that used MP
	sub b
	ld (ISISMP),a
	CALL_(DRAWIATTACK)
	ld a,(MAGICHK)		
	ld b,a
	ld a,(HPD)
	or a
	jr z,ISISCURE
	add a,b
	ld (HPD),a
	CALL_(HPOVERMAXD)
ISISCURE:
	ld a,(HPI)
	add a,b
	ld (HPI),a
	CALL_(HPOVERMAXI)
	CALL_(DISPALLHP)
	CALL_(ERASETEXT)
	JUMP_(SPELLEND)
CURELOOP:
	ld b,8
LOOPOFCURE:
	push bc
	ld de,$1032	
	ld hl,SPELLCURE	
	ld c,11
	CALL_(drawbig2)
	ld de,$103A	
	ld hl,SPELLCURE2	
	ld c,11
	CALL_(drawbig2)
	CALL_(DELAY3)
	pop bc
	djnz LOOPOFCURE
	RET

FIRESPELL:
	ld a,(ISISMP)
	cp 9
	JUMP_C(NEEDMOREMP)		
	CALL_(DRAWIATTACK)
	ld b,6
FIRELOOP:
	push bc
	ld bc,$0D0D
	ld hl,SPELLFIRE
	CALL_(drawit2)
	ld bc,$1A0E
	ld hl,SPELLFIRE
	CALL_(drawit2)
	ld bc,$0D18
	ld hl,SPELLFIRE
	CALL_(drawit2)
	ld bc,$1A1A
	ld hl,SPELLFIRE
	CALL_(drawit2)
	CALL_(DELAY3)
	pop bc
	djnz FIRELOOP
	ld a,(ISISMP)  ;; subtract that used MP
	sub 9
	ld (ISISMP),a
	CALL_(DRAWIATTACK)
	ld c,30		;; damage = 15 +/- RAND	
	JUMP_(MAGICERASE)
HATESPELL:
	ld a,(ISISMP)
	cp 16
	JUMP_C(NEEDMOREMP)		
	CALL_(DRAWIATTACK)
	ld b,8
HATENOLOOP:	
	push bc	
	ld de,$0E06	
	ld hl,SPELLHATE	
	ld c,14
	CALL_(drawbig2)
	CALL_(DELAY2)
	ld de,$071C	
	ld hl,SPELLHATE	
	ld c,14
	CALL_(drawbig2)
	CALL_(DELAY2)
	ld de,$1812	
	ld hl,SPELLHATE	
	ld c,14
	CALL_(drawbig2)
	CALL_(DELAY2)
	pop bc
	djnz HATENOLOOP
	CALL_(DRAWIATTACK)
	ld a,(ISISMP)  ;; subtract that used MP
	sub 16
	ld (ISISMP),a
	ld c,80		;; damage = 15 +/- RAND	
	JUMP_(MAGICERASE)
LIFESPELL:
	ld a,(HPD)
	or a
	JUMP_NZ(MAGICLOOP)
	ld a,(ISISMP)
	cp 24
	JUMP_C(NEEDMOREMP)		
	CALL_(DRAWIATTACK)
	CALL_(DRAWANGEL)
	ld bc,$0635	
	ld hl,LIFESTAR	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$0635	
	ld hl,LIFESTAR	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$0536	
	ld hl,LIFESTAR	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$0536	
	ld hl,LIFESTAR	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$0438	
	ld hl,LIFESTAR	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$0438	
	ld hl,LIFESTAR	
	CALL_(drawit2)
	CALL_(DELAY)
	CALL_(DRAWANGEL)
	CALL_(DRAWIATTACK)
	ld a,(ISISMP)  ;; subtract that used MP
	sub 24
	ld (ISISMP),a
	ld a,100
	ld (HPD),a
	CALL_(ERASEDARQ)
	CALL_(DISPALLHP)
	JUMP_(SPELLEND)
ATTKSPELL:

DEATHSPELL:
	ld a,(ISISMP)
	cp 45
	JUMP_C(NEEDMOREMP)		
	CALL_(DRAWIATTACK)
	ld de, $0103                    
             ld hl,Deathtext
             call DISPSTRING     
	CALL_(DEATHGRAP)
	CALL_(DELAY)
	ld b,30 
INVERTNOLOOP:
	push bc
	CALL_(INVERTSCREEN)
	pop bc
	djnz INVERTNOLOOP
	CALL_(ERASETEXT)
	CALL_(DEATHGRAP)	
	CALL_(DRAWIATTACK)
	ld a,(ISISMP)  ;; subtract that used MP
	sub 45
	ld (ISISMP),a
	ld c,229		;; damage = 15 +/- RAND	
	JUMP_(MAGICERASE)

MAGICERASE:
	CALL_(RAND2)	
	CALL_(DISPDAMAGE)
	ld hl,(ENEMYHP)
	ld de,0
	and a
	sbc hl,de
	jr z,MAGICHIT2
MAGICHIT:
	ld a,3
	ld (MAGICHK),a
	ld a,1
	ld (WHOTOATTACK),a
	ld a,(CHKDFD)
	ld c,a
	ld b,0
	ld hl,(ENEMYHP)
	and a
	sbc hl, bc
	ld (ENEMYHP),hl
	JUMP_Z(ENEMYDEAD1M)
	JUMP_C(ENEMYDEAD1M)
MAGICHIT2:
	ld a,1
	ld (MAGICHK),a
	ld hl,(ENEMYHP2)
	ld de,0
	and a
	sbc hl, de
	JUMP_Z(SPELLEND)
	ld a,2
	ld (WHOTOATTACK),a
	ld a,(CHKDFD)
	ld c,a
	ld b,0
	ld hl,(ENEMYHP2)
	and a
	sbc hl,bc
	ld (ENEMYHP2),hl
	JUMP_Z(ENEMYDEAD2M)
	JUMP_C(ENEMYDEAD2M)
	JUMP_(SPELLEND)
ENEMYDEAD2M:
	ld hl,0
	ld (ENEMYHP2),hl
	jr ENEMYDEADM
ENEMYDEAD1M:
	ld a,(LEADERORNO)
	or a
	JUMP_NZ(ERASELEADER)
	ld hl,0
	ld (ENEMYHP),hl
ENEMYDEADM:
	ld a,(ENEMY32)	
	or a
	JUMP_NZ(BIGERASE)
	CALL_(ERASEENEMY)		
BIGERASEDONEM:
	ld a,(NUMBEROFENEMIES)
	dec a	
	ld (NUMBEROFENEMIES),a
	or a
	JUMP_Z(ALLENEMYDEAD)
	ld a,(MAGICHK)
	cp 3
	jr z,MAGICHIT2
	JUMP_(SPELLEND)		
NEEDMOREMP:
	ld de,$0103                    
             ld hl,YOUNEEDMP
             call DISPSTRING     
	CALL_(DELAY3)
CANCELSPELL:
	CALL_(ENDREVERSAL)
	CALL_(ERASETEXT)
	CALL_(ERASEOF)
	CALL_(PUTNAME)
	JUMP_(SPEEDLOOP)
;---------------------
;---Magic END--
;---------------------

;--------------------
;Item BEGIN---
;--------------------
ITEM:
	CALL_(REVERSAL)
	CALL_(ERASEOF)
	ld bc,$2D3F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	ld a,(MEDKITS)
	or a
	jr z,NEXTITEM		
	ld de,$2D48		
             ld hl,itemmedkit
             call DISPSTRING
	LD DE,$2D59		
	ld a,(MEDKITS)	
	CALL_(DISPHL)		

NEXTITEM:	
	ld a,(MAGIKITS)
	or a
	jr z,ITEMLOOP
	ld de,$3448		
             ld hl,itemmagkit
             call DISPSTRING    
	LD DE,$3459		
	ld a,(MAGIKITS)	
	CALL_(DISPHL)		
	CALL_(DELAY)
ITEMLOOP:
	ld a,$3E
 	out (1),a
 	in a,(1)
 	bit 6,a
 	JUMP_Z(CANCELSPELL)
 	bit 5,a
 	JUMP_Z(ITEMPRESS)
	bit 3,a
 	JUMP_Z(ITEMUP)
 	bit 0,a
 	JUMP_Z(ITEMDOWN)
	jr ITEMLOOP
ITEMUP:
	ld a,(BKY)
	cp 45
	jr z,ITEMLOOP	
	ld bc,$343F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	ld bc,$2D3F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	CALL_(DELAY)
	jr ITEMLOOP
ITEMDOWN:
	ld a,(BKY)
	cp 52
	jr z,ITEMLOOP	
	ld bc,$2D3F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	ld bc,$343F	
	ld hl,CURSOR2	
	CALL_(drawit2)
	CALL_(DELAY)
	JUMP_(ITEMLOOP)
ITEMPRESS:
	ld a,(BKY)
	cp 52
	JUMP_Z(USEMAGIKIT)
USEMEDIKIT:
	ld a,(MEDKITS)
	or a
	JUMP_Z(ITEMLOOP)
	dec a
	ld (MEDKITS),a	
	ld b,3
MEDKITLOOP:
	push bc
	ld bc,$1432	
	ld hl,ITEMMEDKIT	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$1432	
	ld hl,ITEMMEDKIT	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$1432	
	ld hl,ITEMMEDKIT2	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$1432	
	ld hl,ITEMMEDKIT2	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$1432	
	ld hl,ITEMMEDKIT3	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$1432	
	ld hl,ITEMMEDKIT3	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$1432	
	ld hl,ITEMMEDKIT4	
	CALL_(drawit2)
	CALL_(DELAY3)
	ld bc,$1432	
	ld hl,ITEMMEDKIT4	
	CALL_(drawit2)
	pop bc
	djnz MEDKITLOOP1

	ld b,45
	ld a,(HPD)
	or a
	jr z,ISISMED
	add a,b
	ld (HPD),a
	CALL_(HPOVERMAXD)
ISISMED:
	ld b,45
	ld a,(HPI)
	or a
	jr z,ENDMED
	add a,b
	ld (HPI),a
	CALL_(HPOVERMAXI)
ENDMED:
	CALL_(DISPALLHP)
	JUMP_(ITEMEND)	
MEDKITLOOP1:
	JUMP_(MEDKITLOOP)
USEMAGIKIT:	
	ld a,(MAGIKITS)
	or a
	JUMP_Z(ITEMLOOP)
	dec a
	ld (MAGIKITS),a	
	ld b,14
MAGIKITLOOP:
	push bc
	ld bc,$1432	
	ld hl,ITEMMAGIKIT	
	CALL_(drawit2)	
	ld bc,$0C2A	
	ld hl,ITEMMAGIKIT	
	CALL_(drawit2)	
	ld bc,$0C3A	
	ld hl,ITEMMAGIKIT	
	CALL_(drawit2)	
	ld bc,$1C3A	
	ld hl,ITEMMAGIKIT	
	CALL_(drawit2)	
	ld bc,$1C2A	
	ld hl,ITEMMAGIKIT	
	CALL_(drawit2)	
	pop bc
	djnz MAGIKITLOOP
	ld b,30
	ld a,(DARQMP)
	add a,b
	ld (DARQMP),a
	CALL_(MPOVERMAXD)
	ld b,30
	ld a,(ISISMP)
	add a,b
	ld (ISISMP),a
	CALL_(MPOVERMAXI)
ITEMEND:
	ld bc,$3701	
	ld (BKX),bc
	CALL_(ERASEOF)
	CALL_(PUTNAME)
	JUMP_(ACTIONEND)

;--------------------
;---Item END---
;--------------------

DEFEND:
	ld de,$0103                    
	ld a,(WHOATTACK)
	or a
	jr z,ISISDEFENDS

	ld a,99
	ld (DEFENDOND),a
   	ld hl,DARQDEFEND
             call DISPSTRING
  	jr DFDCHOSEN
ISISDEFENDS:
	ld a,99
	ld (DEFENDONI),a
             ld hl,ISISDEFEND
             call DISPSTRING     
DFDCHOSEN:
	xor a
	ld (CHKDFD),a
	CALL_(REVERSAL)
REPLAY:
	ld a,(CHKDFD)	
	inc a
	ld (CHKDFD),a
	ld bc,$0528	
	ld hl,SHIELD1	
	CALL_(drawit2)
	ld bc,$0530	
	ld hl,SHIELD2	
	CALL_(drawit2)
	ld bc,$0538	
	ld hl,SHIELD3	
	CALL_(drawit2)
	ld bc,$0D28	
	ld hl,SHIELD4	
	CALL_(drawit2)
	ld bc,$0D30	
	ld hl,SHIELD5	
	CALL_(drawit2)
	ld bc,$0D38	
	ld hl,SHIELD6	
	CALL_(drawit2)
	ld bc,$1528	
	ld hl,SHIELD7	
	CALL_(drawit2)
	ld bc,$1530	
	ld hl,SHIELD8	
	CALL_(drawit2)
	ld bc,$1538	
	ld hl,SHIELD9	
	CALL_(drawit2)
	ld bc,$1D28	
	ld hl,SHIELD10	
	CALL_(drawit2)
	ld bc,$1D30	
	ld hl,SHIELD11	
	CALL_(drawit2)
	ld bc,$1D38	
	ld hl,SHIELD12	
	CALL_(drawit2)
	ld bc,$2530	
	ld hl,SHIELD13	
	CALL_(drawit2)
	CALL_(ENDREVERSAL)
	ld a,(CHKDFD)
	cp 2
	JUMP_Z(DEFENDEND)
	CALL_(DELAY)
	JUMP_(REPLAY)
DEFENDEND:
	CALL_(ERASETEXT)
ACTIONEND:
	CALL_(REVERSAL)
	ld a,(WHOATTACK)
	cp 1
	jr z,DARQEND
ISISEND:
	ld bc,$2F14
	ld hl,ERASURE	
	CALL_(drawit2)
	ld bc,$2F1B
	ld hl,ERASURE	
	CALL_(drawit2)
	ld a,21
	ld (COUNTER),a
	xor a
	ld (OKAY1),a
	CALL_(ENDREVERSAL)
	JUMP_(SWITCH)
DARQEND:
	ld bc,$3529
	ld hl,BLANK
	CALL_(drawit2)
	ld bc,$2F30	
	ld hl,ERASURE	
	CALL_(drawit2)
	ld a,41
	ld (COUNTER2),a
	xor a
	ld (OKAY2),a
	CALL_(ENDREVERSAL)
	JUMP_(SWITCH)
DELAY:
        ld a,$FF
        ld b,$FF
dloop:
        dec a
        jr nz,dloop
        dec b
        jr nz,dloop
        ret
DELAY2:
        ld a,$44
        ld b,$44
        jr dloop
DELAY3:
        ld a,$8F
        ld b,$8F
        jr dloop
DELAY4:
        ld a,$9F
        ld b,$9F
        jr dloop
ENDREVERSAL:
	ld a,(BKX1)
	ld (BKX),a
	ld a,(BKY1)	 
	ld (BKY),a
	RET
REVERSAL:
	ld a,(BKX)
	ld (BKX1),a
	ld a,(BKY)	
	ld (BKY1),a
	RET
ENEMYATTACK:
	ld hl,(ENEMYHP)
	ld de,0
	and a
	sbc hl,de
	jr z,ATTACKW2
	ld a,(ENEMYHP2)
	or a
	jr z,ATTACKW1

	ld a,(HITBYWHO)
	cp 1
	jr z,ATTACKW1
ATTACKW2:
	ld a,2
	ld (HITBYWHO),a
	ld a,(ENEMY2STR)
	ld (HIT),a
	jr REGO
ATTACKW1:
	ld a,1
	ld (HITBYWHO),a
	ld a,(ENEMY1STR)
	ld (HIT),a
REGO:	
	ld de,$0103                     
             ld hl,ENEMYATTACKS
            	call DISPSTRING     
	LD DE,$011A		
	ld a,(HITBYWHO)	
	CALL_(DISPHL)		
	xor a
	ld (ENEMYCOUNTER),a
	ld a,2
	ld a,(HITBYWHO)
	cp 1
	jr z,HITBY1
HITBY2:
	ld a,1
	ld (HITBYWHO),a
	jr GOON
HITBY1:
	ld a,2
	ld (HITBYWHO),a
GOON:
	call CR_GRBCopy
	CALL_(DELAY)
	CALL_(INVERTSCREEN)	
	CALL_(shake)
	CALL_(INVERTSCREEN)
	CALL_(ERASETEXT)
	ld a,(HPI)
	or a
	jr z,DARQHIT
	ld a,(HPD)
	or a
	jr z,ISISHIT
RANDX:		
	ld a,r
  	srl a
  	and 3          ; between 1-2
 	jr z,RANDX
  	sub 1
	jr z,RANDX
	cp 2		
	jr z,ISISHIT
DARQHIT:

	ld a,(DEFENDD)
	ld b,a
	ld a,(DEFENDOND)
	cp 99
	jr nz,DEFENDNTD
	xor a	
	ld (DEFENDOND),a
	ld a,b
	add a,a
	ld b,a
DEFENDNTD:
	ld a,(HIT)	
	sub b
	ld (HIT),a
	jr c,SETTO1
	jr z,SETTO1
	jr DARQHIT1
SETTO1:
	ld a,1
DARQHIT1:
	ld b,a
	ld a,(HPD)
	sub b
	ld (HPD),a
	JUMP_C(DARQDEAD)
	JUMP_Z(DARQDEAD)
	CALL_(DISPALLHP)
	JUMP_(RETURNATTK)
ISISHIT:
	ld a,(DEFENDI)
	ld b,a
	ld a,(DEFENDONI)
	cp 99
	jr nz,DEFENDNTI   ;;DEFEND N-ot T-rue (for) I-sis
	xor a	
	ld (DEFENDONI),a
	ld a,b
	add a,a
	ld b,a
DEFENDNTI:
	ld a,(HIT)	
	sub b
	ld (HIT),a
	jr c,SETTO11
	jr z,SETTO11
	jr ISISHIT1
SETTO11:
	ld a,1
ISISHIT1:	
	ld b,a
	ld a,(HPI)
	sub b
	ld (HPI),a
	JUMP_C(ISISDEAD)
	JUMP_Z(ISISDEAD)
	CALL_(DISPALLHP)
	JUMP_(RETURNATTK)
ISISDEAD:
	xor a
	ld (HPI),a
	CALL_(DISPALLHP)	
	ld de,$0103                    
            	ld hl,ISISFALLS
            	call DISPSTRING     
	xor a
	ld (ENEMYCOUNTER),a
	call CR_GRBCopy
	CALL_(DELAY)
	CALL_(DELAY)
	CALL_(ERASEISIS)
	CALL_(ERASETEXT)
	ld a,(HPD)
	or a
	JUMP_Z(GAMEOVER)
	res textInverse,(iy+textflags)
	ld de,$0753                   
            	ld hl,BLANKLIFE
            	call DISPSTRING
	res textInverse,(iy+textflags)
	;ld bc,$0655
	;ld hl,CURSOR
	;call drawit2

	ld b,88
	ld c,57
	CALL_(RemovePixel)
	CALL_(REVERSAL)
	ld a,(WHOATTACK)
	cp 1
	JUMP_Z(RETURNATTK)
	ld bc,$1C55	
	ld hl,CURSOR	
	CALL_(drawit2)
	CALL_(ENDREVERSAL)
	ld a,1
	ld (WHOATTACK),a
	JUMP_(RETURNATTK)
DARQDEAD:	
	xor a
	ld (HPD),a
	CALL_(DISPALLHP)	
	ld de,$0103                    
             ld hl,DARQFALLS
             call DISPSTRING     
	xor a
	ld (ENEMYCOUNTER),a
	call CR_GRBCopy
	CALL_(DELAY) 
	CALL_(DELAY)
	CALL_(ERASEDARQ)
	CALL_(ERASETEXT)
	ld a,(HPI)
	or a
	JUMP_Z(GAMEOVER)
	res textInverse,(iy+textflags)
	ld de,$1D53                   ;HERE********************************************
             ld hl,BLANKLIFE
             call DISPSTRING
	res textInverse,(iy+textflags)	
	;ld bc,$1C55
	;ld hl,CURSOR
	;call drawit2

	ld a,(WHOATTACK)
	or a
	JUMP_Z(RETURNATTK)
	ld b,88
	ld c,35
	CALL_(RemovePixel)
	CALL_(REVERSAL)
	ld bc,$0655	
	ld hl,CURSOR	
	CALL_(drawit2)
	CALL_(ENDREVERSAL)
	xor a
	ld (WHOATTACK),a
	JUMP_(RETURNATTK)
RAND2: ;; Random Damage
	ld a,r
  	srl a
  	and 3          ; between 1-2
	add a,c  	  	
	ld (CHKDFD),a  ;dummy variable
	RET
PUTENEMY:

RANDFORPUTENEMY:
  ld a,r
  srl a
  and 7   
  or a
  jr z,RANDFORPUTENEMY       
  cp 7
  jr z,RANDFORPUTENEMY       
  ld (WHICHENEMY),a
ROOMLESS8:
	ld a,(DUNGEON)
	cp 100
	JUMP_Z(DUNGEON1ENEMY)
	cp 124
	JUMP_Z(DUNGEON2ENEMY)
	cp 138
	JUMP_Z(DUNGEON3ENEMY)
	ld a,(ROOM)
	cp 24	
	JUMP_NC(ROOMGREATER24)
	ld a,34			;;Sets enemy speed for BOTH
	ld (ENEMYSPEED),a		;;enemies  	
	ld a,8
	ld (XPPOINTER),a

	ld hl,15
	ld (LIFEPOINTER),hl
	ld a,(WHICHENEMY)
	cp 1
	jr z,SLime
	cp 2
	jr z,CLown
	cp 3
	jr z,RObo
	cp 4
	jr z,WIsp
	ld a,(ENEMYHP)
	or a
	JUMP_NZ(RANDFORPUTENEMY)
	ld hl,32
	ld (LIFEPOINTER),hl
	ld a,(WHICHENEMY)
  	cp 5
	JUMP_Z(Big1)
	cp 6
	JUMP_Z(Big2)
CLown:
	ld a,8
	ld (STRENGTHPOINTER),a
	ld hl,ENEMY1AREA1
	ld (DISPENEMY),hl
	ld hl,Clown	
	JUMP_(STARTENEMY)
RObo:	
	ld a,9
	ld (STRENGTHPOINTER),a
	ld hl,ENEMY2AREA1
	ld (DISPENEMY),hl
	ld hl,Robo
	JUMP_(STARTENEMY)
SLime:
	ld a,10
	ld (STRENGTHPOINTER),a
	ld hl,ENEMY4AREA1
	ld (DISPENEMY),hl
	ld hl,Slime
	JUMP_(STARTENEMY)
WIsp:
	ld a,21		
	ld (ENEMYSPEED),a	
	ld a,7
	ld (STRENGTHPOINTER),a
	ld hl,ENEMY5AREA1
	ld (DISPENEMY),hl
	ld hl,Wisp
	JUMP_(STARTENEMY)
Big1:
	ld a,14
	ld (STRENGTHPOINTER),a
	ld hl,ENEMY3AREA1
	ld (DISPENEMY),hl
	ld hl,ENEMY3AREA1p2
	ld (ENEMY32),hl
	ld hl,Stinger
	JUMP_(BIGENEMY)
Big2:
	ld a,19
	ld (STRENGTHPOINTER),a
	ld hl,ENEMY6AREA1
	ld (DISPENEMY),hl
	ld hl,ENEMY6AREA1p2
	ld (ENEMY32),hl
	ld hl,Skeleton
	JUMP_(BIGENEMY)
	
KNight:
	ld hl,ENEMY1AREA2
	ld (DISPENEMY),hl
	ld hl,Knight
	JUMP_(STARTENEMY)
EYe:
	ld hl,ENEMY2AREA2
	ld (DISPENEMY),hl
	ld hl,Eye
	JUMP_(STARTENEMY)
HAwk:
	ld hl,ENEMY3AREA2
	ld (DISPENEMY),hl
	ld hl,Hawk
	JUMP_(STARTENEMY)
FLame:
	ld hl,ENEMY4AREA2
	ld (DISPENEMY),hl
	ld hl,Flame
	JUMP_(STARTENEMY)
DUNGEON1ENEMY:
	ld a,29			;;Sets enemy speed for BOTH
	ld (ENEMYSPEED),a		;;enemies  	
	ld a,17
	ld (XPPOINTER),a
	ld hl,60
	ld (LIFEPOINTER),hl
	ld a,20
	ld (STRENGTHPOINTER),a
	ld a,(WHICHENEMY)
	cp 1
	jr z,KNight
	cp 2
	jr z,EYe
	cp 3
	jr z,HAwk
	cp 4
	jr z,FLame
	ld a,(ENEMYHP)
	or a
	JUMP_NZ(RANDFORPUTENEMY)
	ld hl,32
	ld (LIFEPOINTER),hl
	ld a,(WHICHENEMY)
  	cp 5
	JUMP_Z(Big1)
	cp 6
	JUMP_Z(Big2)
ROOMGREATER24:
	ld a,(ROOM)
	cp 39	
	JUMP_NC(ROOMGREATER39)
	ld a,24			;;Sets enemy speed for BOTH
	ld (ENEMYSPEED),a		;;enemies  	
	ld a,27
	ld (XPPOINTER),a
	ld hl,125
	ld (LIFEPOINTER),hl
	ld a,38
	ld (STRENGTHPOINTER),a
	ld a,(WHICHENEMY)
	cp 1
	jr z,BEe
	cp 2
	jr z,MAsk
	cp 3
	jr z,TOrch
	cp 4
	jr z,SPider
BEe:
	ld hl,ENEMY1AREA3
	ld (DISPENEMY),hl
	ld hl,Bee
	JUMP_(STARTENEMY)
MAsk:
	ld hl,ENEMY2AREA3
	ld (DISPENEMY),hl
	ld hl,Mask
	JUMP_(STARTENEMY)
TOrch:
	ld hl,ENEMY3AREA3
	ld (DISPENEMY),hl
	ld hl,Torch
	JUMP_(STARTENEMY)
SPider:
	ld hl,ENEMY4AREA3
	ld (DISPENEMY),hl
	ld hl,Spider
	JUMP_(STARTENEMY)
DUNGEON2ENEMY:
	ld a,28			;;Sets enemy speed for BOTH
	ld (ENEMYSPEED),a		;;enemies  	
	ld a,35
	ld (XPPOINTER),a
	ld hl,145
	ld (LIFEPOINTER),hl
	ld a,47
	ld (STRENGTHPOINTER),a
	ld a,(WHICHENEMY)
	cp 1
	jr z,MAge
	cp 2
	jr z,MAsk
	cp 3
	jr z,TOrch
	cp 4
	jr z,KIss
	ld a,(ENEMYHP)
	or a
	JUMP_NZ(RANDFORPUTENEMY)
	ld a,(WHICHENEMY)
	cp 5
	jr z,Big3
	cp 6
	jr z,Big4
MAge:
	ld hl,ENEMY2AREA4
	ld (DISPENEMY),hl
	ld hl,Mage
	JUMP_(STARTENEMY)
KIss:
	ld hl,ENEMY1AREA4
	ld (DISPENEMY),hl
	ld hl,Kiss
	JUMP_(STARTENEMY)	
Big3:
	ld hl,ENEMY3AREA4
	ld (DISPENEMY),hl
	ld hl,ENEMY3AREA4p2
	ld (ENEMY32),hl
	ld hl,Head
	JUMP_(BIGENEMY)
Big4:
	ld hl,ENEMY4AREA4
	ld (DISPENEMY),hl
	ld hl,ENEMY4AREA4p2
	ld (ENEMY32),hl
	ld hl,Sun
	JUMP_(BIGENEMY)
JUnk:
	ld hl,ENEMY1AREA5
	ld (DISPENEMY),hl
	ld hl,Junk
	JUMP_(STARTENEMY)
ZOrg:
	ld hl,ENEMY2AREA5
	ld (DISPENEMY),hl
	ld hl,Zorg
	JUMP_(STARTENEMY)	

ROOMGREATER39:
DUNGEON3ENEMY:
	ld a,26			;;Sets enemy speed for BOTH
	ld (ENEMYSPEED),a		;;enemies  	
	ld a,60
	ld (XPPOINTER),a
	ld hl,210
	ld (LIFEPOINTER),hl
	ld a,100
	ld (STRENGTHPOINTER),a
	ld a,(WHICHENEMY)
	cp 1
	jr z,MAge
	cp 2
	jr z,KIss
	cp 3
	jr z,JUnk
	cp 4
	jr z,ZOrg
	ld a,(ENEMYHP)
	or a
	JUMP_NZ(RANDFORPUTENEMY)
	ld a,(WHICHENEMY)
	cp 5
	jr z,Big3
	cp 6
	jr z,Big4
BIGENEMY:
	ld (ENEMY1),hl
	ld hl,(LIFEPOINTER)
	ld (ENEMYHP),hl		;load enemy 1's life
	ld a,(STRENGTHPOINTER)
	ld (ENEMY1STR),a	;load enemy 1's strength
	ld a,(XPPOINTER)
	ld (ENEMY1XP),a
	ld de,$0D0D	
	ld hl,(DISPENEMY)	
	ld c,16
	CALL_(drawbig2)
	ld de,$0D15	
	ld hl,(ENEMY32)	
	ld c,16
	CALL_(drawbig2)
	ld de,$2C40
   	ld hl,(ENEMY1)         
             call DISPSTRING     
	ld a,1
	ld (NUMBEROFENEMIES),a
	RET
STARTENEMY:	
	ld a,(ECOUNTER)		;;Displays ENEMY2 after ENEMY1
	cp 26				;;is drawn.
	JUMP_Z(ENEMYNUMBER2)	
	ld (ENEMY1),hl
	ld a,(ECOUNTER)		;; draws the enemy	
	ld (BKX),a
	ld a,(ECOUNTER)		
	ld (BKY),a
	ld hl,(DISPENEMY)	;;ENEMY X AREA X (based on ROOM var)
	ld (ENEMYKILLED),hl	;; loads enemy into ENEMYKILLED
	CALL_(drawit)		;; so he can be erased easily
	ld hl,(LIFEPOINTER)
	ld (ENEMYHP),hl		;load enemy 1's life
	ld a,(STRENGTHPOINTER)
	ld (ENEMY1STR),a	;load enemy 1's strength
	ld a,(XPPOINTER) 
	ld (ENEMY1XP),a
	ld de,$2C40
   	ld   hl,(ENEMY1)         
             call DISPSTRING     
	ld a,(NUMBEROFENEMIES)  ;;Is there more than one ENEMY?
	cp 1			;;If so, continue...if not, RETURN
	RET Z
	ld a,26
	ld (ECOUNTER),a		
	JUMP_(RANDFORPUTENEMY)
ENEMYNUMBER2:	
	ld (ENEMY2),hl
	ld a,(ECOUNTER)		;; draws the enemy	
	ld (BKX),a
	ld a,(ECOUNTER)		
	ld (BKY),a
	ld hl,(DISPENEMY)	;;ENEMY X AREA X (based on ROOM var)
	ld (ENEMYKILLED2),hl	;; loads enemy into ENEMYKILLED
	CALL_(drawit)		;; so he can be erased easily
	ld hl,(LIFEPOINTER)
	ld (ENEMYHP2),hl		;; loads ENEMY 2's life
	ld a,(STRENGTHPOINTER)
	ld (ENEMY2STR),a	;; loads ENEMY 2's strength
	ld a,(XPPOINTER)
	ld (ENEMY2XP),a
	ld de,$3340
   	ld hl,(ENEMY2)      	
             call DISPSTRING     
	RET

BIGERASE:
	ld de,$2C40		
             ld hl,BLANKTEXT
             call DISPSTRING     
	LD de,$0D0D		
             ld hl,BLANKTEXT
             call DISPSTRING     
	LD de,$130D		
            	ld hl,BLANKTEXT
            	call DISPSTRING     
	LD de,$190D		
            	ld hl,BLANKTEXT
            	call DISPSTRING     
	LD de,$1F0D
            	ld hl,BLANKTEXT
           	call DISPSTRING     
	ld a,(MAGICHK)
	cp 3
	JUMP_Z(BIGERASEDONEM)
	JUMP_(BIGERASEDONE)
ERASEENEMY:
	CALL_(REVERSAL)
	ld a,(WHOTOATTACK)
	cp 1
	jr z,ERASE1	
	ld hl,(ENEMYKILLED2) 
	ld bc,$1A1A	
	CALL_(drawit2)
	ld de,$3340		
            	ld hl,BLANKTEXT
            	call DISPSTRING     
	CALL_(ENDREVERSAL)
	RET
ERASE1:
	ld hl,(ENEMYKILLED)
	ld bc,$0D0D	
	CALL_(drawit2)
	ld de,$2C40		
            	ld hl,BLANKTEXT
            	call DISPSTRING     
	CALL_(ENDREVERSAL)
	RET
ERASELEADER:
	ld a,9
	ld (CHKDFD),a
ERASELDRLOOP:
	ld l,9
	ld a,(CHKDFD)
	ld h,a
	ld (_penCol),hl
	
	ld a,(_penCol)
	add a,16
	ld (_penCol),a

           	ld hl,BLANKTEXT
            	call _vputs
	call CR_GRBCopy
	ld l,23
	ld a,(CHKDFD)
	ld h,a
	ld (_penCol),hl

	ld a,(_penCol)
	add a,16
	ld (_penCol),a

           	ld hl,BLANKTEXT
            	call _vputs
	call CR_GRBCopy
	ld a,(CHKDFD)
	inc a
	inc a
	ld (CHKDFD),a
	cp 39
	jr nz,ERASELDRLOOP
	JUMP_(ALLENEMYDEAD)

DISPALLHP:
	ld de,$3819                    
            	ld hl,BLANKLIFE
            	call DISPSTRING
	LD DE,$381A		
	ld a,(HPI)		
	CALL_(DISPHL)		
	ld de,$382D
           	ld hl,BLANKLIFE
            	call DISPSTRING
	LD DE,$382E
	ld a,(HPD)	
	CALL_(DISPHL)
	RET
ERASEDARQ:
	CALL_(REVERSAL)
	ld bc,$174A	
	ld hl,DARQ1	
	CALL_(drawit2)
	ld bc,$1F4A	
	ld hl,DARQ2
	CALL_(drawit2)
	ld bc,$1D52	
	ld hl,DARQ3
	CALL_(drawit2)
	ld b,73
	ld c,26
	CALL_(ChangePixel)
	ld b,82
	ld c,26
	CALL_(ChangePixel)
	CALL_(ENDREVERSAL)
	RET
ERASEISIS:
	CALL_(REVERSAL)
	ld bc,$044A	
	ld hl,ISIS1	
	CALL_(drawit2)
	ld bc,$0C4A	
	ld hl,ISIS2
	CALL_(drawit2)
	ld bc,$0952	
	ld hl,ISIS3
	CALL_(drawit2)
	CALL_(ENDREVERSAL)
	RET
GAMEOVER:
	ld a,(SCENARIO)
	cp 4
	jr z,NEWWORLD
	ld de,$0103
   	ld hl,YOULOSE         
          	call DISPSTRING     
	call WaitKey
	JUMP_(EXIT)	
NEWWORLD:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,weaklings
	call _puts
	call WaitKey	
	ld hl,$0203
	ld (_curRow),hl
	ld hl,thanx
	call _puts
	call WaitKey
	call _clrLCD
	ld a,31
	ld (ROOM),a	
	ld a,5
	ld (SCENARIO),a
SWITCHWORLDS:	
	CALL_(TIMEDISTORT)
	CALL_(DRAWWALLS)
	ld a,(HPIMAX)
	ld (HPI),a
	ld a,(HPDMAX)
	ld (HPD),a
	ld a,12
	ld (DOTY),a
	ld (COUNTER),a
	ld a,36
	ld (DOTX),a	
	ld hl,UP
	ld (Save),hl
	CALL_(moveit)
	CALL_(CHESTRESET)
	JUMP_(RELOADROOM)
TIMEDISTORT:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,time
	call _puts
	CALL_(DELAY)
	CALL_(DELAY)	
	ld hl,$0000			;load battle screen
	CALL_(BG)
	CALL_(INVERTSCREEN)	
	CALL_(shake)
	CALL_(shake)
	RET
CHESTRESET:
	xor a
	ld (CHEST1),a
	ld (CHEST2),a
	ld (CHEST3),a
	ld (CHEST4),a	
	RET
DRAWIATTACK2:
	CALL_(REVERSAL)
	ld bc,$0547	
	ld hl,ATTACKINUMBER2	
	CALL_(drawit2)
	ld b,83
	ld c,48
	CALL_(ChangePixel)
	ld b,82
	ld c,49
	CALL_(ChangePixel)
	CALL_(ENDREVERSAL)
	xor a
	RET
DRAWIATTACK:
	CALL_(REVERSAL)
	ld bc,$0745	
	ld hl,ISISATTACK	
	CALL_(drawit2)
	CALL_(ENDREVERSAL)
	RET
DRAWDATTACK:
	CALL_(REVERSAL)
	ld bc,$1B41	
	ld hl,DARQATTACK	
	CALL_(drawit2)
	ld bc,$1C49	
	ld hl,DARQATTACK2	
	CALL_(drawit2)
	ld b,82
	ld c,27
	CALL_(ChangePixel)
	ld b,82
	ld c,26
	CALL_(ChangePixel)
	ld b,81
	ld c,26
	CALL_(ChangePixel)
	CALL_(ENDREVERSAL)
	RET
INVERTSCREEN:
	xor a
	ld (CHKDFD),a
	ld c,4
	ld      hl,$FC00
invloop2:
	ld      b,0
invloop:
	ld      a,(hl)
	cpl
	ld      (hl),a
	inc     hl
	djnz invloop
	dec c
	jr nz,invloop2
	call CR_GRBCopy
	RET
DISPDAMAGE:
	ld a,(CHKDFD)
	ld DE,$0103
	CALL_(DISPHL)		
	ld de,$0110
   	ld hl,DAMAGE         
             call DISPSTRING     
	CALL_(DELAY)	
	CALL_(ERASETEXT)
	RET
HPOVERMAXD:
	ld a,(HPDMAX)
	ld c,a
	ld a,(HPD)
	sub c
	jr nc,HAIDESUNE
	RET
HAIDESUNE:
	ld a,(HPDMAX)
	ld (HPD),a
	RET
MPOVERMAXD:
	ld a,(MPDMAX)
	ld c,a
	ld a,(DARQMP)
	sub c
	jr nc,MAIDESUNE
	RET
MAIDESUNE:
	ld a,(MPDMAX)
	ld (DARQMP),a
	RET

HPOVERMAXI:
	ld a,(HPIMAX)
	ld c,a
	ld a,(HPI)
	sub c
	jr nc,HAIIDESUNE
	RET
HAIIDESUNE:
	ld a,(HPIMAX)
	ld (HPI),a
	RET

MPOVERMAXI:
	ld a,(MPIMAX)
	ld c,a
	ld a,(ISISMP)
	sub c
	jr nc,MAIIDESUNE
	RET
MAIIDESUNE:
	ld a,(MPIMAX)
	ld (ISISMP),a
	RET

SaveIt:
	ld hl,_asapvar

	rst 20h

	rst 10h

	ld a,b

	ld hl,SAVERAM-_asm_exec_ram+4

	add hl,de

	adc a,0

	call _set_abs_dest_addr

	xor a

	ld hl,SAVERAM

	call _set_abs_src_addr

	ld hl,58

	call _set_mm_num_bytes

	call _mm_ldir

	jp _ram_page_1


shake:
	ld hl,$FC00
	ld de,$B000
	ld bc,1024
	ldir
	ld      b,3
shakeloop:
	push    bc
	ld hl,$B020
	ld de,$FC00
	ld bc,$1024
	ldir
	CALL_(DELAY4)
	ld hl,$AFE0
	ld de,$FC00
	ld bc,1024
	ldir
	CALL_(DELAY4)
	pop     bc
	djnz    shakeloop
	ld hl,$B000
	ld de,$FC00
	ld bc,1024
	ldir
	RET
LEVELUPORNOT:
	ld a,1
	ld (WHOTOATTACK),a
	ld hl,(DARQXP)
	ld (XPCHECK),hl
	ld a,(DARQLVL)
	jr LVLCHK
ISISLVLCHK:
	xor a
	ld (WHOTOATTACK),a
	ld hl,(ISISXP)
	ld (XPCHECK),hl
	ld a,(ISISLVL)
LVLCHK:
	cp 1
	jr z,LEVEL1CHK
	cp 2
	jr z,LEVEL2CHK
	cp 3
	JUMP_Z(LEVEL3CHK)
	cp 4
	JUMP_Z(LEVEL4CHK)
	cp 5
	JUMP_Z(LEVEL5CHK)
	cp 6
	JUMP_Z(LEVEL6CHK)
	cp 7
	JUMP_Z(LEVEL7CHK)
	cp 8
	JUMP_Z(LEVEL8CHK)
	cp 9
	JUMP_Z(LEVEL9CHK)
	cp 10
	JUMP_Z(LEVEL10CHK)
	cp 11
	JUMP_Z(LEVEL10CHK)
	cp 12
	JUMP_Z(LEVEL10CHK)
	cp 13
	JUMP_Z(LEVEL10CHK)
	cp 14
	JUMP_Z(LEVEL10CHK)
	RET
LEVEL1CHK:
	ld hl,(XPCHECK)
	ld de,80
	and a
	sbc hl,de
	jp nc,ENDLVL
	JUMP_(NOLEVEL)
LEVEL2CHK:
	ld hl, (XPCHECK)
	ld de,300
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL3CHK:
	ld hl, (XPCHECK)
	ld de,650
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL4CHK:
	ld hl,(XPCHECK)
	ld de,1600
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL5CHK:
	ld hl,(XPCHECK)
	ld de,2450
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL6CHK:
	ld hl,(XPCHECK)
	ld de,3800
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL7CHK:
	ld hl,(XPCHECK)
	ld de,6000
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL8CHK:
	ld hl,(XPCHECK)
	ld de,10000
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL9CHK:
	ld hl,(XPCHECK)
	ld de,14000
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL10CHK:
	ld hl,(XPCHECK)
	ld de,20000
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL11CHK:
	ld hl,(XPCHECK)
	ld de,24000
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL12CHK:
	ld hl,(XPCHECK)
	ld de,30000
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL13CHK:
	ld hl,(XPCHECK)
	ld de,35000
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
LEVEL14CHK:
	ld hl,(XPCHECK)
	ld de,40000
	and a
	sbc hl,de
	JUMP_NC(ENDLVL)
	JUMP_(NOLEVEL)
ENDLVL:
	call _clrLCD
	ld a,(WHOTOATTACK)
	or a
	jr z,ISISUP
DARQUP:
	ld a,(DARQLVL)
	add a,6
	ld (CHKDFD),a
	ld c,a
	ld a,(HPDMAX)
	add a,c
	ld (HPDMAX),a
	ld (HPD),a
	ld a,(CHKDFD)
	ld c,a
	ld a,(MPDMAX)
	add a,c
	ld (MPDMAX),a
	ld (DARQMP),a
	ld a,(STRENGTHD)
	inc a
	inc a
	ld (STRENGTHD),a
	ld a,(DEFENDD)
	inc a
	inc a
	ld (DEFENDD),a
	ld a,(DARQLVL)
	inc a
	ld (DARQLVL),a
	ld hl,$0200
	ld (_curRow),hl
	ld hl,darq
	call _puts
	jr OKLVLUP
ISISUP:
	ld a,(ISISLVL)
	add a,6
	ld (CHKDFD),a
	ld c,a
	ld a,(HPIMAX)
	add a,c
	ld (HPIMAX),a
	ld (HPI),a
	ld a,(CHKDFD)
	ld c,a
	ld a,(MPIMAX)
	add a,c
	ld (MPIMAX),a
	ld (ISISMP),a
	ld a,(STRENGTHI)
	inc a
	inc a
	ld (STRENGTHI),a
	ld a,(DEFENDI)
	inc a
	inc a
	ld (DEFENDI),a
	ld a,(ISISLVL)
	inc a
	ld (ISISLVL),a
	ld hl,$0200
	ld (_curRow),hl
	ld hl,isis
	call _puts
OKLVLUP:
	ld hl,$0201
	ld (_curRow),hl
	ld hl,hasgainedlvl
	call _puts
             call WaitKey
NOLEVEL:
	ld a,(WHOTOATTACK)
	or a
	jp nz,ISISLVLCHK
	RET
DEATHGRAP:
	ld de,$1128	
	ld hl,SPELLDEATH	
	ld c,14
	CALL_(drawbig2)
	ld de,$1130	
	ld hl,SPELLDEATH2	
	ld c,14
	CALL_(drawbig2)
	RET
DRAWANGEL:
	ld de,$0F26
	ld hl,SPELLLIFE	
	ld c,23
	CALL_(drawbig2)	
	ld de,$0F2E	
	ld hl,SPELLLIFE2	
	ld c,23
	CALL_(drawbig2)
	ld de,$0F36	
	ld hl,SPELLLIFE3	
	ld c,23
	CALL_(drawbig2)
	RET

Description:
 .db "FFX4 v1.0",0


.end
