.plugin string86
;		     FINAL FANTASY X 4
;			   for the TI-86
;
; By Alex Highsmith
; TI-86 Version By Andreas Finne
;

#include "ti86asm.inc"
#include "ffx4.inc"


#DEFINE CALL_Z(ADDR)    call z,ADDR
#DEFINE CALL_(ADDR)     call ADDR
#DEFINE CALL_NZ(ADDR)   call nz,ADDR
#DEFINE CALL_C(ADDR)    call c,ADDR
#DEFINE CALL_NC(ADDR)   call nc,ADDR
#DEFINE JUMP_Z(ADDR)    jp z,ADDR
#DEFINE JUMP_(ADDR)     jp ADDR
#DEFINE JUMP_NZ(ADDR)   jp nz,ADDR
#DEFINE JUMP_C(ADDR)    jp c,ADDR
#DEFINE JUMP_NC(ADDR)   jp nc,ADDR



TEXT_MEM = _plotSScreen
TEXT_MEM2 = _plotSScreen+200


Save = TEXT_MEM2 	
LEFT = TEXT_MEM2+2 	;\
RIGHT = TEXT_MEM2+3	;| Checks walls to see if spaces
UP1 = TEXT_MEM2+4	;| exist or not
DOWN = TEXT_MEM2+5	;/
COUNTER =TEXT_MEM2+6
WHOATTACK = TEXT_MEM2+7
COUNTER2 = TEXT_MEM2+8

BKX = TEXT_MEM+5	;\   Coordinates for (drawit),
BKY = TEXT_MEM+6	;/   a simple sprite displayer
BKX1 = TEXT_MEM+7
BKY1 = TEXT_MEM+8
OKAY1 = TEXT_MEM+10
OKAY2 = TEXT_MEM+11
NUMBEROFENEMIES = TEXT_MEM+19
ENEMYKILLED = TEXT_MEM+20
ECOUNTER = TEXT_MEM+22
ENEMYCOUNTER = TEXT_MEM+24
ENEMYSPEED = TEXT_MEM+26
ENEMY1STR = TEXT_MEM+27
ENEMY2STR = TEXT_MEM+28
ENEMY1 = TEXT_MEM+29
ENEMY2 = TEXT_MEM+31
WHICHENEMY = TEXT_MEM+32
DISPENEMY = TEXT_MEM+33
STRENGTHPOINTER = TEXT_MEM+35
ENEMYKILLED2 = TEXT_MEM+37
HITBYWHO = TEXT_MEM+39
HIT = TEXT_MEM+41
ENEMY32 = TEXT_MEM+48
MAGIPAGE = TEXT_MEM+56
MAGICHK = TEXT_MEM+58 
DEFENDONI = TEXT_MEM+60
DEFENDOND = TEXT_MEM+61
ENEMYHP = TEXT_MEM+62
ENEMYHP2 = TEXT_MEM+64
LIFEPOINTER = TEXT_MEM+66
LEADERORNO = TEXT_MEM+68

XPCHECK = TEXT_MEM2+45
XPPOINTER = TEXT_MEM2+47
ENEMY1XP = TEXT_MEM2+49
ENEMY2XP = TEXT_MEM2+51
CHKDFD = TEXT_MEM2+53
WHOTOATTACK = TEXT_MEM2+55

ROOM = TEXT_MEM2+61	;<-- Tells what room you are in
DOTY = TEXT_MEM2+63	  
DOTX = TEXT_MEM2+64	  
HPDMAX = TEXT_MEM2+66
GOLD = TEXT_MEM2+68
MEDKITS = TEXT_MEM2+70
MAGIKITS = TEXT_MEM2+72
MPIMAX = TEXT_MEM2+74
MPDMAX = TEXT_MEM2+76
DEFENDD = TEXT_MEM2+78
DEFENDI = TEXT_MEM2+80
SCENARIO = TEXT_MEM2+82
DUNGEON = TEXT_MEM2+84
CHEST1 = TEXT_MEM2+85
CHEST2 = TEXT_MEM2+86
CHEST3 = TEXT_MEM2+87
CHEST4 = TEXT_MEM2+88
ISISLVL = TEXT_MEM2+89
DARQLVL = TEXT_MEM2+91
DARQMP = TEXT_MEM2+93
STRENGTHI = TEXT_MEM2+95
STRENGTHD = TEXT_MEM2+97
HPI = TEXT_MEM2+99
HPD = TEXT_MEM2+101
DARQXP = TEXT_MEM2+103
ISISXP = TEXT_MEM2+105
HPIMAX = TEXT_MEM2+107
ISISMP = TEXT_MEM2+109

.org $8100


;------------------------------------
;Building Check (Press Mode to Enter)
;------------------------------------


BUILDINGCHK:

	ld hl,$FC00
	ld de,$B000
	ld bc,1024
	ldir

	ld a,(DUNGEON)
	or a
	JUMP_NZ(DUNGEONCHK)
	ld a,(ROOM)
	cp 1
	JUMP_Z(KING)
	cp 5
	JUMP_Z(TOWN)
	cp 33
	JUMP_Z(TOWN)	
	cp 41
	JUMP_Z(TOWN)	
	cp 3
	jr z,WEAPONS
	cp 30
	jr z,WEAPONS
	cp 40
	jr z,WEAPONS
	cp 7
	JUMP_Z(CAVE1)
	cp 43
	JUMP_Z(CAVE1)
	cp 44
	JUMP_Z(PORTALX)
	cp 32
	JUMP_Z(PORTALX)
	cp 26
	JUMP_Z(TOWERX)
	cp 159
	jr z,SWITCH159
	JUMP_(GAMELOOP)
SWITCH159:
	ld a,(DOTX)
	cp 68
	JUMP_Z(KING)
	JUMP_(TOWN)
WEAPONS:
	ld a,(DOTX)
	cp 20
	JUMP_NZ(GAMELOOP)
	ld a,(DOTY)
	cp 12
	JUMP_NZ(GAMELOOP)	
BEGINWPNARMR:
	call _clrLCD
	ld hl,$0000
	ld (_curRow),hl
	ld hl,wpnshoptext
	set 3,(IY+05)
	call _puts
	ld hl,$0202
	ld (_curRow),hl
	ld hl,wpnshoptext2
	res 3,(IY+05)
	call _puts
WPNSHOPLOOP:
	call _getky
                    cp K_2
                    JUMP_Z(BUYARMOR)
                    cp K_1
                    JUMP_Z(BUYWEAPON)
                    cp K_3
                    JUMP_Z(DONEBUILD)
                    jr WPNSHOPLOOP
BUYARMOR:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,uparmor
	call _puts
	ld a,2 ;; 2==Player is buying Armor
	ld (CHKDFD),a	
	jr BUYDONE
BUYWEAPON:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,upweapon
	call _puts
	ld a,1 ;; 1==Player is buying Weapon
	ld (CHKDFD),a	
BUYDONE:
	CALL_(YOURGOLD)
	ld hl,$0202
	ld (_curRow),hl
	ld hl,wpnshoptext4
	call _puts
WPNSHOPLOOP2:
	call _getky
             cp K_2
             JUMP_Z(WAFORDARQ)
             cp K_1
             JUMP_Z(WAFORISIS)
             cp K_3
             JUMP_Z(BEGINWPNARMR)
             jr WPNSHOPLOOP2
WAFORDARQ:
	ld hl,(GOLD)
	ld de, 60
	and a
	sbc hl, de
	JUMP_C(NEEDGOLD)	
	ld (GOLD),hl
	CALL_(THANKYOU)
	ld a,(CHKDFD)
	cp 1
	jr z,WEAPONBOUGHTD
	ld a,(DEFENDD)
	add a,3		
	ld (DEFENDD),a
	JUMP_(BEGINWPNARMR)
WEAPONBOUGHTD:
	ld a,(STRENGTHD)	
	add a,3		
	ld (STRENGTHD),a	
	JUMP_(BEGINWPNARMR)
WAFORISIS:
	ld hl,(GOLD)
	ld de, 60
	and a
	sbc hl, de
	JUMP_C(NEEDGOLD)	
	ld (GOLD),hl
	CALL_(THANKYOU)
	ld a,(CHKDFD)
	cp 1
	jr z,WEAPONBOUGHTI
	ld a,(DEFENDI)
	add a,3		
	ld (DEFENDI),a
	JUMP_(BEGINWPNARMR)
WEAPONBOUGHTI:
	ld a,(STRENGTHI)	
	add a,3		
	ld (STRENGTHI),a	
	JUMP_(BEGINWPNARMR)
NEEDGOLD:
	ld hl,$0200
	ld (_curRow),hl
	ld hl,youneedg
	call _puts
	call WaitKey		
	JUMP_(BEGINWPNARMR)
THANKYOU:
	call _clrLCD
	ld hl,$0203
	ld (_curRow),hl
	ld hl,thankmessage
	call _puts
	call WaitKey		
	RET
KING:
	ld a,(DOTX)
	cp 68
	JUMP_NZ(GAMELOOP)
	ld a,(DOTY)
	cp 36
	JUMP_NZ(GAMELOOP)	
	ld a,(ROOM)
	cp 159
	jr nz,NOTENDOFGAME
	ld a,160
	JUMP_(DUNGEONJUMP)
NOTENDOFGAME:
	call _clrLCD
	ld hl,$0000
	ld (_curRow),hl
	ld hl,throne
	set 3,(IY+05)
	call _puts
	res 3,(IY+05)
	ld a,(SCENARIO)
	cp 3
	jr z,MIDGAMECHANGE
	ld hl,$0202
	ld (_curRow),hl
	ld hl,kingsays
	call _puts
             call WaitKey
DONEBUILD:
	ld hl,$B000
	ld de,$FC00
	ld bc,1024
	ldir
	jp MOVELEFT
MIDGAMECHANGE:
	ld hl,$0202
	ld (_curRow),hl
	ld hl,kingsays1
	call _puts
             call WaitKey
	CALL_(DRAWWALLS)
	ld bc,$1E02
	ld hl,HANDp1
	CALL_(drawit2)
	ld de,$1C0A
	ld hl,HANDp2
	ld c,11
	CALL_(drawbig2)
	ld de,$1C12
	ld hl,HANDp3
	ld c,11
	CALL_(drawbig2)
	ld de,$1922
	ld hl,CRYSTAL
	ld c,18
	CALL_(drawbig2)
	ld de,$0608
   	ld hl,kingattacks         
             call DISPSTRING     
	call WaitKey
	ld de,$0E0B
   	ld hl,kingattacks2         
             call DISPSTRING     
	call WaitKey
	ld a,99
	ld (CHKDFD),a
	JUMP_(STARTBATTLE)
TOWN:
	ld a,(DOTX)
	cp 52
	JUMP_NZ(GAMELOOP)
	ld a,(DOTY)
	cp 28
	JUMP_NZ(GAMELOOP)
TOWNSTART:
	call _clrLCD
	ld hl,$0000
	ld (_curRow),hl
	set 3,(IY+05)
	ld a,(ROOM)
	cp 33
	jr z,TOWN2NAME
	cp 41
	jr z,TOWN3NAME
	cp 159
	jr z,TOWN4NAME
	ld hl,nameoftown1
	jr NAMEDONE
TOWN2NAME:
	ld hl,nameoftown2
	jr NAMEDONE
TOWN3NAME:
	ld hl,nameoftown3
	jr NAMEDONE
TOWN4NAME:
	ld hl,nameoftown4
NAMEDONE:
	call _puts
	ld hl,$0202
	ld (_curRow),hl
	ld hl,towntext1
	res 3,(IY+05)
	call _puts
	CALL_(YOURGOLD)
TOWNLOOP:
	call _getky
             cp K_1
             jr z,INN
             cp K_2
             jr z,ITEMSHOP
             cp K_3
             JUMP_Z(TALK)
	cp K_4 
             JUMP_Z(DONEBUILD)
	jr TOWNLOOP
INN:
	ld hl,(GOLD)
	ld de, 50
	and a
	sbc hl, de
	JUMP_C(NEEDGOLD2)	
	ld (GOLD),hl
	call _clrLCD
	ld hl,$0203
	ld (_curRow),hl
	ld hl,restored
	call _puts
	call WaitKey		
	ld a,(HPIMAX)
	ld (HPI),a
	ld a,(MPIMAX)
	ld (ISISMP),a
	ld a,(HPDMAX)
	ld (HPD),a
	ld a,(MPDMAX)
	ld (DARQMP),a
	JUMP_(TOWNSTART)	
ITEMSHOP:
	call _clrLCD
	ld hl,$0000
	ld (_curRow),hl
	ld hl,towntext3
	set 3,(IY+05)
	call _puts
	ld hl,$0202
	ld (_curRow),hl
	ld hl,towntext2
	res 3,(IY+05)
	call _puts
	CALL_(YOURGOLD)
TOWNLOOP2:
	call _getky
                    cp K_2
                    jr z,BUYMAGKIT
                    cp K_1
                    jr z,BUYMEDKIT
                    cp K_3
                    JUMP_Z(TOWNSTART)
	jr TOWNLOOP2
BUYMAGKIT:
	ld hl,(GOLD)
	ld de, 30
	and a
	sbc hl, de
	jr c,NEEDGOLD2	
	ld (GOLD),hl
	ld a,(MAGIKITS)
	inc a
	ld (MAGIKITS),a
	CALL_(THANKYOU)
	JUMP_(ITEMSHOP)	
BUYMEDKIT:
	ld hl,(GOLD)
	ld de, 30
	and a
	sbc hl, de
	jr c,NEEDGOLD2	
	ld (GOLD),hl
	ld a,(MEDKITS)
	inc a
	ld (MEDKITS),a
	CALL_(THANKYOU)
	JUMP_(ITEMSHOP)	
TALK:	
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld a,(ROOM)
	cp 33
	jr z,TALK2
	cp 41
	jr z,TALK3
	cp 159
	jr z,TALK4
	ld hl,cave1
	jr TALKDONE
TALK2:
	ld hl,towntalk2
	jr TALKDONE
TALK3:
	ld hl,towntalk3
	jr TALKDONE
TALK4:
	ld hl,towntalk4
TALKDONE:
	call _puts
	call WaitKey
	JUMP_(TOWNSTART)
NEEDGOLD2:
	ld hl,$0200
	ld (_curRow),hl
	ld hl,youneedg
	call _puts
	call WaitKey		
	JUMP_(TOWNSTART)	
YOURGOLD:

	xor a
	
	ld h,11		;9
	ld l,7
	ld (_curRow),hl
	ld hl,(GOLD)
	call _dispAHL
	ld hl,$0207
	ld (_curRow),hl
	ld hl,yourg
	call _puts
	RET
CAVE1:
	ld a,(ROOM)
	cp 43
	jr z,DUNGEON3
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,cave1
	call _puts
	call WaitKey
	ld a,100
	jr DUNGEONJUMP
DUNGEON3:
	ld a,138
	ld (ROOM),a
	jr DUNGEONJUMP
DUNGEONJUMP:
	ld (ROOM),a	
	ld (DUNGEON),a
	CALL_(DRAWWALLS)
	ld a,52
	ld (DOTY),a
	ld (BKY),a
	ld a,44
	ld (DOTX),a	
	ld (BKX),a
	ld hl,UP
	ld (Save),hl
	CALL_(drawit)
	JUMP_(RELOADROOM)
PORTALX:
	ld a,(DOTX)
	cp 68
	JUMP_NZ(GAMELOOP)
	ld a,(DOTY)
	cp 36
	JUMP_NZ(GAMELOOP)	
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld a,(SCENARIO)
	cp 8
	jr z,PORTALX2
	cp 9
	jr z,PORTALX3
	ld hl,portal
	call _puts
	call WaitKey
	JUMP_(DONEBUILD)		
PORTALX2: ;; warp to diff world
	ld hl,runetext5
	call _puts
	call WaitKey
	ld a,40
	ld (ROOM),a
	JUMP_(SWITCHWORLDS)
PORTALX3: ;; warp to diff world
	ld hl,lastcrystal
	call _puts
	call WaitKey
	ld hl,$0201
	ld (_curRow),hl
	ld hl,thewayhome
	call _puts
	call WaitKey
	ld a,159
	ld (ROOM),a
	CALL_(SWITCHWORLDS)
TOWERX:
	ld a,(DOTX)
	cp 20
	JUMP_NZ(GAMELOOP)
	ld a,(DOTY)
	cp 12
	JUMP_NZ(GAMELOOP)	
	ld a,(SCENARIO)
	cp 5
	JUMP_NZ(TOWERSTART)
TALKRUNE:
	ld a,6
	ld (SCENARIO),a	
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,runetext
	call _puts
	call WaitKey	
	ld hl,$0203
	ld (_curRow),hl
	ld hl,runetext2
	call _puts
	call WaitKey	
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,runetext3
	call _puts
	call WaitKey	
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,runetext4
	call _puts
	call WaitKey	
TOWERSTART:
	ld a,124
	JUMP_(DUNGEONJUMP)
DUNGEONCHK:
	ld a,(ROOM)
	cp 112
	JUMP_Z(CHESTX)	
	cp 110
	JUMP_Z(CHESTX)	
	cp 108
	JUMP_Z(CHESTX)	
	cp 114
	JUMP_Z(CHESTX)	
	cp 121
	JUMP_Z(CHESTX)	
	cp 128
	JUMP_Z(CHESTX)	
	cp 130
	JUMP_Z(CHESTX)	
	cp 132
	JUMP_Z(CHESTX)	
	cp 140
	JUMP_Z(CHESTX)	
	cp 145
	JUMP_Z(CHESTX)	
	cp 153
	JUMP_Z(CHESTX)	
STAIRWAY:
	ld a,(DOTX)
	cp 52
	JUMP_NZ(GAMELOOP)
	ld a,(DOTY)
	cp 28
	JUMP_NZ(GAMELOOP)
	ld a,(ROOM)
	cp 105
	jr z,switch105
	cp 104
	jr z,switch104
	cp 106
	jr z,switch106
	cp 115
	jr z,switch115
	cp 126
	jr z,switch126
	cp 123
	jr z,switch123
	cp 129
	jr z,switch129
	cp 131
	jr z,switch131
	cp 136
	jr z,switch136
	cp 137
	jr z,switch137
	cp 139
	jr z,switch139
	cp 143
	jr z,switch143
	cp 152
	jr z,switch152
	cp 148
	jr z,switch148
	cp 151
	jr z,switch151
	cp 155
	jr z,switch155
	JUMP_(GAMELOOP)
switch104:
	ld a,115
	jr STAIREND
switch105:
	ld a,106
	jr STAIREND
switch106:
	ld a,105
	jr STAIREND
switch115:
	ld a,104
	jr STAIREND
switch126:
	ld a,129
	jr STAIREND
switch123:
	ld a,131
	jr STAIREND
switch129:
	ld a,126
	jr STAIREND
switch131:
	ld a,123
	jr STAIREND
switch136:
	ld a,143
	jr STAIREND
switch137:
	ld a,152
	jr STAIREND
switch139:
	ld a,148
	jr STAIREND
switch143:
	ld a,136
	jr STAIREND
switch148:
	ld a,139
	jr STAIREND
switch152:
	ld a,137
	jr STAIREND
switch151:
	ld a,155
	jr STAIREND
switch155:
	ld a,151
	jr STAIREND
STAIREND:
	ld (ROOM),a
	CALL_(DRAWWALLS)
	ld a,28
	ld (DOTY),a
	ld (BKY),a
	ld a,44
	ld (DOTX),a	
	ld (BKX),a
	ld hl,UP
	ld (Save),hl
	CALL_(drawit)
	JUMP_(RELOADROOM)
CHESTX:
	ld a,(DOTX)
	cp 68
	JUMP_NZ(GAMELOOP)
	ld a,(DOTY)
	cp 20
	JUMP_NZ(GAMELOOP)
	ld a,(ROOM)
	cp 112	
	jr z,chest1x
	cp 110
	jr z,chest2x
	cp 108
	jr z,chest3x
	cp 114
	jr z,chest4x
	cp 121
	jr z,chest1x
	cp 128
	jr z,chest2x 
	cp 130
	jr z,chest3x
	cp 132
	jr z,chest4x	
	cp 140
	jr z,chest1x
	cp 145
	jr z,chest2x 
	cp 153
	jr z,chest3x
chest1x:
	ld a,(CHEST1)
	or a
	JUMP_NZ(GAMELOOP)
	ld a,1
	ld (CHEST1),a
	JUMP_(CHESTFOUND)
chest2x:
	ld a,(CHEST2)
	or a
	JUMP_NZ(GAMELOOP)
	ld a,1
	ld (CHEST2),a
	JUMP_(CHESTFOUND)
chest3x:
	ld a,(CHEST3)
	or a
	JUMP_NZ(GAMELOOP)
	ld a,1
	ld (CHEST3),a
	JUMP_(CHESTFOUND)
chest4x:
	ld a,(CHEST4)
	or a				
	JUMP_NZ(GAMELOOP)
	ld a,1
	ld (CHEST4),a
	ld a,(SCENARIO)
	inc a
	ld (SCENARIO),a
CHESTKEY:	
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,youfind
	call _puts
	ld hl,$0201
	ld (_curRow),hl
	ld hl,BLANKKEY
	call _puts
	JUMP_(ITSFOUND)

CHESTFOUND:	
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,youfind
	call _puts
RANDTREASURE:
  ld a,r
  srl a
  and 3   
  or a
  jr z,RANDTREASURE	
	cp 1
	jr z,FGOLD
	cp 2
	jr z,FITEM
	cp 3
	jr z,FSCROLL
FSCROLL
	ld hl,$0201
	ld (_curRow),hl
	ld hl,BLANKSCROLL
	call _puts
	ld a,(ISISLVL)
	ld b,a
	ld hl,0
	ld de,30
MULTLOOPXP:
	add hl,de	
	djnz MULTLOOPXP
	push hl
	ld bc,(DARQXP)
	add hl,bc
	ld (DARQXP),hl
	pop hl
	ld bc,(ISISXP)
	add hl,bc
	ld (ISISXP),hl
	JUMP_(ITSFOUND)
FITEM:
	ld hl,$0201
	ld (_curRow),hl
	ld hl,BLANKITEM
	call _puts
	ld a,(MEDKITS)
	inc a
	ld (MEDKITS),a
  ld a,r
  srl a
  and 3   
  cp 2
  jr nz,ITSFOUND
	ld a,(MAGIKITS)
	inc a
	ld (MAGIKITS),a
	ld hl,$0202
	ld (_curRow),hl
	ld hl,BLANKITEM2
	call _puts
	jr ITSFOUND
FGOLD:
	ld hl,$0201
	ld (_curRow),hl
	ld hl,BLANKGOLD
	call _puts
	ld a,(ISISLVL)
	ld b,a
	ld hl,0
	ld de,30
MULTLOOPGOLD:
	add hl,de	
	djnz MULTLOOPGOLD
	ld bc,(GOLD)
	add hl,bc
	ld (GOLD),hl
	CALL_(YOURGOLD)
ITSFOUND:
	call WaitKey	
	CALL_(DRAWWALLS)
	ld a,20
	ld (DOTY),a
	ld (BKY),a
	ld a,68
	ld (DOTX),a	
	ld (BKX),a
	ld hl,UP
	ld (Save),hl
	CALL_(drawit)
	JUMP_(RELOADROOM)

;------------------
; Sprite Stuff....
;------------------

moveit:
	ld (Save), HL
        ld 	a,(DOTY)
	ld      e,a       	 ; Load the y-coordinate in e
	ld      a,(DOTX)	 ; Load the x-coordinate in a

	add a,16

DRWSPR:
        push    hl              ; Save sprite address

;   Calculate the address in graphbuf   

        ld      hl,0            ; Do y*16
        ld      d,0
        ex de,hl
        add     hl,hl
        add     hl,hl
        add     hl,hl
        add     hl,hl

        ld      d,0             ; Do x/8
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de

        ld      de,$FC00
        add     hl,de           ; Add address to graphbuf

        ld      b,00000111b     ; Get the remainder of x/8
        and     b
        cp      0               ; Is this sprite aligned to 8*n,y?
        jr      z,ALIGN

;   Non aligned sprite blit starts here   

        pop     ix              ; ix->sprite
        ld      d,a             ; d=how many bits to shift each line

        ld      e,8             ; Line loop
LILOP:  ld      b,(ix+0)        ; Get sprite data

        ld      c,0             ; Shift loop
        push    de
SHLOP:  srl     b
        rr      c
        dec     d
        jr      nz,SHLOP
        pop     de

	ld      a,b             ; Write line to graphbuf
        xor      (hl)
        ld      (hl),a
        inc     hl
        ld      a,c
        xor       (hl)
        ld      (hl),a
        ld      bc,15           ; Calculate next line address
        add     hl,bc
        inc     ix              ; Inc spritepointer

        dec     e
        jr      nz,LILOP        ; Next line
        jr DONE5

;   Aligned sprite blit starts here   

ALIGN:                          ; Blit an aligned sprite to graphbuf
        pop     de              ; de->sprite
        ld      b,8
ALOP1:  

	ld      a,(de)
	xor      (hl)
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,16
        add     hl,bc
        pop     bc
        djnz    ALOP1
DONE5:
	ld	c,a
	ld	a,e
	add	a,1
	ld	e,a
	ld	a,c
	add	a,1
        call CR_GRBCopy
	RET
drawit2:
	ld (BKX),bc
drawit:
        ld a,(BKY)
	ld      e,a       	 ; Load the y-coordinate in e
	ld      a,(BKX)	 ; Load the x-coordinate in a

    	push	af
	push	bc
	push	de
	push	hl

	add a,16


DRWSPR2:
        push    hl              ; Save sprite address

;   Calculate the address in graphbuf   

        ld      hl,0            ; Do y*16
        ld      d,0
        ex de,hl
        add     hl,hl
        add     hl,hl
        add     hl,hl
        add     hl,hl

        ld      d,0             ; Do x/8
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de

        ld      de,$FC00
        add     hl,de           ; Add address to graphbuf

        ld      b,00000111b     ; Get the remainder of x/8
        and     b
        cp      0               ; Is this sprite aligned to 8*n,y?
        jr      z,ALIGN2


;   Non aligned sprite blit starts here   

        pop     ix              ; ix->sprite
        ld      d,a             ; d=how many bits to shift each line

        ld      e,8             ; Line loop
LILOP2:  ld      b,(ix+0)        ; Get sprite data

        ld      c,0             ; Shift loop
        push    de
SHLOP2:  srl     b
        rr      c
        dec     d
        jr      nz,SHLOP2
        pop     de
	ld      a,b             ; Write line to graphbuf
        xor      (hl)
        ld      (hl),a
        inc     hl
        ld      a,c
        xor      (hl)
        ld      (hl),a
        ld      bc,15           ; Calculate next line address
        add     hl,bc
        inc     ix              ; Inc spritepointer

        dec     e
        jr      nz,LILOP2        ; Next line
	jr      DONE2

;   Aligned sprite blit starts here   

ALIGN2:                          ; Blit an aligned sprite to graphbuf
        pop     de              ; de->sprite
        ld      b,8
ALOP2:  
	ld      a,(de)
	xor      (hl)
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,16
        add     hl,bc
        pop     bc
        djnz    ALOP2
DONE2:
	pop	de
	pop	bc
	pop	af
	pop 	hl
	ld	c,a
	ld	a,e
	add	a,1
	ld	e,a
	ld	a,c
	add	a,1
        call CR_GRBCopy
	RET

PutPixel:		;changes the pixel at b, c
	call Find_Pixel
	or (hl)
	ld (hl), a
        	call CR_GRBCopy
	RET

RemovePixel:		;Removes the pixel at b, c
	call Find_Pixel
	cpl
	and (hl)
	ld (hl), a
                    call CR_GRBCopy
	RET
ChangePixel:
	call Find_Pixel
	xor (hl)
	ld (hl), a
                    call CR_GRBCopy
	RET
DISPHL:
	ld l,a
	ld h,0
DM_HL_DECI:
	ld a,e
	add a,16
	ld e,a

  ld   (_penCol),de          ;Since DE is a word, it overlaps into 8216
  ld b,48                  ; 48 -> b
  ld c,4                   ; 4 -> c
  ld a,h                   ; h -> a
  or l                     ; If a=0 and l=0, then return zero
  jr z,DM_HL_3             ; If zero, then jump to DM_HL_3
  ld c,-1                  ; -1 -> c
  ld b,46                  ; 46 -> b
  jr DM_HL_NEXT2           ; Jump to DM_HL_NEXT2
DM_HL_INIT:
  call _cphlde             ; cp hl,de
  jr c,DM_HL_NEXT2         ; If carry, then jump to DM_HL_NEXT2
  dec c                    ; c = c - 1
DM_HL_NEXT:
  ld b,47                  ; 47 -> b
DM_HL_NEXT2:
  inc c                    ; c = c + 1
  ld a,c                   ; c -> a
  or a                     ; If a=0, then return zero
  ld de,10000              ; 10000 -> de
  jr z,DM_HL_2a            ; If zero, then jump to DM_HL_2a
  cp 1                     ; If a=1, then return zero
  ld de,1000               ; 1000 -> de
  jr z,DM_HL_2a            ; If zero, then jump to DM_HL_2a
  cp 2                     ; If a=2, then return zero
  ld de,100                ; 100 -> de
  jr z,DM_HL_2a            ; If zero, then jump to DM_HL_2a
  cp 3                     ; If a=3, then return zero
  ld de,10                 ; 10 -> de
  jr z,DM_HL_2a            ; If zero, then jump to DM_HL_2a
  ld de,1                  ; 1 -> de
DM_HL_2a:
  ld a,b                   ; b -> a
  cp 46                    ; If a=46, then return zero
  jr z,DM_HL_INIT          ; If zero, then jump to DM_HL_INIT
DM_HL_2b:
  inc b                    ; b = b + 1
  call _cphlde             ; cp hl,de
  jr c,DM_HL_3             ; If carry, then jump to DM_HL_3
  or a                     ; Reset carry flag
  sbc hl,de                ; hl = hl - de
  jr DM_HL_2b              ; Jump to DM_HL_2b
DM_HL_3:
  ld a,b                   ; b -> a
  call _vputmap            ; Display the character
  ld a,c                   ; c -> a
  cp 4                     ; If a=4, then return zero
  jr nz,DM_HL_NEXT         ; If not zero, then jump to DM_HL_NEXT
  call CR_GRBCopy
  ret                      ; return to caller


;-----------------------
;load spaces in walls
;-----------------------

BORDERUP:
	ld a,1
	ld (UP1),a	
	ld bc,$002C
	ld hl,BLANK
	CALL_(drawit2)
	RET
BORDERDOWN:
	ld a,1
	ld (DOWN),a
	ld bc,$3E2C
	ld hl,BLANK
	CALL_(drawit2)
	RET
BORDERLEFT:
	ld a,1
	ld (LEFT),a
	ld bc,$1C00		
	ld hl,BLANK3
	CALL_(drawit2)
	RET
BORDERRIGHT:
	ld a,1
	ld (RIGHT),a
	ld bc,$1C58
	ld hl,BLANK2
	CALL_(drawit2)
	RET
drawbig2:
	ld (BKX),de
drawbig:
	ld a,(BKY)
	ld      e,a
	ld      a,(BKX)
	push	af
	push	bc
	push	de
	push	hl

	add a,16

DRWSPRX:
        	push    hl              ; Save sprite address
        	ld      hl,0            ; Do y*16
       	ld      d,0
        	ex de,hl
        	add     hl,hl
        	add     hl,hl
       	add     hl,hl
       	add     hl,hl
       	ld      d,0             ; Do x/8
       	ld      e,a
        	srl     e
        	srl     e
        	srl     e
        	add     hl,de
       	ld      de,$FC00
        	add     hl,de           ; Add address to graphbuf
        	ld      b,00000111b     ; Get the remainder of x/8
        	and     b
        	cp      0               ; Is this sprite aligned to 8*n,y?
        	jr      z,ALIGNX
        	pop     ix              ; ix->sprite
        	ld      d,a             ; d=how many bits to shift each line
        	ld      e,c             ; Line loop
LILOPX:  	
	ld      b,(ix+0)        ; Get sprite data
        	ld      c,0             ; Shift loop
        	push    de
SHLOPX:  
	srl     b
        	rr      c
        	dec     d
        	jr      nz,SHLOPX
        	pop     de
	ld      a,b             ; Write line to graphbuf
       	xor      (hl)
        	ld      (hl),a
        	inc     hl
        	ld      a,c
        	xor      (hl)
        	ld      (hl),a
        	ld      bc,15           ; Calculate next line address
        	add     hl,bc
        	inc     ix              ; Inc spritepointer
        	dec     e
        	jr      nz,LILOPX        ; Next line
        	jr      DONEX
ALIGNX:                          ; Blit an aligned sprite to graphbuf
        	pop     de              ; de->sprite
        	ld      b,c
ALOPX:
	ld      a,(de)
	xor      (hl)
        	ld      (hl),a
        	inc     de
        	push    bc
        	ld      bc,16
        	add     hl,bc
        	pop     bc
        	djnz    ALOPX
DONEX: 
        	pop	de
        	pop	bc
        	pop	af
        	pop 	hl
       	ld	c,a
        	ld	a,e
        	add	a,1
        	ld	e,a
        	ld	a,c
        	add	a,1
       	call CR_GRBCopy
        	RET
ERASETEXT:
            	LD de,$0103		
            	ld hl,BLANKTEXT
            	call DISPSTRING    
	LD de,$011E		
            	ld hl,BLANKTEXT 
            	call DISPSTRING
	RET

EXIT:
      ;res     4,(IY+9)
      res     2,(iy+2)
	RET
BG:
	ld	de,$FC00
	ld	bc,1024
	ldir
	call CR_GRBCopy 		; Copy graphbuf to LCD
	ret
;---------------------
;Building Draws
;---------------------
BUILDINGDRAWS:
	ld a,(DUNGEON)
	or a
	JUMP_NZ(DUNGEONDRAWS)
	ld a,(ROOM)
	cp 7
	jr z,DRAWCAVE
	cp 43
	jr z,DRAWCAVE
	cp 3
	jr z,DRAWWPNSHOP
	cp 30
	jr z,DRAWWPNSHOP
	cp 40
	jr z,DRAWWPNSHOP
	cp 5
	jr z,DRAWTOWN
	cp 33
	jr z,DRAWTOWN
	cp 41 
	jr z,DRAWTOWN
	cp 1
	jr z,DRAWCASTLE
	cp 159
	jr z,DRAW159
	cp 32
	jr z,DRAWPORTAL
	cp 44
	jr z,DRAWPORTAL
	cp 26
	jr z,DRAWTOWER
	RET
DRAWCASTLE:
	ld bc,$2444
	ld hl,CASTLE
	CALL_(drawit2)	
	RET
DRAWWPNSHOP:
	ld bc,$0C14
	ld hl,WPNSHOP
	CALL_(drawit2)	
	RET
DRAWTOWN:
	ld bc,$1C34
	ld hl,TOWNPIC
	CALL_(drawit2)	
	RET
DRAWCAVE:
	ld bc,$040C
	ld hl,CAVE
	CALL_(drawit2)	
	RET
DRAWPORTAL:
	ld bc,$2444
	ld hl,PORTAL
	CALL_(drawit2)	
	RET
DRAWTOWER:
	ld bc,$0C14
	ld hl,TOWER
	CALL_(drawit2)	
	RET
DRAW159:
	CALL_(DRAWCASTLE)
	CALL_(DRAWTOWN)
	RET
DUNGEONDRAWS:
	ld a,(ROOM)	
	cp 105
	jr z,STAIRS	
	cp 106
	jr z,STAIRS	
	cp 104
	jr z,STAIRS	
	cp 115
	jr z,STAIRS	
	cp 126
	jr z,STAIRS	
	cp 123
	jr z,STAIRS	
	cp 129
	jr z,STAIRS	
	cp 131
	jr z,STAIRS	
	cp 136
	jr z,STAIRS	
	cp 137
	jr z,STAIRS	
	cp 139
	jr z,STAIRS	
	cp 143
	jr z,STAIRS	
	cp 148
	jr z,STAIRS	
	cp 152
	jr z,STAIRS	
	cp 155
	jr z,STAIRS	
	cp 151
	jr z,STAIRS	
	jr nostairs
STAIRS:
	ld bc,$1C34
	ld hl,STAIRZ
	CALL_(drawit2)	
	RET		
nostairs:
	cp 112
	jr z,CHESTZ112	
	cp 110
	jr z,CHESTZ110	
	cp 108
	jr z,CHESTZ108	
	cp 114
	jr z,CHESTZ114	
	cp 121
	jr z,CHESTZ112	
	cp 128
	jr z,CHESTZ110	
	cp 130
	jr z,CHESTZ108	
	cp 132
	jr z,CHESTZ114	
	cp 140
	jr z,CHESTZ112	
	cp 145
	jr z,CHESTZ110	
	cp 153
	jr z,CHESTZ108	
	RET
CHESTZ112:	
	ld a,(CHEST1)
	cp 1
	RET Z
	jr CHESTZ
CHESTZ110:	
	ld a,(CHEST2)
	cp 1
	RET Z
	jr CHESTZ
CHESTZ108:	
	ld a,(CHEST3)
	cp 1
	RET Z
	jr CHESTZ
CHESTZ114:	
	ld a,(CHEST4)
	cp 1
	RET Z
	jr CHESTZ
CHESTZ:
	ld bc,$1444
	ld hl,CHEST
	CALL_(drawit2)	
	RET		

;------------
; ROOM DRAWS
;------------

ROOM1:
	CALL_(BORDERUP)
	CALL_(BORDERDOWN)
	CALL_(BORDERRIGHT)
	CALL_(BORDERLEFT)
	JUMP_(GAMELOOP)
ROOM2:
	CALL_(BORDERUP)
	CALL_(BORDERDOWN)
	JUMP_(GAMELOOP)
ROOM3:
	CALL_(BORDERLEFT)
	JUMP_(GAMELOOP)
ROOM4:
	CALL_(BORDERUP)
	JUMP_(GAMELOOP)
ROOM5:
	CALL_(BORDERRIGHT)
	JUMP_(GAMELOOP)
ROOM6:
	CALL_(BORDERUP)
	CALL_(BORDERDOWN)
	CALL_(BORDERLEFT)
	JUMP_(GAMELOOP)	
ROOM7:
	CALL_(BORDERDOWN)
	JUMP_(GAMELOOP)
ROOM8:
	CALL_(BORDERLEFT)
	CALL_(BORDERRIGHT)
	JUMP_(GAMELOOP)
ROOM9:
	CALL_(BORDERUP)
	CALL_(BORDERDOWN)
	CALL_(BORDERRIGHT)
	JUMP_(GAMELOOP)	
ROOM12:
	CALL_(BORDERUP)
	CALL_(BORDERLEFT)
	JUMP_(GAMELOOP)	
ROOM102:
	CALL_(BORDERDOWN)
	CALL_(BORDERLEFT)
	CALL_(BORDERRIGHT)
	JUMP_(GAMELOOP)	
ROOM103:
	CALL_(BORDERDOWN)
	CALL_(BORDERLEFT)
	JUMP_(GAMELOOP)	
ROOM119:
	CALL_(BORDERUP)
	CALL_(BORDERRIGHT)
	JUMP_(GAMELOOP)	
ROOM129:
	CALL_(BORDERDOWN)
	CALL_(BORDERRIGHT)
	JUMP_(GAMELOOP)	

;-------------end of room draws----------------------

LOOM1:
	ld a,(DOTX)
	cp 84
	jr z,loom1rt
	cp 4	
	jr z,loom1lt
	ld a,(DOTY)
	cp 4
	jr z,loom1up
loom1dn:
	ld a,4
	JUMP_(LOOMTOROOM)
loom1up:
	ld a,2
	JUMP_(LOOMTOROOM)
loom1lt:
	ld a,5
	JUMP_(LOOMTOROOM)
loom1rt:
	ld a,3
	JUMP_(LOOMTOROOM)
LOOMto1:
	ld a,1
	JUMP_(LOOMTOROOM)
LOOM2:
	ld a,(DOTY)
	cp 4
	jr z,loom2up
	ld a,1
	JUMP_(LOOMTOROOM)
loom2up:
	ld a,6
	JUMP_(LOOMTOROOM)
LOOM6:
	ld a,(DOTX)
	cp 4	
	jr z,loom6lt
	ld a,(DOTY)
	cp 4
	jr z,loom6up
	ld a,2
	JUMP_(LOOMTOROOM)
loom6up:
	ld a,(SCENARIO)
	or a
	JUMP_Z(SCENARIO1)
	ld a,7
	JUMP_(LOOMTOROOM)
loom6lt:
	ld a,8
	JUMP_(LOOMTOROOM)
LOOM7:
	ld a,6
	JUMP_(LOOMTOROOM)
LOOM8:
	ld a,(DOTX)
	cp 84
	jr z,loom8rt
	ld a,9
	JUMP_(LOOMTOROOM)
loom8rt:
	ld a,6
	JUMP_(LOOMTOROOM)

LOOM9:
	ld a,(DOTY)
	cp 4
	jr z,loom9up
	cp 52
	jr z,loom9dn
	ld a,8
	JUMP_(LOOMTOROOM)
loom9up:
	ld a,11
	JUMP_(LOOMTOROOM)
loom9dn:
	ld a,10
	JUMP_(LOOMTOROOM)
		
LOOM10:
	ld a,9
	JUMP_(LOOMTOROOM)
LOOM11:
	ld a,(DOTX)
	cp 84
	jr z,loom11rt
	cp 4	
	jr z,loom11lt
	ld a,(DOTY)
	cp 4
	jr z,loom11up
	ld a,9
	JUMP_(LOOMTOROOM)
loom11up:
	ld a,14
	JUMP_(LOOMTOROOM)
loom11lt:
	ld a,15
	JUMP_(LOOMTOROOM)
loom11rt:
	ld a,12
	JUMP_(LOOMTOROOM)
LOOM12:
	ld a,(DOTX)
	cp 4
	jr z,loom12lt
	ld a,13
	JUMP_(LOOMTOROOM)
loom12lt:
	ld a,11
	JUMP_(LOOMTOROOM)
LOOM13:
	ld a,12
	JUMP_(LOOMTOROOM)
LOOMto11:
	ld a,11
	JUMP_(LOOMTOROOM)

LOOM25:
	ld a,(DOTX)
	cp 84
	jr z,loom25rt
	cp 4	
	jr z,loom25lt
	ld a,(DOTY)
	cp 4
	jr z,loom25up
loom25dn:
	ld a,28
	JUMP_(LOOMTOROOM)
loom25rt:
	ld a,32
	JUMP_(LOOMTOROOM)
loom25lt:
	ld a,27
	JUMP_(LOOMTOROOM)
loom25up:
	ld a,26
	JUMP_(LOOMTOROOM)
LOOMto25:
	ld a,25
	JUMP_(LOOMTOROOM)
LOOM28:
	ld a,(DOTY)
	cp 4
	jr z,LOOMto25
loom28rt:	
	ld a,29
	JUMP_(LOOMTOROOM)
LOOM29:
	ld a,(DOTX)
	cp 4	
	jr z,loom25dn
loom29dn:	
	ld a,30
	JUMP_(LOOMTOROOM)
LOOM30:
	ld a,(DOTY)
	cp 4
	jr z,loom28rt
loom30rt:	
	ld a,31
	JUMP_(LOOMTOROOM)
LOOM31:
	ld a,(DOTX)
	cp 4	
	jr z,loom29dn
loom31dn:	
	ld a,33
	JUMP_(LOOMTOROOM)
LOOM40:
	ld a,41
	JUMP_(LOOMTOROOM)
LOOM41:
	ld a,(DOTY)
	cp 52	
	jr z,loom41dn
loom41lt:
	ld a,42	
	JUMP_(LOOMTOROOM)
loom41dn:
	ld a,40	
	JUMP_(LOOMTOROOM)
LOOM42:
	ld a,(DOTX)
	cp 84
	jr z,LOOM40
loom42lt:
	ld a,43	
	JUMP_(LOOMTOROOM)
LOOM43:
	ld a,(DOTX)
	cp 84
	jr z,loom41lt
loom43lt:
	ld a,44	
	JUMP_(LOOMTOROOM)

LOOM100:	;; 100-120 are dungeon vars
	ld a,(DOTY)
	cp 52
	jr z,loom100dn
	ld a,101
	JUMP_(LOOMTOROOM)
loom100dn:
	ld a,7
	ld (ROOM),a
DUNGEONEXIT:
	CALL_(DRAWWALLS)
	ld a,12
	ld (DOTY),a
	ld (BKY),a
	ld a,4
	ld (BKX),a
	ld (DOTX),a
	ld hl,LT
	ld (Save),hl
	CALL_(drawit)	
	xor a
	ld (DUNGEON),a
	JUMP_(RELOADROOM)
LOOM101:
	ld a,(DOTY)
	cp 52
	jr z,loom101dn
loom101up:
	ld a,102
	JUMP_(LOOMTOROOM)
loom101dn:	
	ld a,100
	JUMP_(LOOMTOROOM)
LOOM102:
	ld a,(DOTX)
	cp 84
	jr z,loom102rt
	cp 4	
	jr z,loom102lt
	ld a,101
	JUMP_(LOOMTOROOM)
loom102lt:	
	ld a,105
	JUMP_(LOOMTOROOM)
loom102rt:
	ld a,103
	JUMP_(LOOMTOROOM)
LOOM103:
	ld a,(DOTX)
	cp 4	
	jr z,loom101up
	ld a,104
	JUMP_(LOOMTOROOM)
LOOM105:
	ld a,102
	JUMP_(LOOMTOROOM)
LOOM106:
	ld a,(DOTX)
	cp 84
	jr z,loom106rt
	cp 4	
	jr z,loom106lt
	ld a,(DOTY)
	cp 4
	jr z,loom106up
loom106dn:
	ld a,107
	JUMP_(LOOMTOROOM)
loom106up:
	ld a,111
	JUMP_(LOOMTOROOM)
loom106lt:
	ld a,113
	JUMP_(LOOMTOROOM)
loom106rt:
	ld a,109
	JUMP_(LOOMTOROOM)
LOOM109:
	ld a,(DOTX)
	cp 4
	jr z,loom109lt
	ld a,110
	JUMP_(LOOMTOROOM)
loom109lt:
	ld a,106
	JUMP_(LOOMTOROOM)
LOOM113:
	ld a,(DOTX)
	cp 84
	jr z,loom109lt
	ld a,114
	JUMP_(LOOMTOROOM)
LOOM111:
	ld a,(DOTY)
	cp 52
	jr z,loom109lt
	ld a,112
	JUMP_(LOOMTOROOM)
LOOM107:
	ld a,(DOTY)
	cp 4
	jr z,loom109lt
	ld a,108
	JUMP_(LOOMTOROOM)
LOOM115:
	ld a,116
	JUMP_(LOOMTOROOM)
LOOM116:
	ld a,(DOTY)
	cp 4
	jr z,loom116up
	ld a,115
	JUMP_(LOOMTOROOM)
loom116up:	
	ld a,117
	JUMP_(LOOMTOROOM)
LOOM117:
	ld a,(DOTY)
	cp 52
	jr z,LOOM115
loom117up:	
	ld a,118
	JUMP_(LOOMTOROOM)
LOOM118:
	ld a,(DOTY)
	cp 52
	jr z,loom116up
loom118lt:	
	ld a,119
	JUMP_(LOOMTOROOM)
LOOM119:
	ld a,(DOTX)
	cp 84
	jr z,loom117up
	ld a,(SCENARIO)
	cp 3	
	JUMP_C(SCENARIO2)	
	ld a,120
	JUMP_(LOOMTOROOM)	

LOOM124:
	ld a,(DOTY)
	cp 52
	jr z,loom124dn
loom124up:
	ld a,125
	JUMP_(LOOMTOROOM)
loom124dn:
	ld a,26
	ld (ROOM),a
	JUMP_(DUNGEONEXIT)
LOOM125:
	ld a,(DOTX)
	cp 84
	jr z,loom125rt
	cp 4	
	jr z,loom125lt
loom125dn:
	ld a,124
	JUMP_(LOOMTOROOM)
loom125rt:
	ld a,126
	JUMP_(LOOMTOROOM)
loom125lt:
	ld a,122
	JUMP_(LOOMTOROOM)
LOOM122:
	ld a,(DOTX)
	cp 84
	jr z,loom124up
	cp 4	
	jr z,loom122lt
	ld a,121
	JUMP_(LOOMTOROOM)
loom122lt:
	ld a,123
	JUMP_(LOOMTOROOM)

LOOM129:
	ld a,(DOTX)
	cp 84
	jr z,loom129rt
	ld a,130
	JUMP_(LOOMTOROOM)
loom129rt:
	ld a,128
	JUMP_(LOOMTOROOM)
LOOM131:
	ld a,(DOTX)
	cp 84
	jr z,loom131rt
	ld a,132
	JUMP_(LOOMTOROOM)
loom131rt:
	ld a,(SCENARIO)
	cp 8	
	JUMP_C(SCENARIO2)
	ld a,133
	JUMP_(LOOMTOROOM)
LOOMto129:
	ld a,129
	JUMP_(LOOMTOROOM)
LOOMto131:
	ld a,131
	JUMP_(LOOMTOROOM)
LOOM138:
	ld a,(DOTX)
	cp 84
	jr z,loom138rt
	cp 4	
	jr z,loom138lt
	ld a,(DOTY)
	cp 4
	jr z,loom138up
loom138dn:
	ld a,43
	ld (ROOM),a
	JUMP_(DUNGEONEXIT)
loom138up:
	ld a,136
	JUMP_(LOOMTOROOM)
loom138lt:
	ld a,137
	JUMP_(LOOMTOROOM)
loom138rt:
	ld a,139
	JUMP_(LOOMTOROOM)
LOOMto138:
	ld a,138
	JUMP_(LOOMTOROOM)
LOOM154:
	ld a,(DOTX)
	cp 84
	jr z,loom154rt
	cp 4	
	jr z,loom154lt
	ld a,(DOTY)
	cp 4
	jr z,loom154up
loom154dn:
	ld a,152
	JUMP_(LOOMTOROOM)
loom154up:
	ld a,150
	JUMP_(LOOMTOROOM)
loom154lt:
	ld a,153
	JUMP_(LOOMTOROOM)
loom154rt:
	ld a,151
	JUMP_(LOOMTOROOM)
LOOMto154:
	ld a,154
	JUMP_(LOOMTOROOM)
LOOM144:
	ld a,(DOTX)
	cp 84
	jr z,loom144rt
	cp 4	
	jr z,loom144lt
	ld a,(DOTY)
	cp 4
	jr z,loom144up
loom144dn:
	ld a,142
	JUMP_(LOOMTOROOM)
loom144up:
	ld a,140
	JUMP_(LOOMTOROOM)
loom144lt:
	ld a,143
	JUMP_(LOOMTOROOM)
loom144rt:
	ld a,141
	JUMP_(LOOMTOROOM)
LOOMto144:
	ld a,144
	JUMP_(LOOMTOROOM)
LOOM149:
	ld a,(DOTX)
	cp 84
	jr z,loom149rt
	cp 4	
	jr z,loom149lt
	ld a,(DOTY)
	cp 4
	jr z,loom149up
loom149dn:
	ld a,147
	JUMP_(LOOMTOROOM)
loom149up:
	ld a,145
	JUMP_(LOOMTOROOM)
loom149lt:
	ld a,148
	JUMP_(LOOMTOROOM)
loom149rt:
	ld a,146
	JUMP_(LOOMTOROOM)
LOOMto149:
	ld a,149
	JUMP_(LOOMTOROOM)
LOOM155:
	ld a,(SCENARIO)
	cp 8	
	JUMP_Z(SCENARIO2)
	ld a,156
	JUMP_(LOOMTOROOM)
LOOM156:
	ld a,155
	JUMP_(LOOMTOROOM)

LOOM160:
	ld a,(DOTY)
	cp 4
	jr z,loom160up
loom160dn:
	ld a,159
	ld (ROOM),a
	JUMP_(DUNGEONEXIT)
loom160up:
	ld a,161
	JUMP_(LOOMTOROOM)
LOOM161:
	ld a,(DOTY)
	cp 4
	jr z,loom161up
loom161dn:
	ld a,160
	JUMP_(LOOMTOROOM)
loom161up:
	ld a,162
	JUMP_(LOOMTOROOM)
LOOM162:
	ld a,(DOTY)
	cp 4
	jr z,loom162up
	jr loom160up
loom162up:
	ld a,163
	JUMP_(LOOMTOROOM)
LOOM163:
	ld a,(DOTY)
	cp 4
	jr z,loom163up
	jr loom161up
loom163up:
	ld a,164
	JUMP_(LOOMTOROOM)
LOOM164:
	ld a,(DOTY)
	cp 4
	jr z,loom164up
	jr loom162up
loom164up:
	ld a,165
	JUMP_(LOOMTOROOM)
LOOM165:
	ld a,(DOTY)
	cp 52
	jr z,loom163up
	JUMP_(SCENARIOEND)

LOOMTOROOM:
	ld (ROOM),a
	ld a,(DOTX)
	cp 4
	jr z,RDRRT	
	cp 84
	jr z,RDRLT
	ld a,(DOTY)
	cp 60
	jr z,RDRUP
	cp 4
	jr z,RDRDN
RDRUP:
	ld a,4
	ld (DOTY),a
	ld (BKY),a
	ld a,44
	ld (BKX),a
	ld hl,DN
	ld (Save),hl
	CALL_(drawit)	
	JUMP_(RELOADROOM)
RDRDN:
	ld a,52
	ld (DOTY),a
	ld (BKY),a
	ld a,44
	ld (BKX),a
	ld hl,UP
	ld (Save),hl
	CALL_(drawit)	
	JUMP_(RELOADROOM)
RDRLT:
	ld a,4
	ld (DOTX),a
	ld (BKX),a
	ld a,28
	ld (BKY),a
	ld hl,RT
	ld (Save),hl
	CALL_(drawit)	
	JUMP_(RELOADROOM)
RDRRT:
	ld a,84
	ld (DOTX),a
	ld (BKX),a
	ld a,28
	ld (BKY),a
	ld hl,LT
	ld (Save),hl
	CALL_(drawit)	
	JUMP_(RELOADROOM)

DRAWWALLS:
	CALL_(ERASESCREEN)
	LD HL,$FC00+2
	LD DE,$FC00+3
           	LD BC,11
           	LD A,$FF
           	LD (HL),A
           	LDIR

	LD HL,$FC00+18
	LD DE,$FC00+19
           	LD BC,11
           	LD A,$FF
           	LD (HL),A
           	LDIR

	LD HL,$FC00+994
	LD DE,$FC00+995
           	LD BC,11
           	LD A,$FF
           	LD (HL),A
           	LDIR
           	

	LD HL,$FC00+1010
	LD DE,$FC00+1011
           	LD BC,11
           	LD A,$FF
           	LD (HL),A
           	LDIR


	LD B,60
           	LD HL,$FC00+34
           	LD DE,11
SIDELINELOOP:
           	LD A,$C0
           	LD (HL),A
           	ADD HL,DE
           	LD A,3
           	LD (HL),A

        	INC HL
			inc hl
			inc hl
			inc hl
			inc hl

           	DJNZ SIDELINELOOP
	RET
	
;-----------------end of room addys-----------------

SCENARIO1:
	CALL_(ERASESCREEN)
	ld a,-8
	ld (CHKDFD),a
	ld b,12
SANDDRAW:
	push bc
	ld a,(CHKDFD)
	add a,8
	ld (CHKDFD),a
	ld (BKX),a
	ld a,55
	ld (BKY),a
	ld hl,SAND
	CALL_(drawit)
	pop bc
	djnz SANDDRAW	
	
	ld a,-8
	ld (CHKDFD),a
	ld b,12
MNTNDRAW:
	push bc
	ld a,(CHKDFD)
	add a,8
	ld (CHKDFD),a
	ld (BKX),a
	ld a,10
	ld (BKY),a
	ld hl,MOUNTAIN
	CALL_(drawit)
	pop bc
	djnz MNTNDRAW	

	ld a,74
	ld (CHKDFD),a
	ld (WHOTOATTACK),a
CINEMALOOP:
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,42
	ld (BKY),a
	ld hl,ISIS1	
	CALL_(drawit)
	ld a,(WHOTOATTACK)
	dec a
	jr z,FOOT1
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,50
	ld (BKY),a
	ld hl,ISIS4
	CALL_(drawit)
	jr FOOTGO
FOOT1:
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,50
	ld (BKY),a
	ld hl,ISIS5
	CALL_(drawit)
FOOTGO:
	ld a,(CHKDFD)
	add a,8
	ld (BKX),a
	ld a,47
	ld (BKY),a
	ld hl,ISIS3
	CALL_(drawit)

	ld a,(CHKDFD)
	cp 42
	jr z,ITSDONE

	CALL_(DELAY3)
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,42
	ld (BKY),a
	ld hl,ISIS1	
	CALL_(drawit)
	ld a,(WHOTOATTACK)
	dec a
	jr z,FOOT1ERASE
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,50
	ld (BKY),a
	ld hl,ISIS4
	CALL_(drawit)
	ld a,1
	ld (WHOTOATTACK),a
	jr FOOTGOERASE
FOOT1ERASE:
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,50
	ld (BKY),a
	ld hl,ISIS5
	CALL_(drawit)
	ld a,2
	ld (WHOTOATTACK),a
FOOTGOERASE:
	ld a,(CHKDFD)
	add a,8
	ld (BKX),a
	ld a,47
	ld (BKY),a
	ld hl,ISIS3
	CALL_(drawit)
	CALL_(DELAY2)
	ld a,(CHKDFD)
	sub 4
	ld (CHKDFD),a
	JUMP_NZ(CINEMALOOP)
ITSDONE:
	xor a
	ld (CHKDFD),a
	ld b,45
LOOPMOVE:
	push bc
	ld bc,$322A
	ld hl,ISIS6
	CALL_(drawit2)
	CALL_(DELAY2)
	CALL_(CLOUDS)
	pop bc
	djnz LOOPMOVE	
	
	ld bc,$322A
	ld hl,ISIS4
	CALL_(drawit2)
	ld bc,$322A
	ld hl,ISIS2
	CALL_(drawit2)
	ld de,$2400
	ld hl,SPACESHIP1	
	ld c,19
	CALL_(drawbig2)
	ld de,$2408	
	ld hl,SPACESHIP2	
	ld c,19
	CALL_(drawbig2)
	ld de,$2410	
	ld hl,SPACESHIP3	
	ld c,19
	CALL_(drawbig2)
	ld de,$2A18	
	ld hl,SPACESHIP4	
	ld c,13
	CALL_(drawbig2)
	ld de,$171A                    
            	ld hl,ufotext
            	call DISPSTRING     
	call WaitKey
	ld a,99
	ld (CHKDFD),a
	JUMP_(STARTBATTLE)	
CLOUDS:
	ld a,(CHKDFD)
	add a,3
	ld (CHKDFD),a
	ld (BKX),a
	xor a
	ld (BKY),a
	ld hl,CLOUD
	CALL_(drawit)
	ld a,(CHKDFD)
	add a,40
	ld (BKX),a
	xor a
	ld (BKY),a
	ld hl,CLOUD
	CALL_(drawit)
	CALL_(DELAY)
	ld a,(CHKDFD)
	ld (BKX),a
	xor a
	ld (BKY),a
	ld hl,CLOUD
	CALL_(drawit)
	ld a,(CHKDFD)
	add a,40
	ld (BKX),a
	xor a
	ld (BKY),a
	ld hl,CLOUD
	CALL_(drawit)
	RET
SCENARIOEND:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,DarkKing
	call _puts
	call WaitKey		
	ld hl,$0202
	ld (_curRow),hl
	ld hl,finalboss
	call _puts
	call WaitKey		
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,throws
	call _puts
	call WaitKey		
	ld hl,$0202
	ld (_curRow),hl
	ld hl,endtext
	call _puts
	call WaitKey		
	ld a,99
	ld (CHKDFD),a
	JUMP_(STARTBATTLE)	
SCENARIO2:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld a,(SCENARIO)
	cp 1
	jr z,NOKEY
	cp 6
	jr z,NOKEY
	cp 7
	jr z,LEADER4
	cp 8
	jr z,LEADER5
	ld hl,darkcrystal
	call _puts
	call WaitKey		
	ld a,99
	ld (CHKDFD),a
	JUMP_(STARTBATTLE)		
LEADER4:
	ld hl,crystal1
	call _puts
	call WaitKey		
	ld a,99
	ld (CHKDFD),a
	JUMP_(STARTBATTLE)
LEADER5:
	ld hl,crystal2
	call _puts
	call WaitKey		
	ld a,99
	ld (CHKDFD),a
	JUMP_(STARTBATTLE)
NOKEY:
	ld hl,needkey
	call _puts
	call WaitKey		
	CALL_(DRAWWALLS)
	ld a,(DOTY)
	ld (BKY),a
	ld a,(DOTX)
	ld (BKX),a
	ld hl,(Save)
	CALL_(drawit)	
	JUMP_(RELOADROOM)
LEADERS:
	ld a,1
	ld (NUMBEROFENEMIES),a
	ld a,(SCENARIO)
	or a
	jr z,LEADEREYE
	cp 2
	JUMP_Z(LEADERELF)
	cp 3
	JUMP_Z(LEADERDRAGON)
	cp 7
	JUMP_Z(LEADERDRAKES)
	cp 8
	JUMP_Z(LEADEREVIL)
	cp 9
	JUMP_Z(LEADERDRAGON)
LEADEREYE:
	ld de,$090D
	ld hl,LEADER1p1
	ld c,33
	CALL_(drawbig2)	
	ld de,$0915
	ld hl,LEADER1p2
	ld c,33
	CALL_(drawbig2)	
	ld de,$091D
	ld hl,LEADER1p3
	ld c,33
	CALL_(drawbig2)	
	ld de,$0925
	ld hl,LEADER1p4
	ld c,33
	CALL_(drawbig2)	
	ld de,$122D
	ld hl,LEADER1p5
	ld c,22
	CALL_(drawbig2)	
	ld a,1
	ld (SCENARIO),a
	ld (LEADERORNO),a
	ld hl,25
	ld (ENEMYSPEED),hl
	ld hl,120
	ld (ENEMYHP),hl
	ld a,23
	ld (ENEMY1STR),a	;load enemy 1's strength
	ld a,80
	ld (ENEMY1XP),a
	ld hl,leadername1
	ld (ENEMY1),hl
	CALL_(PUTNAME)
	JUMP_(RETFROMLEADER)
LEADERELF:
	ld de,$1F02
	ld hl,LEADER2p8
	ld c,11
	CALL_(drawbig2)	
	ld de,$040A
	ld hl,LEADER2p1
	ld c,41
	CALL_(drawbig2)	
	ld de,$0412
	ld hl,LEADER2p2
	ld c,41
	CALL_(drawbig2)	
	ld de,$041A
	ld hl,LEADER2p3
	ld c,41
	CALL_(drawbig2)	
	ld de,$0422
	ld hl,LEADER2p4
	ld c,41
	CALL_(drawbig2)	
	ld de,$042A
	ld hl,LEADER2p5
	ld c,41
	CALL_(drawbig2)	
	ld bc,$2032
	ld hl,LEADER2p6
	CALL_(drawit2)	
	ld bc,$203A
	ld hl,LEADER2p7
	CALL_(drawit2)	
	ld a,3
	ld (SCENARIO),a
	ld (LEADERORNO),a
	ld hl,420
	ld (ENEMYHP),hl
	ld a,45
	ld (ENEMY1STR),a	;load enemy 1's strength
	ld a,170
	ld (ENEMY1XP),a
	ld hl,leadername2
	ld (ENEMY1),hl
	CALL_(PUTNAME)	
	JUMP_(RETFROMLEADER)
LEADERDRAGON:
	ld de,$040A
	ld hl,LEADER3p1
	ld c,40
	CALL_(drawbig2)	
	ld de,$0412
	ld hl,LEADER3p2
	ld c,40
	CALL_(drawbig2)	
	ld de,$041A
	ld hl,LEADER3p3
	ld c,40
	CALL_(drawbig2)	
	ld de,$0422
	ld hl,LEADER3p4
	ld c,40
	CALL_(drawbig2)	
	ld de,$042A
	ld hl,LEADER3p5
	ld c,40
	CALL_(drawbig2)	
	ld de,$0B32
	ld hl,LEADER3p6
	ld c,24
	CALL_(drawbig2)
	ld a,(SCENARIO)
	inc a
	ld (SCENARIO),a
	ld (LEADERORNO),a
	ld hl,8000
	ld (ENEMYHP),hl
	ld hl,30
	ld (ENEMYSPEED),hl
	ld a,180
	ld (ENEMY1STR),a	;load enemy 1's strength
	ld hl,leadername3
	ld (ENEMY1),hl
	CALL_(PUTNAME)
	JUMP_(RETFROMLEADER)
LEADERDRAKES:
	ld de,$060F
	ld hl,DRAKES
	ld c,39
	CALL_(drawbig2)	
	ld de,$0621
	ld hl,DRAKES
	ld c,39
	CALL_(drawbig2)	
	ld a,8
	ld (SCENARIO),a
	ld (LEADERORNO),a
	ld hl,2000
	ld (ENEMYHP),hl
	ld hl,14
	ld (ENEMYSPEED),hl
	ld a,80
	ld (ENEMY1STR),a	;load enemy 1's strength
	ld hl,leadername4
	ld (ENEMY1),hl
	CALL_(PUTNAME)
	JUMP_(RETFROMLEADER)
LEADEREVIL:
	ld de,$0A0A
	ld hl,$0000
	ld c,28
	CALL_(drawbig2)	
	ld de,$0712
	ld hl,$0000
	ld c,34
	CALL_(drawbig2)	
	ld de,$0A1A
	ld hl,$0000
	ld c,28
	CALL_(drawbig2)	
	ld de,$0722
	ld hl,$0000
	ld c,34
	CALL_(drawbig2)	
	ld de,$0A2A
	ld hl,$0000
	ld c,28
	CALL_(drawbig2)	
	ld a,9
	ld (SCENARIO),a
	ld (LEADERORNO),a
	ld hl,3000
	ld (ENEMYHP),hl
	ld hl,20
	ld (ENEMYSPEED),hl
	ld a,120
	ld (ENEMY1STR),a	;load enemy 1's strength
	ld hl,leadername5
	ld (ENEMY1),hl
	CALL_(PUTNAME)
	JUMP_(RETFROMLEADER)
AFTERLEADER:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld a,(SCENARIO)
	cp 3
	jr z,AFTERLEADER2
	cp 8
	jr z,AFTERLEADER3
	cp 9
	jr z,AFTERLEADER3
	cp 10
	jr z,ENDOFGAME
AFTERLEADER1:
	ld hl,afterleader1
	call _puts
	call WaitKey
	JUMP_(RETFROMLDR2)
AFTERLEADER2:
	ld hl,afterleader2
	call _puts
	call WaitKey
	JUMP_(RETFROMLDR2)
AFTERLEADER3:
	ld hl,getcrystal
	call _puts
	call WaitKey
	JUMP_(RETFROMLDR2)

ENDOFGAME:	;; end
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,endgametext1
	call _puts
	call WaitKey
	CALL_(TIMEDISTORT)
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,endgametext2
	call _puts
	call WaitKey
	CALL_(DRAWWALLS)

	ld de,$341E
	ld hl,ENDISISp1
	ld c,10
	CALL_(drawbig2)
	ld de,$2026
	ld hl,ENDISISp2
	ld c,30
	CALL_(drawbig2)
	ld de,$202E
	ld hl,ENDISISp3
	ld c,30
	CALL_(drawbig2)
	ld de,$2036
	ld hl,ENDISISp4
	ld c,30
	CALL_(drawbig2)
	ld bc,$363B
	ld hl,ENDISISp5
	CALL_(drawit2)
	ld a,7
	ld (CHKDFD),a
	CALL_(DRAWRUIN)
	ld a,47
	ld (CHKDFD),a
	CALL_(DRAWRUIN)
	call WaitKey
	ld de, $1E03
   	ld hl,empty 
             call DISPSTRING   
	call WaitKey
	ld de,$1E3D
   	ld hl,lost  
             call DISPSTRING   
	call WaitKey
	ld bc,$1624
	ld hl,TITLE1
	CALL_(drawit2)
	ld bc,$162C
	ld hl,TITLE2
	CALL_(drawit2)
	ld bc,$1634
	ld hl,TITLE3
	CALL_(drawit2)
	call WaitKey
	JUMP_(EXIT)  ;; You win! =]	

DRAWRUIN:
	ld a,(CHKDFD)
	ld (BKX),a
	ld a,9
	ld (BKY),a
	ld hl,RUINOFWORLDp1
	ld c,12
	CALL_(drawbig)
	ld a,(CHKDFD)
	add a,8
	ld (BKX),a
	ld a,9
	ld (BKY),a
	ld hl,RUINOFWORLDp2
	ld c,12
	CALL_(drawbig)
	ld a,(CHKDFD)
	add a,16
	ld (BKX),a
	ld a,9
	ld (BKY),a
	ld hl,RUINOFWORLDp3
	ld c,12
	CALL_(drawbig)
	ld a,(CHKDFD)
	add a,24
	ld (BKX),a
	ld a,9
	ld (BKY),a
	ld hl,RUINOFWORLDp4
	ld c,12
	CALL_(drawbig)
	ld a,(CHKDFD)
	add a,32
	ld (BKX),a
	ld a,9
	ld (BKY),a
	ld hl,RUINOFWORLDp5
	ld c,12
	CALL_(drawbig)
	RET

STATUSSCREEN:
	CALL_(DRAWWALLS)
	ld bc,$070E
	ld hl,TITLE1
	CALL_(drawit2)
	ld bc,$0716
	ld hl,TITLE2
	CALL_(drawit2)
	ld bc,$071E
	ld hl,TITLE3
	CALL_(drawit2)
	ld de,$1207
	ld hl,PIC1
	ld c,16
	CALL_(drawbig2)
	ld de,$120F
	ld hl,PIC1p2
	ld c,16
	CALL_(drawbig2)
	ld de,$261B
	ld hl,PIC2
	ld c,16
	CALL_(drawbig2)
	ld de,$2623
	ld hl,PIC2p2
	ld c,16
	CALL_(drawbig2)

	ld a,-4
	ld (CHKDFD),a
	ld b,7
VINELOOP:
	push bc
	ld a,47
	ld (BKX),a
	ld a,(CHKDFD)	
	add a,8
	ld (CHKDFD),a	
	ld (BKY),a
	ld hl,VINE
	CALL_(drawit)
	pop bc
	djnz VINELOOP

	ld bc,$0837
	ld hl,CURSOR2
	CALL_(drawit2)
	ld de,$0841
   	ld hl,sitem         
             call DISPSTRING     
	ld de,$1041
   	ld hl,sspell         
             call DISPSTRING     
	ld de,$1841
   	ld hl,sstats         
             call DISPSTRING     
	ld de,$2041
   	ld hl,ssave         
             call DISPSTRING     
	ld de,$2841
   	ld hl,sload         
             call DISPSTRING     
LOOPSTAT:
	call _getky
	cp K_SECOND
	jr z,STATPRESS
	cp K_EXIT
	JUMP_Z(STATEND)
	cp K_DOWN
	jr z,DOWNARROW
	cp K_UP
	jr nz,LOOPSTAT
UPARROW:
	ld a,(BKY)
	cp 8
	jr z,LOOPSTAT
	ld hl,CURSOR2
	CALL_(drawit)
	ld a,(BKY)
	sub 8
	ld (BKY),a	
	ld hl,CURSOR2
	CALL_(drawit)
	jr LOOPSTAT
DOWNARROW:
	ld a,(BKY)
	cp 40
	jr z,LOOPSTAT
	ld hl,CURSOR2
	CALL_(drawit)
	ld a,(BKY)
	add a,8
	ld (BKY),a	
	ld hl,CURSOR2
	CALL_(drawit)
	jr LOOPSTAT
STATPRESS:
	ld a,(BKY)
	cp 32
	jr z,SAVEGAME
	cp 40
	jr z,LOADGAME	
	cp 24
	JUMP_Z(STATUS)
	cp 16
	JUMP_Z(SPELLS)
	cp 8
	JUMP_Z(ITEMS)
SAVEGAME:
	ld a,(DUNGEON)
	or a
	JUMP_NZ(LOOPSTAT)

        LD DE,SAVERAM
        LD HL,ROOM
        LD BC,52
        LDIR
        call _clrLCD
        ld hl,$0503
        ld (_curRow),hl
        ld hl,gamesaved
        call _puts
        call WaitKey
        call CR_GRBCopy
		call SaveIt
        JUMP_(STATUSSCREEN)

;and so on...  that can probably be optimized a little to fit your game

LOADGAME:
       
        LD HL,SAVERAM
        LD DE,ROOM
        LD BC,52
        LDIR
        call _clrLCD
        ld hl,$0503
        ld (_curRow),hl
        ld hl,gameloaded
        res 3,(IY+05)
        call _puts
        call WaitKey
        	CALL_(DRAWWALLS)
	ld a,28
	ld (DOTY),a
	ld (BKY),a
	ld a,44
	ld (DOTX),a	
	ld (BKX),a
	ld hl,UP
	ld (Save),hl
	CALL_(drawit)
	JUMP_(RELOADROOM)
STATEND:
	CALL_(DRAWWALLS)
	ld a,(DOTY)
	ld (BKY),a
	ld a,(DOTX)	
	ld (BKX),a
	ld hl,(Save)
	CALL_(drawit)
	JUMP_(RELOADROOM)
STATUS:
	CALL_(DRAWWALLS)
	ld de,$0322
   	ld hl,isis         
             call DISPSTRING
	ld de, $0336
   	ld hl,darq         
   	call DISPSTRING
	ld de, $0A03
   	ld hl,hp         
             call DISPSTRING
	ld de, $1103
   	ld hl,hpmax         
              call DISPSTRING
	ld de, $1903
   	ld hl,mp         
             call DISPSTRING
	ld de, $2003
   	ld hl,mpmax         
             call DISPSTRING
	ld de, $2803
   	ld hl,strength         
             call DISPSTRING
	ld de, $2F03
   	ld hl,defense         
             call DISPSTRING
	ld de, $3703
   	ld hl,level         
             call DISPSTRING
	LD DE,$0A22	
	ld a,(HPI)
	CALL_(DISPHL)	
	LD DE,$0A36
	ld a,(HPD)	
	CALL_(DISPHL)	
	LD DE,$1122	
	ld a,(HPIMAX)
	CALL_(DISPHL)	
	LD DE,$1136
	ld a,(HPDMAX)	
	CALL_(DISPHL)	
	LD DE,$1922	
	ld a,(ISISMP)
	CALL_(DISPHL)	
	LD DE,$1936
	ld a,(DARQMP)	
	CALL_(DISPHL)	
	LD DE,$2022	
	ld a,(MPIMAX)
	CALL_(DISPHL)	
	LD DE,$2036
	ld a,(MPDMAX)	
	CALL_(DISPHL)	
	LD DE,$2822	
	ld a,(STRENGTHI)
	CALL_(DISPHL)	
	LD DE,$2836
	ld a,(STRENGTHD)	
	CALL_(DISPHL)	
	LD DE,$2F22	
	ld a,(DEFENDI)
	CALL_(DISPHL)	
	LD DE,$2F36
	ld a,(DEFENDD)	
	CALL_(DISPHL)	
	LD DE,$3722	
	ld a,(ISISLVL)
	CALL_(DISPHL)	
	LD DE,$3736
	ld a,(DARQLVL)	
	CALL_(DISPHL)	
	call WaitKey	
	CALL_(YOURGOLD)
	call WaitKey	
	JUMP_(STATUSSCREEN)
ITEMS:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,towntext2
	call _puts
ITEMLOOP2:
	call _getky
                    cp K_1
                    jr z,MEDKITUSE
                    cp K_2
                    jr z,MAGKITUSE
                    cp K_3
                    JUMP_Z(STATUSSCREEN)
	jr ITEMLOOP2
MEDKITUSE:
	ld a,(MEDKITS)
	or a
	jr z,ITEMLOOP2
	dec a
	ld (MEDKITS),a	
	ld b,45
	ld a,(HPD)
	or a
	jr z,ISISMED2
	add a,b
	ld (HPD),a
	CALL_(HPOVERMAXD)
ISISMED2:
	ld b,45
	ld a,(HPI)
	or a
	jr z,ENDMED2
	add a,b
	ld (HPI),a
	CALL_(HPOVERMAXI)
ENDMED2:
	ld hl,$0204
	ld (_curRow),hl
	ld hl,gainhp
	call _puts
	call WaitKey
	jr ITEMS	
	
MAGKITUSE:
	ld a,(MAGIKITS)
	or a
	jr z,ITEMLOOP2
	dec a
	ld (MAGIKITS),a	
	ld b,30
	ld a,(DARQMP)
	add a,b
	ld (DARQMP),a
	CALL_(MPOVERMAXD)
	ld b,30
	ld a,(ISISMP)
	add a,b
	ld (ISISMP),a
	CALL_(MPOVERMAXI)
ENDMAGI2:
	ld hl,$0204
	ld (_curRow),hl
	ld hl,gainmp
	call _puts
	call WaitKey
	JUMP_(ITEMS)
SPELLS:
	ld a,(HPI)
	or a
	JUMP_Z(LOOPSTAT)
	call _clrLCD
	ld hl,$0202
	ld (_curRow),hl
	ld hl,healorno
	call _puts
	ld hl,$0200
	ld (_curRow),hl
	ld hl,healing
	call _puts

	ld a,(HPI)	
	ld b,a
	ld a,(HPIMAX)
	sub b
	ld (CHKDFD),a
	ld a,(HPD)	
	ld c,a
	ld a,(HPDMAX)
	sub c
	ld (HITBYWHO),a	
	ld a,(CHKDFD)
	ld b,a
	ld a,(HITBYWHO)
	add a,b
	sra a
	sra a
	ld (CHKDFD),a
	ld l,a
	ld h,0
	push hl
	ld h,8				;6
	ld l,0
	ld (_curRow),hl
	pop hl
	
	xor a

	call _dispAHL
	ld h,6				;4
	ld l,1
	ld (_curRow),hl
	ld a,(ISISMP)
	ld l,a
	ld h,0

	xor a

	call _dispAHL
HEALLOOP:	
	call _getky
	cp K_1
             jr z,HEALTHEM
             cp K_2
	JUMP_Z(STATUSSCREEN)
	jr HEALLOOP                    
HEALTHEM:
	ld a,(CHKDFD)
	ld b,a
	ld a,(ISISMP)
	sub b
	JUMP_C(NEEDMPS)	
	ld (ISISMP),a
	ld a,(HPIMAX)
	ld (HPI),a
	ld a,(HPDMAX)
	or a
	JUMP_Z(STATUSSCREEN)
	ld (HPD),a
             JUMP_(STATUSSCREEN)
NEEDMPS:
	call _clrLCD
	ld hl,$0200
	ld (_curRow),hl
	ld hl,YOUNEEDMP
	call _puts
	call WaitKey
             JUMP_(STATUSSCREEN)
DISPSTRING:
	ld a,e
	add a,16
	ld e,a
             ld (_penCol),de
	call _vputs
	call CR_GRBCopy
	ret
WaitKey:
	push bc
	push de
	push hl
	call _getky
	pop hl
	pop de
	pop bc
	cp K_ENTER
	ret z
	cp K_SECOND
	jr nz,WaitKey
	RET

;------------------------------------------------------
;   FIND_PIXEL by CLEM
;
;   121 cycles  27 bytes    Destroyes : none
;------------------------------------------------------

Find_Pixel:
	push bc
	ld a,b
	add a,16
	ld b,a
	ld a, $3f
	sub c
	ld c, a


    ld h,63
    ld a,c
    add a,a
    add a,a
    ld l,a
    ld a,b
    rra
    add hl,hl
    rra
    add hl,hl
    rra
    or l
    ld l,a
    ld a,b
    and 7
    cpl
    rlca
    rlca
    rlca
    ld (FP_Bit+1),a
    xor a
FP_Bit:
    set 0,a
	pop bc
    ret

DeComp:
	ld   a, (hl)												; b should already be 0
	inc  hl
	cp   %00111111
	jr   nc, DoDeComp
	
	or   a
	ret  z														; EOF
	ld   c, a
	ldir														; Simply dump the data
	jr   DeComp

DoDeComp:
	push af

	and  %00011111
	add  a, 2
	cp   33
	jr   nz, NotMax

	add  a, (hl)
	rl   b
	inc  hl

NotMax:
	ld   c, a													; Here, bc = Length
	pop  af
	push hl
	ld   l, (hl)
	rlca
	rlca
	rlca
	or   %11111000
	ld   h, a

	add  hl, de
	ldir
	pop  hl
	inc  hl
	jr   DeComp


BATTLEPIC:
; Data compressed with Lite, Total Size = 304

   .db 003h, 000h, 000h, 0FFh, 0E9h, 0FFh, 001h, 000h, 0E1h, 0FFh, 002h, 080h
   .db 000h, 0E7h, 0FFh, 001h, 001h, 0EEh, 0F0h, 0FBh, 0E0h, 001h, 00Ch, 0EDh
   .db 0D0h, 001h, 01Eh, 0EDh, 0C0h, 001h, 037h, 0EDh, 0B0h, 002h, 00Bh, 080h
   .db 0ECh, 0A0h, 002h, 007h, 0C0h, 0EDh, 0B0h, 001h, 0E0h, 0ECh, 080h, 002h
   .db 006h, 060h, 0EDh, 0D0h, 0EDh, 0C0h, 001h, 009h, 0EDh, 0B0h, 001h, 00Eh
   .db 0EDh, 0B0h, 001h, 014h, 0EDh, 0C0h, 002h, 03Fh, 0D0h, 0ECh, 020h, 001h
   .db 01Dh, 0EDh, 070h, 0FFh, 00Fh, 000h, 0DFh, 00Fh, 0D0h, 001h, 00Eh, 0CEh
   .db 0F0h, 0CDh, 090h, 001h, 013h, 0CDh, 080h, 001h, 00Ah, 0CDh, 070h, 001h
   .db 019h, 0CDh, 0C0h, 001h, 036h, 0CDh, 0C0h, 001h, 03Bh, 0CDh, 0C0h, 001h
   .db 02Ah, 0CDh, 0B0h, 001h, 035h, 0CDh, 0A0h, 001h, 03Fh, 0CDh, 090h, 001h
   .db 03Eh, 0EEh, 0E0h, 0CEh, 0C0h, 0CDh, 070h, 0EEh, 090h, 001h, 077h, 0CDh
   .db 040h, 0DFh, 02Dh, 0B0h, 001h, 007h, 0ADh, 050h, 001h, 006h, 0A1h, 044h
   .db 001h, 003h, 0A2h, 040h, 0A5h, 030h, 001h, 0E4h, 0A7h, 040h, 007h, 040h
   .db 030h, 000h, 007h, 000h, 000h, 064h, 0A6h, 030h, 008h, 090h, 052h, 0A1h
   .db 008h, 002h, 060h, 000h, 024h, 0A6h, 020h, 007h, 098h, 049h, 021h, 063h
   .db 002h, 053h, 053h, 0E7h, 0F0h, 007h, 08Dh, 056h, 021h, 04Ah, 002h, 055h
   .db 065h, 0E7h, 0E0h, 007h, 096h, 046h, 0A1h, 029h, 002h, 055h, 043h, 0E7h
   .db 0D0h, 007h, 0BBh, 049h, 021h, 06Bh, 002h, 063h, 041h, 0E7h, 0C0h, 007h
   .db 095h, 054h, 0A7h, 0FFh, 0E2h, 07Fh, 0FFh, 0E7h, 0B0h, 0E0h, 090h, 006h
   .db 028h, 000h, 012h, 080h, 000h, 0A4h, 086h, 0C0h, 080h, 0A0h, 001h, 0E8h
   .db 0EBh, 0F0h, 0E0h, 070h, 001h, 027h, 0EBh, 0D0h, 006h, 09Eh, 05Fh, 0A0h
   .db 000h, 002h, 000h, 0E8h, 070h, 006h, 0A1h, 052h, 0AAh, 000h, 002h, 0A0h
   .db 0E8h, 060h, 006h, 0BFh, 05Dh, 0AAh, 080h, 002h, 0A8h, 0E8h, 050h, 006h
   .db 0ADh, 052h, 0AEh, 000h, 002h, 0E0h, 0E9h, 0D0h, 002h, 04Bh, 02Ah, 0EBh
   .db 0E0h, 003h, 0BFh, 046h, 02Ah, 0EBh, 0C0h, 0E5h, 000h, 001h, 066h, 0CDh
   .db 0E0h, 085h, 010h, 000h



UP      .db       00011000b
        .db       00101000b
        .db       00100100b
        .db       01101100b
        .db       01101010b
        .db       01010110b
        .db       11111111b
        .db       01101100b

DN      .db       00011000b
        .db       00111000b
        .db       00101100b
        .db       01010100b
        .db       01100110b
        .db       01100110b
        .db       11111111b
        .db       01101100b

RT      .db       00001000b
        .db       00010100b
        .db       00010010b
        .db       00101100b
        .db       01000100b
        .db       01010010b
        .db       11111111b
        .db       00110110b

LT      .db       00010000b
        .db       00101000b
        .db       01001000b
        .db       00110100b
        .db       00100010b
        .db       01001010b
        .db       11111111b
        .db       01101100b

CASTLE  
        .db     10100101b
        .db     11100111b
        .db     10100101b
        .db     10111101b
        .db     11100111b
        .db     11011011b
        .db     11000011b
        .db     11111111b
WPNSHOP: ;for erasing walls left
        .db     01011111b
        .db     01010101b
        .db     01011111b
        .db     01010101b
        .db     01010101b
        .db     01010101b
        .db     11101110b
        .db     01000100b
BLANK3: ;for erasing walls left
        .db     11000000b
        .db     11000000b
        .db     11000000b
        .db     11000000b
        .db     11000000b
        .db     11000000b
        .db     11000000b
        .db     11000000b
CAVE: 
        .db     00000000b
        .db     00011100b
        .db     00100011b
        .db     00101101b
        .db     01011101b
        .db     01011111b
        .db     11011111b
        .db     11111111b
STAIRZ:
        .db     00000000b
        .db     00000000b
        .db     00000111b
        .db     00001101b
        .db     00011011b
        .db     00110111b
        .db     01101101b
        .db     11111111b
CHEST:
        .db     00011111b
        .db     00100011b
        .db     01000101b
        .db     11111001b
        .db     10001001b
        .db     10001010b
        .db     10001100b
        .db     11111000b

endgametext1:
	.db "You use all 3        "
	.db "crystals...",0
endgametext2:
	.db "This is home...      "
	.db "but...?",0
sitem:
	.db "Item",0
sstats:
	.db "Status",0
sspell:
	.db "Heal",0
ssave:
	.db "Save",0
new:
	.db "New ",0
sload:
	.db "Load",0
leadername1:
	.db "EyeKill",0
leadername2:
	.db "DrkOne",0
leadername3:
	.db "DrkKing",0
leadername4:
	.db "Drakes",0
leadername5:
	.db "Evil",0
runetext5:
	.db "Go now..find the     "
	.db "other 2!",0
empty:
	.db "all is empty",0
lost:
	.db "all is lost",0
healing:
	.db "Costs:               "
	.db "MP:",0
healorno:
	.db "1. Yes               " 
	.db "2. No",0
runetext:
	.db "A tall wizard is     "
	.db "standing here",0
runetext2:
	.db "Hmm..a different     " 
	.db "dimension? What      "
	.db "you need is the      "
	.db "time crystals...",0
runetext3:
	.db "They change time     "
	.db "and space. With      "
	.db "3 of them you        "	
	.db "can return home.",0
runetext4:
	.db "1 crystal is in      "
	.db "this tower. Come     "
	.db "to the portal        "
	.db "when you get it.",0
crystal1:
	.db "The 1st crystal.     "
	.db "2 drakes appear      "
	.db "to guard it!",0
crystal2:
	.db "The 2nd crystal.     "
	.db "You feel an evil     "
	.db "presence..",0
lastcrystal:
	.db "Last crystal..",0
thewayhome:
	.db "the way home?",0
needkey:
	.db "Need key",0
portal:
	.db "The portal gate      "
	.db "is locked",0
darkcrystal:
	.db "A humanoid alien     "
	.db "is guarding a        "
	.db "glowing crystal.     "
	.db "It attacks!",0
throne:
	.db "  The King's Throne  ",0

kingsays:
	.db "A strange ship       "
	.db "fell from the        "
	.db "sky. Won't you       "
	.db "go investigate?",0

kingsays1:
	.db "Ah! The crystal!     "
	.db "The King starts      "
	.db "to take it.",0

DarkKing:
	.db "The Dark King!",0
finalboss:
	.db "Is this what you     "
	.db "seek? Take it.",0
throws:
	.db "He throws you it",0
endtext:
	.db "Sadly, you won't     " 
	.db "be using it.",0
kingattacks:
	.db "Wait!",0
kingattacks2:
	.db "The symbol on his    "
	.db "hand!!",0	
afterleader1:
	.db "The monster was      "
	.db "guarding this        " 
	.db "cave..",0
weaklings:
	.db "HahAhA! Now i'll     "
	.db "send you on a        " 
	.db "little trip.",0
thanx:
	.db "Thanks for the       "
	.db "crystal!",0
time:
	.db "Time distorts...",0
towntalk2:
	.db "SkyReach? The        "
	.db "Dark King? Seek      "
	.db "Rune..maybe he       "
	.db "can help.",0 
towntalk3:
	.db "A Time Crystal?      "
	.db "Search west.",0
towntalk4:
	.db "...",0
afterleader2:
	.db "You take the         "
	.db "crystal back for     "
	.db "the king.            "
	.db "What was that        "
	.db "symbol on the        "
	.db "aliens forehead?",0
cave1:
	.db "The ship's crash     "
	.db "unearthed this       " 
	.db "cave..",0
isis:
	.db "Isis",0
darq:
	.db "Darq",0
hp:
	.db "HP",0
hpmax:
	.db "HPmax",0
mp:
	.db "MP",0
mpmax:
	.db "MPmax",0
strength:
	.db "Attk",0
defense:
	.db "Dfnd",0
level:
	.db "Lvl",0
ufotext:
	.db "What in the world..?",0
yourg:
	.db "Your Gold:",0
nameoftown1:
	.db "     ~SkyReach~      ",0
nameoftown2:
	.db "     ~Arcanick~      ",0
nameoftown3:
	.db "     ~Moonbeam~      ",0
nameoftown4:
	.db "     ~Finality~      ",0
towntext1:
	.db "1.Inn - 50g          "
	.db "2.Item Shop          "
	.db "3.Talk with ppl      "
	.db "4.Exit",0
towntext2:
	.db "1. MediKit           "
	.db "2. MagiKit           "
	.db "3. Exit",0
getcrystal:
	.db "Crystal attained",0
gamesaved:
	.db "Game Saved",0
gameloaded:
	.db "Game Loaded",0
towntext3:
	.db "     ~Items 30g~     ",0
restored:
	.db " HP&MP restored ",0
wpnshoptext:
	.db "   Weapons & Armor   ",0
wpnshoptext2:
	.db "1.Upgrade Weapon     "
	.db "2.Upgrade Armor      "
	.db "3.Exit",0
upweapon:
	.db "Weapon +3 = 60g",0
uparmor:
	.db "Armor +3 = 60g",0
wpnshoptext4:
	.db "1.Upgrade Isis       "
	.db "2.Upgrade Darq       "
	.db "3.Exit",0
gainmp:
	.db "MP +30!",0
gainhp:
	.db "HP +45!",0
youfind:
	.db "You find",0
youneedg:
	.db " You need gold! ",0	
thankmessage:
	.db "  Thank you!!!  ",0
YOUWIN:
	.db "You win!",0
DAMAGE:
	.db "Damage!!!",0
ISISDEFEND:
	.db "Isis Dfnds",0
BLANKGOLD:
	.db "some gold",0
BLANKITEM:
	.db "a MedKit",0
BLANKITEM2:
	.db "a MagiKit",0
BLANKSCROLL:
	.db "a scroll.You get     "
	.db "some xp!",0
BLANKKEY:
	.db "a key.",0
DARQDEFEND:
	.db "Darq Dfnds",0
NOTTURN:
	.db "It's not their turn",0
WHY:
	.db " ",0				;i don't know why this has to be here
BLANKTEXT:
	.db "                             ",0
BLANKTEXT2:
	.db "                    ",0
ENEMYATTACKS:
	.db "Enemy      Attacks!",0
BLANKLIFE:
	.db "            ",0
ISISFALLS:
	.db "Isis falls...",0
DARQFALLS:
	.db "Darq Falls...",0
YOULOSE:
	.db "Game Over",0
YOUNEEDMP:
	.db "You need MP!",0
EXP:
	.db "xp:",0
GOLDSTR:
	.db "$:",0
GAIN:
	.db "Gain",0
hasgainedlvl:
	.db "gains a level!",0
Fire:
	.db "Fire",0
Cure:
	.db "Cure",0
Flee:
	.db "Flee",0
Deathtext:
	.db "atashi no aijin...",0
Curetext:
	.db "...the cure...",0
Fleetext:
	.db "the winds of change...",0
Drain:
	.db "Drain",0
Wrath:
	.db "Hate",0
Cure2:
	.db "Cure2",0
Cure3:
	.db "Cure3",0
Life:
	.db "Life",0
Death:
	.db "Death",0
Siphon:
	.db "Suck",0
Nuke:
	.db "Nuke",0
itemmedkit:
	.db "MKit",0
itemmagkit:
	.db "Magi",0
Clown:
	.db "Clown",0
Robo:
	.db "Robo",0
Spider:
	.db "Tick",0
Wisp:
	.db "Wisp",0
Slime:
	.db "Slime",0
Stinger:
	.db "Sting",0
Hawk:
	.db "Hawk",0
Knight:
	.db "Knight",0
Eye:
	.db "Eye",0
Flame:
	.db "Burn",0
Skeleton:
	.db "Skel",0
Bee:
	.db "Bee",0
Mask:
	.db "Mask",0
Torch:
	.db "Torch",0
Mage:
	.db "Mage",0
Kiss:
	.db "Kiss",0
Sun:
	.db "Sun",0
Head:
	.db "Head",0
Junk:
	.db "Junk",0
Zorg:
	.db "Zorg",0

credits:
 .db "by Alex Highsmith",0
credits2:
.db "TI-86 port by Andreas Finne",0

SPELLCURE:
        .db     00000100b
        .db     01000100b
        .db     00100100b
        .db     00010001b
        .db     00000100b
        .db     11101010b
        .db     00000100b
        .db     00010001b
        .db     00100100b
        .db     01000100b
        .db     00000100b
SPELLCURE2:
        .db     00000000b
        .db     01000000b
        .db     10000000b
        .db     00000000b
        .db     00000000b
        .db     11100000b
        .db     00000000b
        .db     00000000b
        .db     10000000b
        .db     01000000b
        .db     00000000b
SPELLLIFE:
        .db     00000001b
        .db     00000010b
        .db     00000001b
        .db     00000011b
        .db     00000010b
        .db     00000111b
        .db     00000111b
        .db     00000101b
        .db     00000111b
        .db     00000111b
        .db     00011000b
        .db     00110010b
        .db     00100010b
        .db     01100011b
        .db     11011001b
        .db     01110110b
        .db     10101100b
        .db     11000100b
        .db     01001001b
        .db     00001001b
        .db     00010011b
        .db     00010111b
        .db     00001101b
SPELLLIFE2:
        .db     11100000b
        .db     00010000b
        .db     11100001b
        .db     11011010b
        .db     11111111b
        .db     00111110b
        .db     10111010b
        .db     00110100b
        .db     11111000b
        .db     11000001b
        .db     11110001b
        .db     00001111b
        .db     00000110b
        .db     00000111b
        .db     10001101b
        .db     11110011b
        .db     01000001b
        .db     10101001b
        .db     00001000b
        .db     00000100b
        .db     00000010b
        .db     00111010b
        .db     11011111b
SPELLLIFE3:
        .db     10110000b
        .db     11010000b
        .db     10100000b
        .db     11100000b
        .db     00010000b
        .db     11110000b
        .db     00100000b
        .db     00100000b
        .db     11000000b
        .db     10110000b
        .db     11000000b
        .db     11111000b
        .db     11011000b
        .db     01111000b
        .db     11101000b
        .db     00100000b
        .db     10000000b
        .db     00000000b
        .db     10000000b
        .db     10000000b
        .db     10000000b
        .db     11000000b
        .db     00000000b
SPELLNUKE:
        .db     00001011b
        .db     00110000b
        .db     11001111b
        .db     00111100b
        .db     01100101b
        .db     01010001b
        .db     11101110b
        .db     10010011b
        .db     11001100b
        .db     10101011b
        .db     11010111b
        .db     01010101b
        .db     01100000b
        .db     10111100b
        .db     01101111b
        .db     00010000b

SPELLNUKE2:
        .db     10000000b
        .db     01111000b
        .db     10000110b
        .db     11111001b
        .db     01011111b
        .db     00110011b
        .db     11011010b
        .db     01001111b
        .db     11001100b
        .db     00101111b
        .db     01011111b
        .db     11110010b
        .db     00111111b
        .db     11110000b
        .db     10001111b
        .db     11110000b
SPELLNUKE3:
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     10000000b
        .db     11111100b
        .db     11001000b
        .db     01111000b
        .db     11111110b
        .db     00011100b
        .db     11110000b
        .db     11111000b
        .db     11100000b
        .db     00000000b
        .db     11000000b
        .db     00000000b
        .db     00000000b

SPELLDEATH:
        .db     00000000b
        .db     00001100b
        .db     00010110b
        .db     00110001b
        .db     00110110b
        .db     00110110b
        .db     01001010b
        .db     01010101b
        .db     01010111b
        .db     10101011b
        .db     11101101b
        .db     11000100b
        .db     10101101b
        .db     01111111b

SPELLDEATH2:
        .db     01000000b
        .db     01100000b
        .db     01110000b
        .db     01011000b
        .db     01001000b
        .db     01000000b
        .db     11000000b
        .db     11000000b
        .db     10000000b
        .db     01000000b
        .db     01000000b
        .db     11000000b
        .db     10100000b
        .db     11110000b

FLEE:
        .db     11111111b
        .db     00000000b
        .db     00111111b
        .db     00000000b
        .db     01111111b
        .db     00000000b
        .db     11110000b
        .db     00000111b
SPELLHATE:
        .db     10001001b
        .db     01001000b
        .db     10011010b
        .db     00101001b
        .db     10101100b
        .db     01101101b
        .db     00111010b
        .db     00100110b
        .db     01101101b
        .db     01110101b
        .db     01010011b
        .db     10100111b
        .db     10101011b
        .db     10010001b
SPELLFIRE:
        .db     01001010b
        .db     11011011b
        .db     11110111b
        .db     10111101b
        .db     11010111b
        .db     01101011b
        .db     01111110b
        .db     00111100b

SPELLDRAIN:
        .db     11111100b
        .db     10000100b
        .db     10111111b
        .db     10100101b
        .db     10100101b
        .db     11111101b
        .db     00100001b
        .db     00111111b
SPELLDRAIN2:
        .db     00111111b
        .db     00100001b
        .db     11111101b
        .db     10100101b
        .db     10100101b
        .db     10111111b
        .db     10000100b
        .db     11111100b
SPELLDRAIN3:
        .db     11111100b
        .db     11111100b
        .db     11111111b
        .db     11111111b
        .db     11111111b
        .db     11111111b
        .db     00111111b
        .db     00111111b
SPELLDRAIN4:
        .db     00111111b
        .db     00111111b
        .db     11111111b
        .db     11111111b
        .db     11111111b
        .db     11111111b
        .db     11111100b
        .db     11111100b
ITEMMEDKIT:
        .db     00011000b
        .db     01011010b
        .db     00011000b
        .db     11111111b
        .db     11111111b
        .db     00011000b
        .db     01011010b
        .db     00011000b
ITEMMEDKIT2:
        .db     11001001b
        .db     01100011b
        .db     00110110b
        .db     10011101b
        .db     00111100b
        .db     01100110b
        .db     11000011b
        .db     10010001b
ITEMMEDKIT3:
        .db     01100100b
        .db     00110001b
        .db     10011011b
        .db     00011110b
        .db     01111100b
        .db     11001101b
        .db     10000110b
        .db     00100011b
ITEMMEDKIT4:
        .db     00110000b
        .db     00011000b
        .db     00011000b
        .db     00011011b
        .db     01111110b
        .db     11011000b
        .db     00001100b
        .db     00000110b
ITEMMAGIKIT:
        .db     10010011b
        .db     11011010b
        .db     00100100b
        .db     01011011b
        .db     11011010b
        .db     00100100b
        .db     01011011b
        .db     11001001b
BLANK:
        .db     11111111b
        .db     11111111b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
BLANK2: ;for erasing walls right
        .db     00000011b
        .db     00000011b
        .db     00000011b
        .db     00000011b
        .db     00000011b
        .db     00000011b
        .db     00000011b
        .db     00000011b

LIFESTAR:
        .db %00000000
        .db %00010000
        .db %01010100
        .db %00101000
        .db %11010110
        .db %00101000
        .db %01010100
        .db %00010000

ISISATTACK:
        .db %00000000
        .db %00001000
        .db %00001100
        .db %00011111
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
ATTACKINUMBER1:
        .db %00111000
        .db %01000100
        .db %10111010
        .db %10110010
        .db %10101010
        .db %01000100
        .db %00111000
        .db %00000000
ATTACKINUMBER2:
        .db %10000000
        .db %11000000
        .db %01100000
        .db %00110000
        .db %00011000
        .db %00001100
        .db %00010000
        .db %00000000
ATTACKINUMBER3:
        .db %00000100
        .db %00001000
        .db %10011000
        .db %01100100
        .db %00111010
        .db %00001001
        .db %00010000
        .db %00100000
ATTACKINUMBER4:
        .db %00000010
        .db %10000100
        .db %01001000
        .db %00110100
        .db %00010110
        .db %00001001
        .db %00010000
        .db %00100000
ATTACKINUMBER5:
        .db %10000000
        .db %01000000
        .db %00101011
        .db %00010100
        .db %00110100
        .db %00101010
        .db %01000001
        .db %10000000
ATTACKINUMBER6:
        .db %00010000
        .db %00010000
        .db %00001000
        .db %10010110
        .db %01110101
        .db %00001001
        .db %00010000
        .db %00100000

ISIS1:
        .db     00110000b
        .db     01111000b
        .db     11011100b
        .db     00101110b
        .db     00011111b
        .db     00110011b
        .db     00011001b
        .db     00011110b
ISIS2:	
        .db     00100110b
        .db     00111011b
        .db     01010001b
        .db     11111111b
        .db     01110110b
        .db     00000000b
        .db     00000000b
        .db     00000000b
ISIS3:	
        .db     10000000b
        .db     10000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     10000000b
        .db     01000000b
        .db     00000000b
ISIS4:	
        .db     00100110b
        .db     00101011b
        .db     01000101b
        .db     11111111b
        .db     00000110b
        .db     00000000b
        .db     00000000b
        .db     00000000b
ISIS5:	
        .db     00100110b
        .db     00111011b
        .db     01010001b
        .db     11111111b
        .db     01110000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
ISIS6:	
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     01110110b
        .db     00000000b
        .db     00000000b
        .db     00000000b

ATTACKDNUMBER1:
        .db     10000010b
        .db     11000110b
        .db     01101100b
        .db     00111000b
        .db     00010000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
ATTACKDNUMBER2:
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00010000b
        .db     00111000b
        .db     01101100b
        .db     11000110b
        .db     10000010b
ATTACKDNUMBER3:
        .db %01111000
        .db %11111110
        .db %00011111
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
DARQATTACK:
   .db %11111100
   .db %01000011
   .db %00101110
   .db %00011111
   .db %00010011
   .db %00001010
   .db %00000101
   .db %00000011
DARQATTACK2:
  .db %10000000
  .db %10000000
  .db %10000000
  .db %10000000
  .db %00000000
  .db %10000000
  .db %00000000
  .db %10000000

DARQ1:
        .db     00111000b
        .db     00101100b
        .db     01001100b
        .db     00101000b
        .db     01100110b
        .db     11011011b
        .db     11101111b
        .db     10101011b
DARQ2:
        .db     11010111b
        .db     11111111b
        .db     11111011b
        .db     11111101b
        .db     11111101b
        .db     11101111b
        .db     11011111b
        .db     00000000b
DARQ3:
        .db     10000000b
        .db     10000000b
        .db     10000000b
        .db     10000000b
        .db     10000000b
        .db     10000000b
        .db     10000000b
        .db     10000000b

ENEMY1AREA1:
        .db     11100111b
        .db     10100101b
        .db     11100111b
        .db     00011000b
        .db     00011000b
        .db     11000011b
        .db     11111111b
        .db     01111110b
ENEMY2AREA1:
        .db %10011001
        .db %11011011
        .db %01100110
        .db %01111110
        .db %01111110
        .db %10011001
        .db %10011001
        .db %10011001
ENEMY4AREA1:
        .db %00001000
        .db %00011000
        .db %00100100
        .db %00100010
        .db %01010110
        .db %01010101
        .db %10001001
        .db %11111111
ENEMY5AREA1:
        .db %00100010
        .db %01010000
        .db %00100100
        .db %00001010
        .db %10000100
        .db %00100000
        .db %01010010
        .db %00100000
ENEMY3AREA1:
        .db     10000000b
        .db     01110011b
        .db     01011111b
        .db     01010101b
        .db     00101110b
        .db     00111011b
        .db     00101110b
        .db     01110101b
        .db     01011111b
        .db     10110101b
        .db     00111111b
        .db     01101010b
        .db     01111111b
        .db     01011010b
        .db     11010010b
        .db     10010010b
ENEMY3AREA1p2:
        .db     01010000b
        .db     10011000b
        .db     01001000b
        .db     01001100b
        .db     10000110b
        .db     10000110b
        .db     10001110b
        .db     11111100b
        .db     01110100b
        .db     11010000b
        .db     10100000b
        .db     11100000b
        .db     10110000b
        .db     10010000b
        .db     11011000b
        .db     01001000b
ENEMY6AREA1:
        .db     00001111b
        .db     00010000b
        .db     00010101b
        .db     00010101b
        .db     00010000b
        .db     00001011b
        .db     00000111b
        .db     11111010b
        .db     10101111b
        .db     11111010b
        .db     10101010b
        .db     10110101b
        .db     01110111b
        .db     00101010b
        .db     00010000b
        .db     00110000b
ENEMY6AREA1p2:
        .db     00000000b
        .db     10000000b
        .db     10000011b
        .db     10000101b
        .db     10001010b
        .db     00010110b
        .db     01101100b
        .db     01011100b
        .db     10110100b
        .db     11100000b
        .db     00010100b
        .db     00010000b
        .db     00001110b
        .db     10011111b
        .db     01011111b
        .db     01101110b
ENEMY1AREA2:
        .db %00110010
        .db %01101010
        .db %00110010
        .db %11010110
        .db %11101111
        .db %11011010
        .db %00010100
        .db %00100010
ENEMY2AREA2:
        .db %00111100
        .db %01001010
        .db %10100101
        .db %11001011
        .db %10001011
        .db %10100101
        .db %01010010
        .db %00111100
ENEMY3AREA2:
        .db %10001001
        .db %10010011
        .db %11011011
        .db %11110011
        .db %11101111
        .db %01110110
        .db %00111100
        .db %01011010
ENEMY4AREA2:
        .db %01011110
        .db %11001111
        .db %11100101
        .db %11011000
        .db %00011011
        .db %10100111
        .db %11110011
        .db %01111010
ENEMY1AREA3:
        .db %01011110
        .db %10111011
        .db %11010101
        .db %01110111
        .db %10101101
        .db %11011010
        .db %10101101
        .db %01110110
ENEMY2AREA3:
        .db %01111110
        .db %11011101
        .db %10111011
        .db %11011101
        .db %11111111
        .db %01111110
        .db %01000010
        .db %00111100
ENEMY3AREA3:
        .db %01010101
        .db %10101010
        .db %01111101
        .db %00101110
        .db %00111011
        .db %01101110
        .db %11111000
        .db %11100000
ENEMY4AREA3:
        .db %10111101
        .db %11111111
        .db %01111110
        .db %11111111
        .db %00111100
        .db %01100110
        .db %10011001
        .db %10100101
ENEMY1AREA4:
        .db %11000011
        .db %10100101
        .db %01100110
        .db %00000000
        .db %10111101
        .db %01100110
        .db %01100110
        .db %00111100
ENEMY2AREA4:
        .db %00100000
        .db %01100010
        .db %01010101
        .db %11110010
        .db %11111100
        .db %11111000
        .db %11110000
        .db %11111000
ENEMY3AREA4:
        .db %00011111
        .db %00101010
        .db %01001110
        .db %10011011
        .db %11110101
        .db %10010011
        .db %01011110
        .db %01100100
        .db %00100101
        .db %00101111
        .db %01010110
        .db %01010000
        .db %01001110
        .db %00100111
        .db %01111001
        .db %10001111
ENEMY3AREA4p2:
        .db %11111000
        .db %10101100
        .db %00111010
        .db %01101101
        .db %01010111
        .db %01101101
        .db %00111010
        .db %00010010
        .db %11110100
        .db %01011010
        .db %00001010
        .db %01101010
        .db %01110110
        .db %10000010
        .db %00111110
        .db %11100001
ENEMY4AREA4:
        .db %00000010
        .db %00001001
        .db %00100011
        .db %00000101
        .db %01001100
        .db %00011001
        .db %10100010
        .db %01111011
        .db %10100010
        .db %00011001
        .db %01001100
        .db %00010101
        .db %00100011
        .db %00001001
        .db %00000010
        .db %00000000
ENEMY4AREA4p2:
        .db %10000000
        .db %00100000
        .db %10001000
        .db %01010000
        .db %01100100
        .db %00110000
        .db %10001010
        .db %10111100
        .db %10001010
        .db %00110000
        .db %01100100
        .db %01010000
        .db %10001000
        .db %00100000
        .db %10000000
        .db %00000000
ENEMY1AREA5:
        .db %01100100
        .db %11011010
        .db %10110101
        .db %01101010
        .db %01010110
        .db %10101101
        .db %01011011
        .db %00100110
ENEMY2AREA5:
        .db %01000010
        .db %00111100
        .db %00100100
        .db %11011010
        .db %01010011
        .db %00100100
        .db %01011010
        .db %01010010
ERASURE:
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     01111111b
        .db     01111111b
CURSOR:
        .db     00010000b
        .db     00110000b
        .db     01111111b
        .db     11111111b
        .db     01111111b
        .db     00110000b
        .db     00010000b
        .db     00000000b
CURSOR2:
        .db     00001000b
        .db     00001100b
        .db     11111110b
        .db     11111111b
        .db     11111110b
        .db     00001100b
        .db     00001000b
        .db     00000000b
CURSORDN:
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00111110b
        .db     00011100b
        .db     00001000b

SHIELD1:
	.db     01111111b
        .db     01010101b
        .db     01101010b
        .db     01010101b
        .db     01101010b
        .db     01010101b
        .db     01111111b 
        .db     01111111b
SHIELD2:
	.db     11111111b
        .db     01011101b
        .db     10111110b
        .db     01011101b
        .db     10111110b
        .db     01011101b
        .db     11111111b
        .db     11111111b
SHIELD3: 
	.db     11111111b
        .db     01010101b
        .db     10101011b
        .db     01010101b
        .db     10101011b 
        .db     01010101b
        .db     11111111b
        .db     11111111b
SHIELD4:
	.db     01111111b
        .db     01010101b
        .db     01101010b
        .db     01010101b
        .db     01101010b
        .db     01010101b
        .db     01101010b
        .db     01010101b
SHIELD5:
	.db     11111111b
        .db     01011101b
        .db     10111110b 
        .db     01011101b
        .db     10111110b
        .db     01011101b
        .db     10111110b
        .db     01011101b
SHIELD6:
	.db     11111111b
        .db     01010101b
        .db     10101011b
        .db     01010101b
        .db     10101011b
        .db     01010101b
        .db     10101011b
        .db     01010101b
SHIELD7:
	.db     01101010b 
        .db     01010101b
        .db     01101010b
        .db     01010101b
        .db     01101010b
        .db     01010101b
        .db     01101010b
        .db     00110101b
SHIELD8:
	.db     10111110b
        .db     01011101b
        .db     10111110b
        .db     01011101b
        .db     10111110b
        .db     01011101b
        .db     10111110b
        .db     01011101b
SHIELD9:
	.db     10101011b
        .db     01010101b
        .db     10101011b
        .db     01010101b
        .db     10101011b
        .db     01010101b
        .db     10101011b
        .db     01010110b
SHIELD10:
	.db     00011010b
        .db     00001101b
        .db     00000110b
        .db     00000011b
        .db     00000001b
        .db     00000000b
        .db     00000000b
        .db     00000000b
SHIELD11:
	.db     10111110b
        .db     01011101b
        .db     10111110b
        .db     01011101b
        .db     10111110b
        .db     11011101b
        .db     01111111b
        .db     00111110b
SHIELD12:
	.db     10101100b
        .db     01011000b
        .db     10110000b 
        .db     01100000b
        .db     11000000b
        .db     10000000b
        .db     00000000b
        .db     00000000b
SHIELD13:
	.db     00011100b
        .db     00001000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
ICONRING:
        .db     11111111b
        .db     10000001b
        .db     10000001b
        .db     10000001b
        .db     10000001b
        .db     10000001b
        .db     10000001b
        .db     11111111b
TOWNPIC:
        .db     %00111000
        .db     %01100100
        .db     %10011110
        .db     %10111111
        .db     %11010001
        .db     %01110111
        .db     %00110111
        .db     %11111111
SAND:
        .db     %11111111
        .db     %01001000
        .db     %00010010
        .db     %10000100
        .db     %01010001
        .db     %10101000
        .db     %00000010
        .db     %01001000
MOUNTAIN:
        .db     %00100010
        .db     %01110101
        .db     %11011000
        .db     %10010100
        .db     %11001010
        .db     %00101001
        .db     %01010111
        .db     %11010011
CLOUD:
        .db     %00000000
        .db     %00101110
        .db     %01010001
        .db     %10000010
        .db     %01000001
        .db     %11000011
        .db     %00111100
        .db     %00000000
SPACESHIP1:
        .db     00000000b
        .db     00000011b
        .db     00011110b
        .db     01111001b
        .db     01100100b
        .db     10100001b
        .db     00011110b
        .db     00010010b
        .db     01000001b
        .db     11111110b
        .db     10010111b
        .db     11111010b
        .db     00101101b
        .db     00010010b
        .db     11110001b
        .db     11111111b
        .db     00001011b
        .db     00010000b
        .db     00010000b
SPACESHIP2:
        .db     11110000b
        .db     10111110b
        .db     01000111b
        .db     01100001b
        .db     11011101b
        .db     01000100b
        .db     01000111b
        .db     00001000b
        .db     11111111b
        .db     01010011b
        .db     11111100b
        .db     10011010b
        .db     01100101b
        .db     01010010b
        .db     00101010b
        .db     11100011b
        .db     11111111b
        .db     10001110b
        .db     01110001b
SPACESHIP3:
        .db     00000000b
        .db     00000000b
        .db     11000000b
        .db     11110000b
        .db     00111100b
        .db     00001111b
        .db     10100001b
        .db     10011111b
        .db     11101011b
        .db     10111100b
        .db     10010010b
        .db     11011011b
        .db     10101111b
        .db     01111111b
        .db     11110110b
        .db     10001010b
        .db     00001010b
        .db     00010100b
        .db     10100101b
SPACESHIP4:
        .db     10000000b
        .db     11100000b
        .db     11111000b
        .db     00111100b
        .db     11110000b
        .db     11000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     00000000b
        .db     11000000b
        .db     00100000b

LEADER1p1:
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000001
        .db %00000110
        .db %00001001
        .db %00001001
        .db %00010010
        .db %00100000
        .db %00100100
        .db %01011000
        .db %01000010
        .db %01000010
        .db %10001100
        .db %10010000
        .db %10000010
        .db %10100001
        .db %11011100
        .db %10001000
        .db %10010000
        .db %01000100
        .db %01001010
        .db %01001010
        .db %00100000
        .db %01110000
        .db %01110010
        .db %11001000
        .db %01001000
        .db %01100110
        .db %10101001
        .db %00101000
        .db %01001100
        .db %10000010

LEADER1p2:
        .db %00000111
        .db %00111000
        .db %11000000
        .db %00000000
        .db %00000100
        .db %00000100
        .db %01000010
        .db %10100001
        .db %00000010
        .db %10001000
        .db %00010000
        .db %10110010
        .db %01000001
        .db %00000000
        .db %00100011
        .db %01010000
        .db %10001010
        .db %00000001
        .db %00010010
        .db %01100100
        .db %10000011
        .db %10000110
        .db %00001000
        .db %10000000
        .db %01011000
        .db %00000100
        .db %11000010
        .db %01001100
        .db %10001010
        .db %00001100
        .db %11010000
        .db %00111000
        .db %00000111

LEADER1p3:
        .db %11111000
        .db %00000111
        .db %00000000
        .db %10100000
        .db %00011010
        .db %00000101
        .db %00000001
        .db %00000000
        .db %10001011
        .db %00010101
        .db %00010000
        .db %01100001
        .db %10000010
        .db %10100010
        .db %00011100
        .db %00001000
        .db %00110010
        .db %10000101
        .db %00001000
        .db %01101000
        .db %00010000
        .db %00000001
        .db %00101110
        .db %11010100
        .db %00001000
        .db %00010001
        .db %01100010
        .db %00000000
        .db %01000001
        .db %00010000
        .db %00101000
        .db %00000111
        .db %11111000
        
LEADER1p4:
        .db %00000000
        .db %00000000
        .db %11000000
        .db %00100000
        .db %00011000
        .db %01100100
        .db %01000100
        .db %10001110
        .db %00011001
        .db %10110100
        .db %00100101
        .db %01100011
        .db %01001011
        .db %01010111
        .db %01000111
        .db %01000111
        .db %01010110
        .db %11100111
        .db %11000111
        .db %01110111
        .db %00110011
        .db %00101011
        .db %10010000
        .db %00001001
        .db %00001101
        .db %11000110
        .db %00100111
        .db %11000101
        .db %01011001
        .db %00100110
        .db %11001101
        .db %00011001
        .db %00010001

LEADER1p5:
        .db %10000000
        .db %10000000
        .db %10000000
        .db %11000000
        .db %11000000
        .db %01000000
        .db %01000000
        .db %11000000
        .db %11000000
        .db %11000000
        .db %11000000
        .db %10000000
        .db %10001100
        .db %10010000
        .db %00010000
        .db %00011000
        .db %00101000
        .db %01000010
        .db %10000100
        .db %00000110
        .db %11011000
        .db %10110100

LEADER2p1:
        .db %00000000
        .db %00000000
        .db %00000111
        .db %00001100
        .db %00010001
        .db %00110110
        .db %00101001
        .db %00101111
        .db %00101100
        .db %01101001
        .db %01011001
        .db %01010001
        .db %01011111
        .db %11001001
        .db %11001100
        .db %10010101
        .db %11010110
        .db %11011010
        .db %11001001
        .db %01100100
        .db %01100100
        .db %00111011
        .db %00000111
        .db %00000001
        .db %00000011
        .db %00001111
        .db %00011101
        .db %11110111
        .db %10001001
        .db %11101011
        .db %10111110
        .db %00100110
        .db %01010001
        .db %00101100
        .db %10100011
        .db %11010110
        .db %01111100
        .db %00000011
        .db %11110000
        .db %00111111
        .db %00000000
LEADER2p2:
        .db %00000011
        .db %01111111
        .db %11101000
        .db %00010001
        .db %11010110
        .db %11111100
        .db %10010010
        .db %00100101
        .db %11100100
        .db %01001011
        .db %01010100
        .db %01010100
        .db %01101011
        .db %11001000
        .db %01101000
        .db %00110000
        .db %10010000
        .db %01000000
        .db %00110000
        .db %10010000
        .db %11000000
        .db %00110000
        .db %10010000
        .db %11110000
        .db %11001000
        .db %10000100
        .db %10000011
        .db %10010000
        .db %00010000
        .db %00010000
        .db %00110000
        .db %00100000
        .db %11111000
        .db %00000110
        .db %10110001
        .db %11001111
        .db %01100010
        .db %00010001
        .db %11111111
        .db %10000001
        .db %00000000
LEADER2p3:
        .db %11111000
        .db %00101110
        .db %10000011
        .db %00111100
        .db %01010000
        .db %01100011
        .db %11001110
        .db %00011100
        .db %01100000
        .db %10000000
        .db %00000001
        .db %00000010
        .db %10000000
        .db %11000000
        .db %01100000
        .db %00111110
        .db %00011101
        .db %00001110
        .db %00001110
        .db %01000000
        .db %00100000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000001
        .db %11100000
        .db %00111000
        .db %00011111
        .db %00100000
        .db %01000000
        .db %10000000
        .db %10000000
        .db %10000000
        .db %10000000
        .db %11000001
        .db %01000110
        .db %01001100
        .db %01010000
        .db %11000000
LEADER2p4:
        .db %00111110
        .db %01000001
        .db %11011111
        .db %00101000
        .db %01011011
        .db %10001110
        .db %10010100
        .db %01100111
        .db %00000001
        .db %00000001
        .db %10110001
        .db %11101000
        .db %01000011
        .db %10100110
        .db %01000100
        .db %00011101
        .db %00110101
        .db %00011001
        .db %00011010
        .db %01000011
        .db %01000010
        .db %01100011
        .db %00110010
        .db %00100110
        .db %01000100
        .db %00001000
        .db %10010000
        .db %00100000
        .db %11000000
        .db %00000001
        .db %00000011
        .db %00000010
        .db %00001110
        .db %00011110
        .db %00110100
        .db %11001100
        .db %10001000
        .db %00001001
        .db %00001001
        .db %00001011
        .db %00011110
LEADER2p5:
        .db %10000000
        .db %01000000
        .db %11110000
        .db %10010000
        .db %00101110
        .db %10010010
        .db %11001010
        .db %01101001
        .db %10010101
        .db %01010011
        .db %10011001
        .db %11101010
        .db %01011110
        .db %10010000
        .db %10110000
        .db %10010000
        .db %01110000
        .db %01000000
        .db %10000000
        .db %01000100
        .db %10001110
        .db %00111010
        .db %00100110
        .db %01101100
        .db %01001000
        .db %10001000
        .db %10001100
        .db %10000011
        .db %10000001
        .db %10000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00011110
        .db %00110011
        .db %01000000
        .db %11000000
        .db %10000000
        .db %10000000
        .db %00000000
        .db %00000000
LEADER2p6:
        .db %11000001
        .db %01111111
        .db %00000001
        .db %01111111
        .db %10001100
        .db %01111000
        .db %11000000
        .db %00000000
LEADER2p7:
        .db %11000000
        .db %10000000
        .db %10000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
LEADER2p8:
        .db %00000011
        .db %00001110
        .db %00011011
        .db %00010110
        .db %00010011
        .db %00011101
        .db %00001011
        .db %00001110
        .db %00000100
        .db %00000011
        .db %00000011
LEADER3p1:
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %00000011
        .db %01111110
        .db %00110000
        .db %00011111
        .db %00001100
        .db %00000110
        .db %00000010
        .db %00000011
        .db %00000001
        .db %00000001
        .db %00000110
        .db %00011000
        .db %01101111
        .db %11110000
        .db %11000000
        .db %11111001
        .db %10010010
        .db %00100101
        .db %01100101
        .db %01011110
        .db %10110111
        .db %10100100
        .db %11000101
        .db %11000101
        .db %10001101
        .db %10011101
        .db %11110100
        .db %10110101
        .db %10100110
        .db %00100100
        .db %00111110
        .db %00010011
        .db %00000000
        .db %00000000
LEADER3p2:
        .db %00000000
        .db %00000000
        .db %00000011
        .db %00001101
        .db %00011001
        .db %01110111
        .db %11011101
        .db %00110011
        .db %11100110
        .db %10001100
        .db %00011011
        .db %00110110
        .db %01100101
        .db %10011010
        .db %01110100
        .db %11101011
        .db %00011110
        .db %00001100
        .db %10111010
        .db %01110011
        .db %10011000
        .db %01000101
        .db %01110111
        .db %00011001
        .db %10100010
        .db %00110011
        .db %00000000
        .db %00100100
        .db %00110110
        .db %10000001
        .db %00100001
        .db %10110100
        .db %00011100
        .db %00100100
        .db %10110110
        .db %11000011
        .db %00101100
        .db %00110101
        .db %11000010
        .db %00111111
LEADER3p3:
        .db %00000001
        .db %00001110
        .db %00000010
        .db %00000010
        .db %00001110
        .db %00111001
        .db %01100010
        .db %11111110
        .db %10000111
        .db %10000010
        .db %11000100
        .db %11011110
        .db %01100100
        .db %01001001
        .db %01111110
        .db %11000001
        .db %10010001
        .db %11011100
        .db %01000110
        .db %01101000
        .db %00001100
        .db %00000010
        .db %10111011
        .db %10001100
        .db %11100100
        .db %00110101
        .db %10000010
        .db %11010010
        .db %00011010
        .db %00000010
        .db %10100011
        .db %10110011
        .db %11001010
        .db %00010011
        .db %10011001
        .db %11111110
        .db %00001011
        .db %01010101
        .db %10000010
        .db %11111111
LEADER3p4:
        .db %11111000
        .db %00001100
        .db %00000111
        .db %11110100
        .db %10011000
        .db %01100000
        .db %00000000
        .db %11100100
        .db %10110110
        .db %00111000
        .db %00100101
        .db %01100110
        .db %10000000
        .db %01001001
        .db %01101101
        .db %00010000
        .db %10011001
        .db %00000111
        .db %01001000
        .db %01101000
        .db %00111000
        .db %10001100
        .db %01001100
        .db %00010101
        .db %11101101
        .db %00100110
        .db %00010001
        .db %00011010
        .db %00110100
        .db %01000011
        .db %11000000
        .db %00000000
        .db %00000000
        .db %00000000
        .db %11000000
        .db %01100000
        .db %11111111
        .db %01001000
        .db %00100110
        .db %11111111
LEADER3p5:
        .db %00000000
        .db %00000000
        .db %11100000
        .db %00111000
        .db %00001100
        .db %01110110
        .db %00011011
        .db %00010001
        .db %00000000
        .db %00000000
        .db %10000001
        .db %11011100
        .db %00110111
        .db %00100000
        .db %11000000
        .db %10000000
        .db %00000000
        .db %00000000
        .db %10000000
        .db %10000111
        .db %10000101
        .db %10001100
        .db %10001011
        .db %00010010
        .db %00110100
        .db %01001000
        .db %10010001
        .db %10100001
        .db %01100010
        .db %11000010
        .db %10000101
        .db %00000111
        .db %00001101
        .db %00001011
        .db %00110101
        .db %11010011
        .db %00100110
        .db %10011100
        .db %01110000
        .db %10000000
LEADER3p6:
        .db %11100000
        .db %01010000
        .db %00010000
        .db %11110000
        .db %01100000
        .db %10110000
        .db %00001000
        .db %00000100
        .db %00000011
        .db %00000001
        .db %00000000
        .db %00000000
        .db %10000000
        .db %00000000
        .db %11000000
        .db %10000000
        .db %00000000
        .db %00000000
        .db %01111100
        .db %10001010
        .db %00100100
        .db %01011000
        .db %11100000
        .db %10000000
VINE:
        .db %00011000
        .db %00110000
        .db %01100000
        .db %00110000
        .db %00011000
        .db %00001100
        .db %00011000
        .db %00110000
TITLE1:
        .db %11111111
        .db %01100101
        .db %01110001
        .db %01100001
        .db %01100001
        .db %11110011
        .db %00000000
        .db %00000000
TITLE2:
        .db %11111110
        .db %10010110
        .db %11000011
        .db %10000011
        .db %10000110
        .db %11001110
        .db %00000000
        .db %00000000
TITLE3:
        .db %11100110
        .db %11001110
        .db %10001110
        .db %10011010
        .db %11011111
        .db %11100110
        .db %00000000
        .db %00000000
PIC1:
        .db %11111111
        .db %10010000
        .db %11010111
        .db %11001100
        .db %10010010
        .db %10110101
        .db %11000000
        .db %11110011
        .db %11001010
        .db %10100101
        .db %11010011
        .db %11101011
        .db %10010101
        .db %11101111
        .db %10011111
        .db %11111111
PIC1p2:
        .db %11111111
        .db %00011011
        .db %10011101
        .db %11001111
        .db %01000111
        .db %01010001
        .db %11010011
        .db %01000011
        .db %10001001
        .db %00101001
        .db %00100001
        .db %11000011
        .db %01101011
        .db %10101001
        .db %11100001
        .db %11111111
PIC2:
        .db %11111111
        .db %10000000
        .db %10101000
        .db %10010000
        .db %10000000
        .db %11010100
        .db %10100010
        .db %10000001
        .db %10000000
        .db %10011000
        .db %10100100
        .db %11000011
        .db %10010100
        .db %10101001
        .db %10000010
        .db %11111111
PIC2p2:
        .db %11111111
        .db %00011001
        .db %00110101
        .db %00111101
        .db %00011001
        .db %01000001
        .db %10000001
        .db %00001001
        .db %00010101
        .db %01101011
        .db %10010011
        .db %00001001
        .db %10100101
        .db %00010011
        .db %01000101
        .db %11111111
HANDp1:
        .db %11111111
        .db %11111111
        .db %11111111
        .db %11111111
        .db %11111110
        .db %11111110
        .db %11111100
        .db %11111111
HANDp2:
        .db %00000001
        .db %00001110
        .db %00110000
        .db %11000100
        .db %00000010
        .db %00010110
        .db %00101100
        .db %00010110
        .db %11000010
        .db %00110100
        .db %00001111
HANDp3:
        .db %11110000
        .db %01001000
        .db %00011110
        .db %01000001
        .db %00110110
        .db %00000001
        .db %00110110
        .db %00000001
        .db %00110110
        .db %01111100
        .db %11100000
CRYSTAL:
        .db %00010000
        .db %00111000
        .db %01101100
        .db %01000100
        .db %10110010
        .db %11101110
        .db %10100110
        .db %11000110
        .db %10110010
        .db %11000110
        .db %11010010
        .db %10011010
        .db %10100010
        .db %11001110
        .db %01100100
        .db %01010100
        .db %00101000
        .db %00010000
PORTAL:
        .db %11111111
        .db %01111110
        .db %00101100
        .db %01110110
        .db %01101110
        .db %01110110
        .db %11111011
        .db %11111111
TOWER:
        .db %00011110
        .db %00011010
        .db %00010110
        .db %00011010
        .db %00010110
        .db %00010010
        .db %01101001
        .db %11010001
DRAKES:
        .db %01100000
        .db %11011000
        .db %10110110
        .db %10110001
        .db %10001111
        .db %10010101
        .db %10010000
        .db %01001000
        .db %01000100
        .db %01101010
        .db %00110001
        .db %00001011
        .db %00001001
        .db %00011011
        .db %00110010
        .db %01000100
        .db %01101010
        .db %00110001
        .db %00001011
        .db %00001001
        .db %00010111
        .db %00100110
        .db %01010100
        .db %01001100
        .db %01100010
        .db %00110101
        .db %00001011
        .db %00001001
        .db %00010011
        .db %00101010
        .db %00101100
        .db %00010100
        .db %10011010
        .db %11011001
        .db %10101111
        .db %10011001
        .db %01101110
        .db %00100100
        .db %00011100
ENDISISp1:
        .db %00000001
        .db %00000001
        .db %00000001
        .db %00000010
        .db %00011110
        .db %00100100
        .db %01000101
        .db %01001100
        .db %01001001
        .db %10011100

ENDISISp2
       .db %00000001
       .db %00000010
       .db %00000100
       .db %00001000
       .db %00010000
       .db %00110000
       .db %01000000
       .db %01000100
       .db %01000100
       .db %01000100
       .db %01000100
       .db %01000100
       .db %01001000
       .db %01010001
       .db %10010001
       .db %10000001
       .db %10100010
       .db %10000100
       .db %10000000
       .db %10000000
       .db %00100010
       .db %00000100
       .db %01000101
       .db %01000000
       .db %10010010
       .db %00100010
       .db %00000001
       .db %00010011
       .db %00100000
       .db %00001100
ENDISISp3:
       .db %11111111
       .db %00000000
       .db %00100000
       .db %00000011
       .db %00001000
       .db %10000010
       .db %10010001
       .db %10000001
       .db %01000001
       .db %00010000
       .db %10010000
       .db %10000001
       .db %00010001
       .db %00100000
       .db %00001100
       .db %00100000
       .db %00100000
       .db %01000000
       .db %01000001
       .db %01000110
       .db %10001001
       .db %00001001
       .db %00010000
       .db %00100001
       .db %00100001
       .db %11000010
       .db %00100110
       .db %00001111
       .db %10001101
       .db %00001101
ENDISISp4:
       .db %00000000
       .db %10000000
       .db %01000000
       .db %01100000
       .db %00010000
       .db %00001000
       .db %00001000
       .db %00011000
       .db %10101000
       .db %10001000
       .db %01010000
       .db %00010000
       .db %00110000
       .db %00100000
       .db %01000000
       .db %01000000
       .db %01000000
       .db %11000000
       .db %01000000
       .db %10000000
       .db %10000000
       .db %11000000
       .db %11000000
       .db %00100000
       .db %00111000
       .db %00010000
       .db %01010000
       .db %01001000
       .db %01100000
       .db %11011000
ENDISISp5:
       .db %00000000
       .db %00000000
       .db %11111100
       .db %10001110
       .db %10011010
       .db %00001101
       .db %11100001
       .db %00011001
RUINOFWORLDp1:
       .db %00000000
       .db %00000000
       .db %00000000
       .db %00000001
       .db %00000011
       .db %00000010
       .db %00000110
       .db %00001100
       .db %00110011
       .db %00100111
       .db %01100010
       .db %11111111
RUINOFWORLDp2:
       .db %00111111
       .db %11000011
       .db %10010110
       .db %10000100
       .db %01001111
       .db %00110000
       .db %01111000
       .db %11110010
       .db %10100010
       .db %00101000
       .db %00101000
       .db %11111111
RUINOFWORLDp3:
       .db %00010010
       .db %00101101
       .db %00100100
       .db %11110100
       .db %00010110
       .db %00110100
       .db %01111100
       .db %10110101
       .db %00100100
       .db %01100110
       .db %01000001
       .db %11111111
RUINOFWORLDp4:
       .db %00000000
       .db %11000000
       .db %00100000
       .db %00100000
       .db %10100000
       .db %00100000
       .db %00100000
       .db %00100111
       .db %00111100
       .db %00110101
       .db %00101100
       .db %11111111
RUINOFWORLDp5:
       .db %00000000
       .db %00000000
       .db %00000000
       .db %00000000
       .db %00000000
       .db %00000000
       .db %00000000
       .db %10001100
       .db %10111010
       .db %11100001
       .db %01100101
       .db %11111111


.end
